CREATE OR REPLACE FUNCTION SPED_BLOCOC(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_LIVROMAG     IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_PERFIL       IN NOTAFISCAL.IDSTATUS%TYPE,
   P_VERSAO       IN VARCHAR2,
   P_IDDIFALIQ    IN VARCHAR2,
   P_TOTALIZA     IN NUMBER,
   P_GERAFORSALE  IN VARCHAR2 DEFAULT 'N') RETURN VARCHAR  
AS
   V_CONTREGC        NUMBER;
   V_SEQADIC         NUMBER;
   V_MOVIMENT        NUMBER;
   V_TOTFORPER_S     NUMBER;
   V_TOTFORPER_E     NUMBER;
   V_VRFORAPER       NUMBER;
   V_VRFORAPER_E     NUMBER;
   V_SEQUPROD        NUMBER;
   V_SEQUENCIAL      VARCHAR2(100);
   V_IDFRETE         VARCHAR2(01);
   V_IDSEGUR         VARCHAR2(01);
   V_IDOUTROS        VARCHAR2(01);
   V_IDDESCONTO      VARCHAR2(01);
   V_PIS             VARCHAR2(02);
   V_COFINS          VARCHAR2(02);
   V_IPI             VARCHAR2(02);
   V_CDIMPOSTRIB     VARCHAR2(02);
   V_DTPERIODO       VARCHAR2(01);
   V_DADOS_2         VARCHAR2(10);
   V_IDSTATUS        VARCHAR2(01);
   V_ICMS            VARCHAR2(02);
   TIPOOPER_COMPL_S  VARCHAR(02);
   TIPOOPER_COMPL_E  VARCHAR(02);
   V_DTEMISSAO       DATE;
   V_DTENTRSAID      DATE;
   V_NRSEQUMAPAPU    VARCHAR2(10);
   V_COD_NAT         VARCHAR2(100);
   V_COD_PAR         VARCHAR2(100);
   V_UNID            VARCHAR2(100);
   V_PRODUTO         VARCHAR2(100);
   V_VRDEBESP        NUMBER;
   V_LINHA           VARCHAR2(255);
   V_NR_TOT          VARCHAR2(02);
   V_DESCR_NR_TOT    VARCHAR2(255);
   V_REG_C197        VARCHAR2(1000);
   V_COD_OBS         VARCHAR2(1000);
   V_SGESTADO        VARCHAR2(02);
   V_CDAJUSTEC195    VARCHAR2(10);
   V_IDGERREGC197    VARCHAR2(10);
   V_CDSITUCRT       VARCHAR2(01);
   V_VENDABRUTA      FLOAT;
   V_VENDACANC       FLOAT;
   V_IDDIFEALIQUOTA  VARCHAR2(02);
   V_CFOPC195        VARCHAR2(01);
   V_IDANTICMSARROZ  VARCHAR2(01);
   V_CDTPOPANTARROZ  VARCHAR2(03);
   V_CDAJUSTEXTEMP   VARCHAR2(10);
   V_IDTPCARGATRIB   VARCHAR2(01);
   V_CODC195         VARCHAR2(06);
   V_TXTC195         VARCHAR2(500);
   V_CDFORNECED      VARCHAR2(20);
   V_GERAC113        VARCHAR2(01);
   V_C195            VARCHAR2(06);
   V_NRSEQITEM       NUMBER;
   V_IDATUESTTPOP    VARCHAR2(01);
   V_CONTCTBL        VARCHAR2(100);
   V_UNIDADE         VARCHAR2(100);
BEGIN
   V_SEQUPROD := NVL(P_TOTALIZA,0);

   /*Busca o tipo de operao de complemento */
   BEGIN
      SELECT MAX(TIPOOPER_S), MAX(TIPOOPER_E)
        INTO TIPOOPER_COMPL_S, TIPOOPER_COMPL_E
        FROM (SELECT DECODE(IDENTRSAIDOP,'S',CDTIPOOPER,NULL) AS TIPOOPER_S,
                     DECODE(IDENTRSAIDOP,'E',CDTIPOOPER,NULL) AS TIPOOPER_E
                FROM TIPOOPERAC
               WHERE UPPER(NMTIPOOPER) LIKE '%NF COMPLEMENTO%'
                 AND CDTIPOOPER <> '03');
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         TIPOOPER_COMPL_S := NULL;
         TIPOOPER_COMPL_E := NULL;
   END;

   BEGIN
      SELECT MAX(EN.IDENCARGO)
        INTO V_IDFRETE
        FROM ENCARGO EN
       WHERE EN.CDENCARGONFE = '01';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
           V_IDFRETE     := NULL;
   END;

   BEGIN
      SELECT MAX(EN.IDENCARGO)
        INTO V_IDSEGUR
        FROM ENCARGO EN
       WHERE EN.CDENCARGONFE = '02';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
           V_IDSEGUR     := NULL;
   END;

   BEGIN
      SELECT MAX(EN.IDENCARGO)
        INTO V_IDDESCONTO
        FROM ENCARGO EN
       WHERE EN.CDENCARGONFE = '03';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
           V_IDDESCONTO  := NULL;
   END;

   BEGIN
      SELECT MAX(EN.IDENCARGO)
        INTO V_IDOUTROS
        FROM ENCARGO EN
       WHERE EN.CDENCARGONFE = '04';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
           V_IDOUTROS    := NULL;
   END;

   V_IPI         := '10';
   V_PIS         := '50';
   V_COFINS      := '60';
   V_CDIMPOSTRIB := '80';

   /*VERIFICA SE A EMPRESA  DO SIMPLES NACIONAL, '3' NAO  DO SIMPLES, APENAS 1 E 2*/
   SELECT NVL(MAX(CDSITUCRT), '3') CDSITUCRT
     INTO V_CDSITUCRT
     FROM PARAMEMPRESA
    WHERE CDEMPRESA = P_CDEMPRESA;

   IF V_CDSITUCRT IN ('2','3') THEN
      BEGIN
         SELECT NRSEQUMAPAPU
           INTO V_NRSEQUMAPAPU
           FROM MAPAAPURAC M
          WHERE M.CDEMPRESA    = P_CDEMPRESA
            AND M.CDINSCESTA   = P_CDINSCESTA
            AND M.CDIMPOSTO    = P_CDIMPOSTO
            AND M.DTINIPERIODO = P_DTINICIAL
            AND M.DTFIMPERIODO = P_DTFINAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NRSEQUMAPAPU := NULL;
      END;
   END IF;

   IF V_CDSITUCRT = '1' THEN
      BEGIN
         SELECT NRSEQUMAPAPU
           INTO V_NRSEQUMAPAPU
           FROM MAPAAPURACSN M
          WHERE M.CDEMPRESA    = P_CDEMPRESA
            AND M.DTINIPERIODO = P_DTINICIAL
            AND M.DTFIMPERIODO = P_DTFINAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NRSEQUMAPAPU := NULL;
      END;
   END IF;

   /*ESTADO DA IE*/
   SELECT MAX(SGESTADO)
     INTO V_SGESTADO
     FROM INSCRESTAD
    WHERE CDEMPRESA  = P_CDEMPRESA
      AND CDINSCESTA = P_CDINSCESTA;

   V_IDTPCARGATRIB := 'N';

   /*VERIFICA SE EXISTE CARGA TRIBUTRIA GERADA COMO OUTROS DBITOS/CRDITOS,
     CASO CONTRRIO CONSIDERA COMO SE FOSSE DBITO/CRDITO NORMAL*/
   BEGIN
      SELECT MAX('O') AS IDTPCARGATRIB
        INTO V_IDTPCARGATRIB
        FROM ITMAPARECUP
       WHERE NRSEQUMAPAPU = V_NRSEQUMAPAPU
         AND IDTIPOITMAPR IN ('OC','OD')
         AND IDCARGATRIBUTARIA = 'S';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDTPCARGATRIB := 'N';
   END;

   V_SEQADIC := 000001; --Cdigo da informao complementar, registro C110.

   IF V_CDSITUCRT IN ('2','3') THEN
      FOR C_REGC100 IN(SELECT ('|C100'                                                             || '|' ||
                              NF.CAMPO2                                                            || '|' ||
                              (CASE WHEN ((NF.CDSERIEENTR BETWEEN '890' AND '899') AND (NF.CDMODDOCFISC = '55')) THEN '1' ELSE NF.CAMPO3 END) || '|' ||
                              DECODE(NF.IDSTATUSNFE,'D','',DECODE(NF.IDSTATUS,'C','',REPLACE(REPLACE(REPLACE(REPLACE(NF.IDORIGDESTNF||DECODE(NF.IDORIGDESTNF, 'F', NF.CDFORNECED, DECODE(NF.IDORIGDESTNF, 'C', NF.CDCLIENTE , DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIEMIT, NF.CDFILIRECE))),'.'),'-'),'/'),' '))) || '|' ||
                              NF.CDMODDOCFISC                                                      || '|' ||
                              DECODE(NF.IDSTATUSNFE, 'D', '04', DECODE(NF.IDSTATUSNFE, 'I', '05',DECODE(IDSTATUS,'C','02',DECODE(NF.IDREGESPECIAL,'S','08', DECODE(NF.IDENTRSAIDOP,'S', (CASE WHEN DTEMISSAO < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_S,'07','01') ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_S,'06','00') END),(CASE WHEN ((NF.CDSERIEENTR BETWEEN '890' AND '899') AND (NF.CDMODDOCFISC = '55')) THEN '08'ELSE (CASE WHEN DTENTRSAID < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_E,'07','01')ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_E,'06','00') END) END))))))||'|'||
                              CASE WHEN LENGTH(NF.NRACESSONFE) = '44' THEN SUBSTR(NRACESSONFE,23,3) ELSE REPLACE(REPLACE(DECODE(NF.IDENTRSAIDOP, 'E', NF.CDSERIEENTR, NF.CDSERIE),'-',''),'.','') END  || '|' ||
                              DECODE(NF.IDENTRSAIDOP,'E',LTRIM(NF.NRNOTAFISC,'0'), DECODE(NF.NRACESSONFE, '', LTRIM(REPLACE(LTRIM(NF.NRNOTAFISC, '0'),' ')),DECODE(NF.IDSTATUS,'C',LTRIM(NF.NRNOTAFISC,'0'),LTRIM(NF.NRNOTAFISCALELE, '0')) )  )|| '|' ||
                              DECODE(NF.CDMODDOCFISC,'04','',NRACESSONFE)                               || '|' ||  --chave da nota fiscal eletronica
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',TO_CHAR(NF.DTEMISSAO,'ddmmyyyy'))) )      || '|' ) AS DADOS_1,
                              (REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF,2), '999999999990.00')), '.', ',') || '|' ||
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',DECODE(NVL(NF.QTDEPARC,0),0,'2',1,'0','1'))))    || '|' || -- campo 13
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',REPLACE(LTRIM(TO_CHAR((SELECT SUM(ROUND(NVL(VRENCARGODESC,0),2)) FROM ITEMPRODUTO WHERE CDFILIAL = NF.CDFILIAL AND NRLANCTONF = NF.NRLANCTONF AND NRSEQITPROD IS NOT NULL), '999999999990.00')), '.', ',')))) || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','', NVL(NF.VRIMPDESONERADO,0)))),2), '999999999990.00')), '.', ',') || '|' ||  -- abatimento no tributado e nao comercial desconto ICMS
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRPRODUTOS,2)+NVL((SELECT SUM(ROUND(NVL(VRDESCITEM,0),2) + ROUND(NVL(VRENCARGOIMPXML,0),2)) FROM ITEMPRODUTO WHERE CDFILIAL = NF.CDFILIAL AND NRLANCTONF = NF.NRLANCTONF AND NRSEQITPROD IS NOT NULL),0), '999999999990.00')), '.', ',')))) || '|' ||
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',RPAD(NVL(NF.IDPGTOFRETE, '9'), 1, ' '))))                                       || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDFRETE,  '01')))),2), '999999999990.00')), '.', ',') || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDSEGUR,  '02')))),2), '999999999990.00')), '.', ',') || '|' ||
                              /*REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUS, 'C', '', ABS(VALOR_IMPOSTO_NF(NF.CDFILIAL, NF.NRLANCTONF,V_CDIMPOSTRIB, 'I','1')) + ABS(VALOR_IMPOSTO_NF(NF.CDFILIAL, NF.NRLANCTONF, V_IPI, 'I','1'))),2), '999999999990.00')), '.', ',')  || '|' || --campo20*/
                              /*REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDOUTROS, '04')))),2), '999999999990.00')), '.', ',') || '|' || -- Campo 20*/
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',REPLACE(LTRIM(TO_CHAR(ROUND((SELECT NVL(SUM(I.VRITEMENCA),0)
                                                                                                                                                       FROM ITEMENCARGO I, ENCARGO E
                                                                                                                                                      WHERE I.CDFILIAL     = NF.CDFILIAL
                                                                                                                                                        AND I.NRLANCTONF   = NF.NRLANCTONF
                                                                                                                                                        AND E.CDENCARGO    = I.CDENCARGO
                                                                                                                                                        AND E.IDENCARGO    = 'A'
                                                                                                                                                        AND E.CDENCARGONFE = '04'
                                                                                                                                                        AND I.CDENCARGO NOT IN (SELECT CDENCARGOIMPXML
                                                                                                                                                                                  FROM IMPOSTO I
                                                                                                                                                                                 WHERE CDIMPOSTONFE IN ('80','10'))),2), '999999999990.00')), '.', ',')))) || '|' || -- Campo 20 outras obrigaes acessrias
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',NF.VRBASECALCNF))),2), '999999999990.00')), '.', ',') || '|' || -- campo 21
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',NF.VRIMPOSTONF))),2), '999999999990.00')), '.', ',') || '|' || -- campo 22
                              REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS,'C','', DECODE(NF.IDSTATUSNFE,'I','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','B','1')))), '999999999990.00')), '.', ',') || '|' || -- base de calc susbt. trib
                              REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS,'C','', DECODE(NF.IDSTATUSNFE,'I','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','I','1') + VALOR_FECP_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','I','1')))), '999999999990.00')), '.', ',') || '|' || -- valor do icms retido susbt. trib
                              REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS,'C','', DECODE(NF.IDSTATUSNFE,'I','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'10','I','1')))), '999999999990.00')), '.', ',') || '|' || -- valor do IPI
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF, '50', 'I','1')))),2), '999999999990.00')), '.', ',') || '|' || -- valor do PIS
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF, '60', 'I','1')))),2), '999999999990.00')), '.', ',') || '|' || -- valor do COFINS
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','','0,00'))) || '|' || -- pis retido por subst. trib.
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','','0,00'))) || '|'  ) AS DADOS_3,
                              NF.CDFILIAL AS CDFILIAL, NF.NRLANCTONF AS NRLANCTONF, '' AS CDCAIXA, NF.NRINSJURTRAN, NF.IDTPIJURTRAN, NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU,
                              NF.NRPLACAVEIC, NF.DSQTDEVOLU, NF.DSESPECVOLU, NF.DSMARCAVOLU, NF.DSNUMEVOLU, NF.CDFISCOPERNF, NF.NRNOTAFISC AS NRNOTAFISC,
                              NF.DTEMISSAO, NF.DTENTRSAID, NF.IDENTRSAIDOP, NF.VRIMPOSTONF, NF.CDMODDOCFISC, NF.IDSTATUS, NF.IDORIGDESTNF,
                              NF.IDORIGDESTNF||DECODE(NF.IDORIGDESTNF, 'F', NF.CDFORNECED, DECODE(NF.IDORIGDESTNF, 'C', NF.CDCLIENTE , DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIEMIT, NF.CDFILIRECE))) AS COD_PAR,
                              DECODE(NF.IDSTATUSNFE, 'D', '04', DECODE(NF.IDSTATUSNFE, 'I', '05',DECODE(IDSTATUS,'C','02',DECODE(NF.IDREGESPECIAL,'S','08',DECODE(NF.IDENTRSAIDOP,'S', (CASE WHEN DTEMISSAO < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_S,'07','01') ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_S,'06','00') END),(CASE WHEN ((NF.CDSERIEENTR BETWEEN '890' AND '899') AND (NF.CDMODDOCFISC = '55')) THEN '08'ELSE (CASE WHEN DTENTRSAID < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_E,'07','01')ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_E,'06','00') END) END)))))) AS SITU_DOC,
                              NF.IDSTATUSNFE, NVL(NF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL, NF.QTDEPARC, NF.CDTIPOOPER, DECODE(NF.IDENTRSAIDOP,'S',NF.CDFILIEMIT,NF.CDFILIRECE) AS FILIAL
                         FROM (/*NF DE SADA COM E SEM CARGA TRIBUTRIA*/
                               SELECT N.CAMPO2, N.CAMPO3, N.NRACESSONFE, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR,
                                      N.NRINSJURNF, N.IDSTATUS,N.IDREGESPECIAL,N.DTENTRSAID, N.VRNOTAFISC, N.VRPRODUTOS, N.IDPGTOFRETE,
                                      N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                      N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, N.CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                      N.VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                      TO_CHAR(NVL(VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL, N.NRLANCTONF, 'B', 'I', '1'),0) - NVL(N.VRBASEC197,0) +
                                              NVL(DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL,N.NRLANCTONF,'B','C','1'))),0)) AS VRBASECALCNF,
                                      TO_CHAR(NVL(VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL, N.NRLANCTONF, 'I', 'I', '1'),0) - NVL(N.VRIMPOSTOC197,0) +
                                              NVL(VALOR_FECP_NFE(N.CDFILIAL, N.NRLANCTONF, '00', 'I', '1'),0) +
                                              NVL(DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL,N.NRLANCTONF,'I','C','1')),0)) AS VRIMPOSTONF,
                                      N.VROUTRCRED, N.VRISENTRIB, N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, N.IDSIMPLESNACIONAL, N.QTDEPARC,
                                      (SELECT NVL(SUM(I.VRIMPOSTOIT + NVL(I.VRADICFECP,0)),0) FROM ITEMPROIMPOS I, IMPOSTO IM WHERE I.IDIMPDESONERAIT = 'S' AND I.CDFILIAL = N.CDFILIAL AND I.NRLANCTONF = N.NRLANCTONF AND I.CDIMPOSTO = IM.CDIMPOSTO AND IM.CDIMPOSTONFE = P_CDIMPOSTO) AS VRIMPDESONERADO
                                FROM (SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                             DECODE(N.IDENTRSAIDOP, 'E', DECODE(IDSTATUSNFE,'A','0',DECODE(IDSTATUS,'E','0','1')), '0') AS CAMPO3, NRACESSONFE,
                                             I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                             N.NRINSJURNF, N.IDSTATUS,T.IDREGESPECIAL,N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                             N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                             N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                             TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                             NVL(C_197.VRBASEC197,0) AS VRBASEC197, NVL(C_197.VRIMPOSTOC197,0) AS VRIMPOSTOC197,
                                             TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                             TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                             N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE,  DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL,
                                             MAX((SELECT COUNT(DISTINCT NRPARCELAREC)
                                                    FROM CONTARECEBER C
                                                   WHERE N.CDFILIAL    = C.CDFILIAL
                                                     AND N.NRLANCTONF  = C.NRLANCTONF
                                                     AND C.NRLANBOLREC IS NOT NULL)) AS QTDEPARC
                                        FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP, PARAMFORNE PF, SERIENF SS, SERIEENTR SE, TIPOOPERAC T,
                                             (SELECT NVL(SUM(IT.VRBASECALCIT),0) AS VRBASEC197,
                                                     NVL(SUM(ROUND(IT.VRIMPOSTOIT + NVL(IT.VRADICFECP,0),2)),0)  AS VRIMPOSTOC197,
                                                     DT.CDFILIAL, DT.NRLANCTONF
                                                FROM ITEMPROIMPOS IT, IMPOSTO IM, DETITMAPARECUP DT
                                               WHERE IT.CDFILIAL     = DT.CDFILIAL
                                                 AND IT.NRLANCTONF   = DT.NRLANCTONF
                                                 AND IT.NRSEQITPROD  = DT.NRSEQITPROD
                                                 AND IT.CDIMPOSTO    = DT.CDIMPOSTO
                                                 AND IT.NRITPROIMPOS = DT.NRITPROIMPOS
                                                 AND IT.NRITPROIMPOS = '1'
                                                 AND IT.CDFISCALIT   = '1'
                                                 AND IT.CDIMPOSTO    = IM.CDIMPOSTO
                                                 AND IM.CDIMPOSTONFE = '00'
                                                 AND DT.IDTIPOITMAPR <> 'VI'
                                               GROUP BY DT.CDFILIAL, DT.NRLANCTONF) C_197
                                       WHERE I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU
                                         AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                         AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                         AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                         AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                         AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                         AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                         AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                         AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                         AND N.IDENTRSAIDOP    = 'S'
                                         AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                         AND N.CDFILIAL        = I.CDFILIAL
                                         AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                         AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                         AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                         AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                         AND SS.CDSERIE(+)     = N.CDSERIE
                                         AND N.NRLANCTONF      = I.NRLANCTONF
                                         AND N.CDFORNECED      = PF.CDFORNECED(+)
                                         AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                         AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                         AND NVL(P_GERAFORSALE,'N') = 'N'
                                         AND N.CDFILIAL        = C_197.CDFILIAL(+)
                                         AND N.NRLANCTONF      = C_197.NRLANCTONF(+)
										 AND T.IDENTRSAIDOP    = N.IDENTRSAIDOP
										 AND T.CDTIPOOPER      = N.CDTIPOOPER
                                       GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE),
                                                      NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), N.NRINSJURNF, N.IDSTATUS,T.IDREGESPECIAL, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE,
                                                      N.DTEMISSAO, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                                      N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                                      N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE,
                                                      DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N'), NVL(C_197.VRBASEC197,0), NVL(C_197.VRIMPOSTOC197,0))N
                                UNION ALL
                               /******** NOTA CANCELADA *******/
                               SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                      '0' AS CAMPO3, NRACESSONFE,
                                      N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                      '' AS NRINSJURNF, N.IDSTATUS,'' AS IDREGESPECIAL, N.DTENTRSAID, N.VRNOTAFISC, '' AS VRPRODUTOS, N.IDPGTOFRETE,
                                      N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                      '' AS CDFILIEMIT, '' AS CDFILIRECE, N.DTEMISSAO, '' AS CDFISCOPERNF, N.CDMODDOCFISC, '' AS CDCLIENTE, '' AS CDFORNECED, N.IDORIGDESTNF,
                                      '' AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                      '' AS VRBASECALCNF,
                                      '' AS VRIMPOSTONF,
                                      '' AS VROUTRCRED,
                                      '' AS VRISENTRIB,
                                      NRNOTAFISCALELE,
                                      N.CDTIPOOPER, N.IDSTATUSNFE, 'N' AS IDSIMPLESNACIONAL,
                                      0 AS QTDEPARC, 0 AS VRIMPDESONERADO
                                 FROM NOTAFISCAL N, SERIENF SS, SERIEENTR SE
                                WHERE (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                  AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                  AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                  AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                  AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                  AND SS.CDSERIE(+)     = N.CDSERIE
                                  AND N.IDENTRSAIDOP = 'S'
                                  AND N.IDSTATUS = 'C'
                                  AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                  AND N.DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL
                                  AND N.CDINSCESTA = P_CDINSCESTA
                                  AND N.CDEMPRESA = P_CDEMPRESA
                                GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR),
                                         N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, N.IDPGTOFRETE, N.CDMODDOCFISC, N.CDCLIENTE,
                                         N.CDFORNECED, N.IDORIGDESTNF, N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, N.NRINSJURTRAN, N.IDTPIJURTRAN,
                                         N.VRPBRUTOVOLU, N.VRPLIQUVOLU, N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU,
                                         N.DSNUMEVOLU, N.NRACESSONFE, N.CDTIPOOPER, N.IDSTATUSNFE, N.NRNOTAFISCALELE
                                UNION ALL
                               /******** NOTA DENEGADA *******/
                               /*No  possvel escriturar nota denegada na entrada, ento mesmo que seja a transmisso de uma entrada
                                 deve ser escriturada como sada para manter o controle de numerao*/
                               SELECT '1' AS CAMPO2,
                                      '0' AS CAMPO3, NRACESSONFE,
                                      '' AS CDFILIAL, '' AS NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(NVL(SS.CDSERIENFE,N.CDSERIE),NVL(SE.CDSERIEENTR,N.CDSERIEENTR)) AS CDSERIE, '' AS CDSERIEENTR,
                                      '' AS NRINSJURNF, N.IDSTATUS,'' AS IDREGESPECIAL, N.DTENTRSAID, N.VRNOTAFISC, '' AS VRPRODUTOS, N.IDPGTOFRETE,
                                      '' AS NRPLACAVEIC, '' AS DSQTDEVOLU, '' AS DSESPECVOLU, '' AS DSMARCAVOLU, N.DSNUMEVOLU,
                                      '' CDFILIEMIT, '' CDFILIRECE, N.DTEMISSAO, '' AS CDFISCOPERNF, N.CDMODDOCFISC, '' AS CDCLIENTE, '' AS CDFORNECED, N.IDORIGDESTNF,
                                      '' AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                      '' AS VRBASECALCNF,
                                      '' AS VRIMPOSTONF,
                                      '' AS VROUTRCRED,
                                      '' AS VRISENTRIB,
                                      NRNOTAFISCALELE,
                                      N.CDTIPOOPER, N.IDSTATUSNFE, 'N' AS IDSIMPLESNACIONAL,
                                      0 AS QTDEPARC, 0 AS VRIMPDESONERADO
                                 FROM NOTAFISCAL N, SERIENF SS, SERIEENTR SE
                                WHERE (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                  AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                  AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                  AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                  AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                  AND SS.CDSERIE(+)     = N.CDSERIE
                                  AND N.IDSTATUSNFE     = 'D'
                                  AND N.NRACESSONFE     IS NOT NULL
                                  AND N.CDMODDOCFISC    IN ('01','1B','04','55')
                                  AND N.DTEMISSAO       BETWEEN P_DTINICIAL AND P_DTFINAL
                                  AND N.CDINSCESTA      = P_CDINSCESTA
                                  AND N.CDEMPRESA       = P_CDEMPRESA
                                GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC,
                                         NVL(NVL(SS.CDSERIENFE,N.CDSERIE),NVL(SE.CDSERIEENTR,N.CDSERIEENTR)),
                                         N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, N.IDPGTOFRETE, N.CDMODDOCFISC, N.CDCLIENTE,
                                         N.CDFORNECED, N.IDORIGDESTNF, N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, N.NRINSJURTRAN, N.IDTPIJURTRAN,
                                         N.VRPBRUTOVOLU, N.VRPLIQUVOLU, N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU,
                                         N.DSNUMEVOLU, N.NRACESSONFE, N.CDTIPOOPER, N.IDSTATUSNFE, N.NRNOTAFISCALELE
                                UNION ALL
                               /******** NMERAO INUTILIZADA *******/
                               SELECT '1' AS CAMPO2,
                                      '0' AS CAMPO3,
                                      ''  AS NRACESSONFE,
                                      ''  AS CDFILIAL, '' AS NRLANCTONF,
                                      'S' AS IDENTRSAIDOP, N.NRINUTILNFELE AS NRNOTAFISC, N.CDSERIE AS CDSERIE, '' AS CDSERIEENTR,
                                      '' AS NRINSJURNF, 'I' AS IDSTATUS,'' AS IDREGESPECIAL, N.DTINUTNFE AS DTENTRSAID, 0 AS VRNOTAFISC, '' AS VRPRODUTOS, '' AS IDPGTOFRETE,
                                      '' AS NRPLACAVEIC, '' AS DSQTDEVOLU, '' AS DSESPECVOLU, '' AS DSMARCAVOLU, '' AS DSNUMEVOLU,
                                      '' CDFILIEMIT, '' CDFILIRECE, N.DTINUTNFE AS DTEMISSAO, '' AS CDFISCOPERNF, '55' AS CDMODDOCFISC, '' AS CDCLIENTE, '' AS CDFORNECED, '' AS IDORIGDESTNF,
                                      '' AS VRCONTABILNF, '' AS NNRINSJURTRAN, '' AS IDTPIJURTRAN, 0 AS VRPBRUTOVOLU, 0 AS VRPLIQUVOLU,
                                      '' AS VRBASECALCNF,
                                      '' AS VRIMPOSTONF,
                                      '' AS VROUTRCRED,
                                      '' AS VRISENTRIB,
                                      N.NRINUTILNFELE AS NRNOTAFISCALELE,
                                      '' AS CDTIPOOPER, 'I' AS IDSTATUSNFE, 'N' AS IDSIMPLESNACIONAL,
                                      0 AS QTDEPARC, 0 AS VRIMPDESONERADO
                                 FROM NUMINUTILNFELE N
                                WHERE TRUNC(N.DTINUTNFE)BETWEEN P_DTINICIAL AND P_DTFINAL
                                  AND N.CDEMPRESA  = P_CDEMPRESA
                                  AND N.CDINSCESTA = P_CDINSCESTA
                                  AND N.NRPROTOCINUTNFE  <> 'TEKNISA'
                                UNION ALL
                               /*NF ENTRADA COM E SEM CARGA TRIBUTRIA*/
                               SELECT N.CAMPO2, N.CAMPO3, N.NRACESSONFE, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, N.CDSERIE,
                                      N.CDSERIEENTR, N.NRINSJURNF, N.IDSTATUS, N.IDREGESPECIAL, N.DTENTRSAID, N.VRNOTAFISC, N.VRPRODUTOS, N.IDPGTOFRETE,
                                      N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, N.CDFILIEMIT, N.CDFILIRECE,
                                      N.DTEMISSAO, N.CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                      N.VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                      TO_CHAR(NVL(VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL, N.NRLANCTONF, 'B', 'I', '1'),0) - NVL(N.VRBASEC197,0) +
                                              NVL(DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL,N.NRLANCTONF,'B','C','1'))),0)) AS VRBASECALCNF,
                                      TO_CHAR(NVL(VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL, N.NRLANCTONF, 'I', 'I', '1'),0) - NVL(N.VRIMPOSTOC197,0) +
                                              NVL(VALOR_FECP_NFE(N.CDFILIAL, N.NRLANCTONF, '00', 'I', '1'),0) +
                                              NVL(DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL,N.NRLANCTONF,'I','C','1'))),0)) AS VRIMPOSTONF,
                                      N.VROUTRCRED, N.VRISENTRIB, N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, N.IDSIMPLESNACIONAL, N.QTDEPARC,
                                      (SELECT NVL(SUM(I.VRIMPOSTOIT+NVL(I.VRADICFECP,0)),0) FROM ITEMPROIMPOS I, IMPOSTO IM WHERE I.IDIMPDESONERAIT = 'S' AND I.CDFILIAL = N.CDFILIAL AND I.NRLANCTONF = N.NRLANCTONF AND I.CDIMPOSTO = IM.CDIMPOSTO AND IM.CDIMPOSTONFE = P_CDIMPOSTO) VRIMPDESONERADO
                                 FROM (SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                              DECODE(N.IDENTRSAIDOP, 'E', DECODE(IDSTATUSNFE,'A','0',DECODE(IDSTATUS,'E','0','1')), '0') AS CAMPO3, NRACESSONFE,
                                              I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                              N.NRINSJURNF, N.IDSTATUS,T.IDREGESPECIAL, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                              N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                              N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                              TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                              NVL(C_197.VRBASEC197,0) AS VRBASEC197, NVL(C_197.VRIMPOSTOC197,0) AS VRIMPOSTOC197,
                                              TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                              TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                              N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL,
                                              MAX((SELECT COUNT(DISTINCT NRPARCELAPAG)
                                                     FROM CONTAPAGAR C
                                                    WHERE N.CDFILIAL    = C.CDFILIAL
                                                      AND N.NRLANCTONF  = C.NRLANCTONF
                                                      AND C.NRLANBOLPAG IS NOT NULL)) AS QTDEPARC
                                         FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP, PARAMFORNE PF, SERIEENTR SE, SERIENF SS, TIPOOPERAC T,
                                              (SELECT NVL(SUM(IT.VRBASECALCIT),0) AS VRBASEC197,
                                                      NVL(SUM(ROUND(IT.VRIMPOSTOIT + NVL(IT.VRADICFECP,0),2)),0)  AS VRIMPOSTOC197,
                                                      DT.CDFILIAL, DT.NRLANCTONF
                                                 FROM ITEMPROIMPOS IT, IMPOSTO IM, DETITMAPARECUP DT
                                                WHERE IT.CDFILIAL     = DT.CDFILIAL
                                                  AND IT.NRLANCTONF   = DT.NRLANCTONF
                                                  AND IT.NRSEQITPROD  = DT.NRSEQITPROD
                                                  AND IT.CDIMPOSTO    = DT.CDIMPOSTO
                                                  AND IT.NRITPROIMPOS = DT.NRITPROIMPOS
                                                  AND IT.NRITPROIMPOS = '1'
                                                  AND IT.CDFISCALIT   = '1'
                                                  AND IT.CDIMPOSTO    = IM.CDIMPOSTO
                                                  AND IM.CDIMPOSTONFE = '00'
                                                  AND DT.IDTIPOITMAPR <> 'VI'
                                                GROUP BY DT.CDFILIAL, DT.NRLANCTONF) C_197
                                        WHERE I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU
                                          AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                          AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                          AND (NVL(N.IDSISTEMA,'DFS')  <> 'REC'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'PAG'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'CMP'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'SUP'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'TMP'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'FIS' )
                                          AND N.IDENTRSAIDOP    = 'E'
                                          AND PF.CDFORNECED(+)  = N.CDFORNECED
                                          AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                          AND N.CDFILIAL        = I.CDFILIAL
                                          AND N.NRLANCTONF      = I.NRLANCTONF
                                          AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                          AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                          AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                          AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                          AND SS.CDSERIE(+)     = N.CDSERIE
                                          AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                          AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                          AND NVL(P_GERAFORSALE,'N') = 'N'
                                          AND N.CDFILIAL        = C_197.CDFILIAL(+)
                                          AND N.NRLANCTONF      = C_197.NRLANCTONF(+)
										  AND T.IDENTRSAIDOP    = N.IDENTRSAIDOP
										  AND  T.CDTIPOOPER      = N.CDTIPOOPER
                                        GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP,
                                               N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), N.NRINSJURNF, N.IDSTATUS, T.IDREGESPECIAL, N.DTENTRSAID, NRACESSONFE,
                                               N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE, N.DTEMISSAO , N.CDMODDOCFISC, N.CDCLIENTE,
                                               N.CDFORNECED, N.IDORIGDESTNF, N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                               N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE, N.CDTIPOOPER, IDSTATUSNFE,
                                               DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N'), NVL(C_197.VRBASEC197,0), NVL(C_197.VRIMPOSTOC197,0))N
                                UNION
                               /*******NOTAS FISCAIS FORSALE - C100 FOS ***********/
                               SELECT DECODE(NF.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                      DECODE(NF.IDENTRSAIDOP, 'E', DECODE(IDSTATUS,'E','0','1'), '0') AS CAMPO3, NRACESSONFE,
                                      NF.CDFILIAL, NF.NRLANCTONF, NF.IDENTRSAIDOP, NF.NRNOTAFISC, NF.CDSERIE, NF.CDSERIEENTR,
                                      NF.NRINSJURNF, NF.IDSTATUS, NF.IDREGESPECIAL, NF.DTENTRSAID, NF.VRNOTAFISC, TO_CHAR(NF.VRPRODUTOS) AS VRPRODUTOS, NF.IDPGTOFRETE,
                                      NF.NRPLACAVEIC, NF.DSQTDEVOLU, NF.DSESPECVOLU, NF.DSMARCAVOLU, NF.DSNUMEVOLU,
                                      NF.CDFILIEMIT, NF.CDFILIRECE, NF.DTEMISSAO, MAX(NF.CDFISCOPERNF) AS CDFISCOPERNF, NF.CDMODDOCFISC, NF.CDCLIENTE, NF.CDFORNECED, NF.IDORIGDESTNF,
                                      NF.VRCONTABILNF AS VRCONTABILNF,
                                      NF.NRINSJURTRAN, NF.IDTPIJURTRAN, NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU,
                                      TO_CHAR(VRBASECALCNF) AS VRBASECALCNF,
                                      TO_CHAR(VRIMPOSTONF),
                                      TO_CHAR(VROUTRCRED),
                                      TO_CHAR(VRISENTRIB),
                                      NF.NRNOTAFISCALELE,
                                      NF.CDTIPOOPER, '' AS IDSTATUSNFE, NF.IDSIMPLESNACIONAL, NF.QTDEPARC,
                                      (SELECT NVL(SUM(I.VRIMPOSTOIT + NVL(I.VRADICFECP,0)),0) FROM ITEMPROIMPOS I, IMPOSTO IM WHERE I.IDIMPDESONERAIT = 'S' AND I.CDFILIAL = NF.CDFILIAL AND I.NRLANCTONF = NF.NRLANCTONF AND I.CDIMPOSTO = IM.CDIMPOSTO AND IM.CDIMPOSTONFE = P_CDIMPOSTO) VRIMPDESONERADO
                                 FROM ENDECLIE EC, ENDEFORN EF, ENDEFILI EFI,
                                      (SELECT DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSJURCLIE,'F',FO.NRINSJURFORN,'L',FI.NRINSJURFILI) AS NRINSJURNF,
                                              DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSESTCLIE,'F',FO.NRINSESTFORN,'L',FI.CDINSCESTA  ) AS NRINSEST,
                                              N.IDORIGDESTNF, N.CDCLIENTE, N.CDFORNECED, N.CDFILIEMIT, N.CDFILIRECE, N.NRNOTAFISC, I.CDFISCOPERNF,
                                              N.NRLANCTONF,N.CDFILIAL, N.IDENTRSAIDOP, DECODE(N.CDMODDOCFISC,'2D','55',N.CDMODDOCFISC) AS CDMODDOCFISC,
                                              NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR, N.DTENTRSAID, N.DTEMISSAO,
                                              TO_CHAR(SUM(VRCONTABILNF)) AS VRCONTABILNF,
                                              DECODE(I.CDFISCALNF,'1',SUM(VRBASECALCNF),0) AS VRBASECALCNF,
                                              DECODE(I.CDFISCALNF,'2',SUM(VRCONTABILNF),'1',SUM(DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF)),0) AS VRISENTRIB,
                                              DECODE(I.CDFISCALNF,'3',SUM(VRCONTABILNF),0) AS VROUTRCRED,
                                              DECODE(I.CDFISCALNF,'1',SUM(VRIMPOSTONF + NVL(VRADICFECP,0)),0) AS VRIMPOSTONF,
                                              SUM(N.VRPRODUTOS) AS VRPRODUTOS,
                                              N.NRINSJURTRAN,N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU, N.NRNOTAFISCALELE, I.VRPERREDBCNF,N.IDSTATUS,T.IDREGESPECIAL, N.IDPGTOFRETE,
                                              N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,N.VRNOTAFISC, NRACESSONFE, N.CDTIPOOPER,
                                              DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL,
                                              MAX((SELECT COUNT(DISTINCT NRPARCELAREC)
                                                     FROM CONTARECEBER C
                                                    WHERE N.CDFILIAL    = C.CDFILIAL
                                                      AND N.NRLANCTONF  = C.NRLANCTONF
                                                      AND C.NRLANBOLREC IS NOT NULL)) AS QTDEPARC
                                         FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IMP, CLIENTE CL, FORNECEDOR FO, FILIAL FI, PARAMFORNE PF, SERIENF SS, SERIEENTR SE, TIPOOPERAC T
                                        WHERE N.CDFILIAL     = I.CDFILIAL
                                          AND N.NRLANCTONF   = I.NRLANCTONF
                                          AND IMP.CDIMPOSTO  = I.CDIMPOSTO
                                          AND N.CDCLIENTE    = CL.CDCLIENTE(+)
                                          AND N.CDFORNECED   = FO.CDFORNECED(+)
                                          AND N.CDFORNECED   = PF.CDFORNECED(+)
                                          AND N.CDFILIRECE   = FI.CDFILIAL(+)
                                          AND N.CDFILIEMIT   = FI.CDFILIAL(+)
                                          AND DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL
                                          AND ((N.IDSTATUS   = 'A' OR N.IDSTATUS = 'E') OR (N.IDSTATUSNFE = 'A' OR N.IDSTATUSNFE = 'T'))
                                          AND N.CDINSCESTA   = P_CDINSCESTA
                                          AND IMP.CDIMPOSTONFE = P_CDIMPOSTO
                                          AND (I.IDIMPOSTONF <> '3' OR IDIMPOSTONF IS NULL)
                                          AND (NVL(N.IDSISTEMA, 'DFS') <> 'REC'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'PAG'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'CMP'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'SUP'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'TMP'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'FIS')
                                          AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                          AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                          AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                          AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                          AND SS.CDSERIE(+)     = N.CDSERIE
                                          AND N.CDMODDOCFISC IN ('01','1B','04','55','2D')
                                          AND N.IDENTRSAIDOP = 'S'
                                          AND NVL(P_GERAFORSALE,'N') = 'S'
										  AND T.IDENTRSAIDOP    = N.IDENTRSAIDOP
                                          AND T.CDTIPOOPER      = N.CDTIPOOPER										  
                                        GROUP BY DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSJURCLIE,'F',FO.NRINSJURFORN,'L',FI.NRINSJURFILI),
                                                 DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSESTCLIE,'F',FO.NRINSESTFORN,'L',FI.CDINSCESTA),N.IDORIGDESTNF,
                                                 N.CDCLIENTE, N.CDFORNECED, N.CDFILIEMIT, N.CDFILIRECE, N.NRNOTAFISC, I.CDFISCOPERNF, N.NRLANCTONF,
                                                 N.CDFILIAL, N.IDENTRSAIDOP, N.CDMODDOCFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR),
                                                 N.DTENTRSAID, N.DTEMISSAO,  I.CDFISCALNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU,
                                                 N.VRPLIQUVOLU,N.NRNOTAFISCALELE,I.VRPERREDBCNF,N.IDSTATUS,T.IDREGESPECIAL, IDPGTOFRETE,
                                                 N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,N.VRNOTAFISC,NRACESSONFE,N.CDTIPOOPER,DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N'))NF
                                WHERE NF.CDCLIENTE    = EC.CDCLIENTE(+)
                                  AND NF.CDFORNECED   = EF.CDFORNECED(+)
                                  AND NF.CDFILIEMIT   = EFI.CDFILIAL(+)
                                  AND NF.CDFILIRECE   = EFI.CDFILIAL(+)
                                  AND IDTPENDECLIE(+) = 'P'
                                  AND IDTPENDEFORN(+) = 'P'
                                  AND IDTPENDEFILI(+) = 'P'
                                  AND NVL(P_GERAFORSALE,'N') = 'S'
                                GROUP BY DECODE(NF.IDENTRSAIDOP, 'E', '0','1'),
                                         DECODE(NF.IDENTRSAIDOP, 'E', DECODE(IDSTATUS,'E','0','1'), '0'), NRACESSONFE,
                                         NF.CDFILIAL, NF.NRLANCTONF, NF.IDENTRSAIDOP, NF.NRNOTAFISC, NF.CDSERIE, NF.CDSERIEENTR,
                                         NF.NRINSJURNF, NF.IDSTATUS,NF.IDREGESPECIAL, NF.DTENTRSAID, NF.VRNOTAFISC, TO_CHAR(NF.VRPRODUTOS), NF.IDPGTOFRETE,
                                         NF.NRPLACAVEIC, NF.DSQTDEVOLU, NF.DSESPECVOLU, NF.DSMARCAVOLU, NF.DSNUMEVOLU,
                                         NF.CDFILIEMIT, NF.CDFILIRECE, NF.DTEMISSAO, NF.CDMODDOCFISC, NF.CDCLIENTE, NF.CDFORNECED, NF.IDORIGDESTNF,
                                         NF.VRCONTABILNF, NF.NRINSJURTRAN, NF.IDTPIJURTRAN, NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU,
                                         TO_CHAR(VRBASECALCNF), TO_CHAR(VRIMPOSTONF), TO_CHAR(VROUTRCRED), TO_CHAR(VRISENTRIB),
                                         NF.NRNOTAFISCALELE,NF.CDTIPOOPER,NF.IDSIMPLESNACIONAL, NF.QTDEPARC, NF.CDTIPOOPER)NF
                        UNION ALL
                       /*Registro C100 para Nota Fiscal Eletrnica para Consumidor Final (NFC-e)*/
                       SELECT ('|C100'                                                                || '|' ||
                               NF.CAMPO2                                                              || '|' ||
                               NF.CAMPO3                                                              || '|' ||
                               ''                                                                     || '|' ||
                               NF.CDMODDOCFISC                                                        || '|' ||
                               DECODE(NF.IDSTATUSNFCE,'D','04','I','05','C','02','00')                || '|' ||
                               REPLACE(REPLACE(NF.CDSERIE,'-',''),'.','')                             || '|' ||
                               LTRIM(NF.NRNOTAFISC,'0')                                               || '|' ||
                               NF.NRACESSONFCE                                                        || '|' ||
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','',TO_CHAR(NF.DTEMISSAO,'ddmmyyyy')) || '|' ) AS DADOS_1,
                               (DECODE(NF.IDSTATUSNFCE,'D','','I','','C','',REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF,2),'999999999990.00')),'.',','))  || '|' || -- Campo 12 - Valor total do documento fiscal
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','','0')                                                                           || '|' || -- Campo 13 - Indicador de Pagamento
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','',REPLACE(LTRIM(TO_CHAR(NF.VRDESITVEND,'999999999990.00')),'.',','))             || '|' || -- Campo 14 - Valor total do desconto
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','','0,00')                                                                        || '|' || -- Campo 15 - Abatimento no tributado e no comercial - desconto ICMS
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','',REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF+NF.VRDESITVEND,2),'999999999990.00')),'.',',')) || '|' || -- Campo 16 - Valor total das mercadorias e servios
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','','9')                                                                           || '|' || -- Campo 17 - Indicador de Frete
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','','0,00')                                                                        || '|' || -- Campo 18 - Valor de Frete
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','','0,00')                                                                        || '|' || -- Campo 19 - Valor do Seguro
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','','0,00')                                                                        || '|' || -- Campo 20 - Outras despesas acessrias
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','',REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRBASECALC,2 ),'999999999990.00')), '.', ','))  || '|' || -- Campo 21 - Valor da base de clculo do ICMS
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','',REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRIMPOSTONF,2),'999999999990.00')), '.', ','))  || '|' || -- Campo 22 - Valor do ICMS
                               '' || '|' || -- base de calc susbt. trib
                               '' || '|' || -- valor do icms retido susbt. trib
                               '' || '|' || -- valor do IPI
                               '' || '|' || -- valor do PIS
                               '' || '|' || -- valor do COFINS
                               '' || '|' || -- pis retido por subst. trib.
                               '' || '|'  ) AS DADOS_3,
                               NF.CDFILIAL, NF.NRLANCTONF, NF.CDCAIXA, '' AS NRINSJURTRAN, '' AS IDTPIJURTRAN, 0 AS VRPBRUTOVOLU, 0 AS VRPLIQUVOLU,
                               '' AS NRPLACAVEIC, '' AS DSQTDEVOLU, '' AS DSESPECVOLU, '' AS DSMARCAVOLU, '' AS DSNUMEVOLU, '' AS CDFISCOPERNF, NF.NRNOTAFISC AS NRNOTAFISC,
                               NF.DTEMISSAO, NF.DTENTRSAID, NF.IDENTRSAIDOP, TO_CHAR(NF.VRIMPOSTONF) AS VRIMPOSTONF, NF.CDMODDOCFISC, NF.IDSTATUS, NF.IDORIGDESTNF,
                               '' AS COD_PAR, DECODE(NF.IDSTATUSNFCE,'D','04','I','05','C','02','00') AS SITU_DOC, NF.IDSTATUSNFCE AS IDSTATUSNFE,
                               'N' AS IDSIMPLESNACIONAL, NF.QTDEPARC, '' AS CDTIPOOPER, NF.CDFILIAL AS FILIAL
                         FROM (SELECT '1' AS CAMPO2, '0' AS CAMPO3, '65' AS CDMODDOCFISC, VE.IDSTATUSNFCE, VE.CDSERIENFCE AS CDSERIE, VE.NRNOTAFISCALCE AS NRNOTAFISC,
                                      SUM(TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2)-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0)) AS VRCONTABILNF,
                                      SUM(VRDESITVEND) AS VRDESITVEND, VE.NRACESSONFCE, TRUNC(VE.DTEMISSAONFCE) AS DTEMISSAO, IP.VRIMPOSTONF, IP.VRBASECALC,
                                      VE.CDFILIAL AS CDFILIAL, VE.NRSEQVENDA AS NRLANCTONF, VE.CDCAIXA, VE.DTENTRVENDA AS DTENTRSAID, 'S' AS IDENTRSAIDOP,
                                      '' AS IDSTATUS, '' AS IDORIGDESTNF, 1 AS QTDEPARC
                                 FROM VENDA VE, ITEMVENDA IT, FILIAL FI,
                                      (SELECT I.CDFILIAL, I.CDCAIXA, I.NRSEQVENDA,
                                              SUM(CASE WHEN I.VRPRBCREDUICMS > 0
                                                       THEN I.VRBASECALCREDUZ
                                                       ELSE TRUNC(T.QTPRODVEND*(T.VRUNITVEND+NVL(T.VRUNITVENDCL,0)),2)-NVL(T.VRDESITVEND,0)+NVL(T.VRACRITVEND,0) END) AS VRBASECALC,
                                              SUM(CASE WHEN I.VRPRBCREDUICMS > 0
                                                       THEN I.VRIMPOPRODREDUZ
                                                       ELSE TRUNC(I.VRIMPOPRODIT,2) END) AS VRIMPOSTONF
                                         FROM ITVENDAIMPOS I,  ITEMVENDA T,  VENDA V,  IMPOSTO M, FILIAL F
                                        WHERE F.CDEMPRESA       = P_CDEMPRESA
                                          AND F.CDINSCESTA      = P_CDINSCESTA
                                          AND F.CDEMPRESA       = V.CDEMPRESA
                                          AND F.CDFILIAL        = V.CDFILIAL
                                          AND TRUNC(V.DTEMISSAONFCE) BETWEEN P_DTINICIAL AND P_DTFINAL
                                          AND V.IDSITUVENDA     = 'O'
                                          AND V.IDTPAMBNFCE     = '1'
                                          AND V.IDSTATUSNFCE    = 'A'
                                          AND V.CDFILIAL        = T.CDFILIAL
                                          AND V.NRSEQVENDA      = T.NRSEQVENDA
                                          AND V.CDCAIXA         = T.CDCAIXA
                                          AND T.CDFILIAL        = I.CDFILIAL
                                          AND T.CDCAIXA         = I.CDCAIXA
                                          AND T.NRSEQUITVEND    = I.NRSEQUITVEND
                                          AND T.NRSEQVENDA      = I.NRSEQVENDA
                                          AND I.CDIMPOSTO       = M.CDIMPOSTO
                                          AND M.CDIMPOSTONFE    = P_CDIMPOSTO
                                          AND M.IDTPIMPOSFIS    = 'T'
                                          AND V.IDAPROVACAONFCE = 'A'
                                          AND V.IDTPEMISVEND    = 'N'
                                        GROUP BY I.CDFILIAL, I.CDCAIXA, I.NRSEQVENDA) IP
                                WHERE VE.CDEMPRESA       = P_CDEMPRESA
                                  AND TRUNC(VE.DTEMISSAONFCE) BETWEEN P_DTINICIAL AND P_DTFINAL
                                  AND VE.IDSITUVENDA     = 'O'
                                  AND VE.IDTPAMBNFCE     = '1'
                                  AND VE.IDSTATUSNFCE    = 'A'
                                  AND VE.IDAPROVACAONFCE = 'A'
                                  AND VE.CDFILIAL        = IT.CDFILIAL
                                  AND VE.NRSEQVENDA      = IT.NRSEQVENDA
                                  AND VE.CDCAIXA         = IT.CDCAIXA
                                  AND IT.CDFILIAL        = IP.CDFILIAL(+)
                                  AND IT.CDCAIXA         = IP.CDCAIXA(+)
                                  AND IT.NRSEQVENDA      = IP.NRSEQVENDA(+)
                                  AND VE.IDTPEMISVEND    = 'N'
                                  AND VE.CDFILIAL        = FI.CDFILIAL
                                  AND FI.CDEMPRESA       = P_CDEMPRESA
                                  AND FI.CDINSCESTA      = P_CDINSCESTA
                                GROUP BY VE.IDSTATUSNFCE, VE.CDSERIENFCE, VE.NRNOTAFISCALCE, VE.NRACESSONFCE,
                                         TRUNC(VE.DTEMISSAONFCE), VE.CDFILIAL, VE.NRSEQVENDA, VE.CDCAIXA,
                                         VE.DTENTRVENDA, IP.VRIMPOSTONF, IP.VRBASECALC
                                UNION ALL
                               SELECT '1' AS CAMPO2, '0' AS CAMPO3, '65' AS CDMODDOCFISC, VE.IDSTATUSNFCE, VE.CDSERIENFCE AS CDSERIE, VE.NRNOTAFISCALCE AS NRNOTAFISC,
                                      0 AS VRCONTABILNF, 0 AS VRDESITVEND, VE.NRACESSONFCE, TRUNC(VE.DTEMISSAONFCE) AS DTEMISSAO, 0 AS VRIMPOSTONF, 0 AS VRBASECALC,
                                      VE.CDFILIAL AS CDFILIAL, VE.NRSEQVENDA AS NRLANCTONF, VE.CDCAIXA, VE.DTENTRVENDA AS DTENTRSAID, 'S' AS IDENTRSAIDOP,
                                      'C' AS IDSTATUS, '' AS IDORIGDESTNF, 0 AS QTDEPARC
                                 FROM VENDA VE, FILIAL FI
                                WHERE VE.CDEMPRESA       = P_CDEMPRESA
                                  AND TRUNC(VE.DTEMISSAONFCE) BETWEEN P_DTINICIAL AND P_DTFINAL
                                  AND VE.IDSITUVENDA     = 'C'
                                  AND VE.IDTPAMBNFCE     = '1'
                                  AND VE.IDSTATUSNFCE    = 'C'
                                  AND VE.IDTPEMISVEND    = 'N'
                                  AND VE.CDFILIAL        = FI.CDFILIAL
                                  AND FI.CDEMPRESA       = P_CDEMPRESA
                                  AND FI.CDINSCESTA      = P_CDINSCESTA
                                UNION ALL
                               /******** NMERAO INUTILIZADA *******/
                               SELECT '1' AS CAMPO2, '0' AS CAMPO3, '65' AS CDMODDOCFISC, 'I' AS IDSTATUSNFCE, I.CDSERIENFCE AS CDSERIE,
                                      I.NRNOTAFISCALCE AS NRNOTAFISC, 0 AS VRCONTABILNF, 0 AS VRDESITVEND, ''  AS NRACESSONFE,
                                      TRUNC(I.DTHRINUTNFCE) AS DTEMISSAO, 0 AS VRIMPOSTONF, 0 AS VRBASECALC, I.CDFILIAL,
                                      '' AS NRSEQVENDA, I.CDCAIXA, I.DTENTRVENDA AS DTENTRSAID, 'S' AS IDENTRSAIDOP, 'I' AS IDSTATUS,
                                      '' AS IDORIGDESTNF, 0 AS QTDEPARC
                                 FROM INUTILIZANFCE I, FILIAL F
                                WHERE I.CDFILIAL    = F.CDFILIAL
                                  AND F.CDEMPRESA   = P_CDEMPRESA
                                  AND F.CDINSCESTA  = P_CDINSCESTA
                                  AND TRUNC(I.DTHRINUTNFCE) BETWEEN P_DTINICIAL AND P_DTFINAL
                                  AND I.IDTPAMBNFCE = '1')NF)LOOP

         IF C_REGC100.IDSTATUS = 'C' OR C_REGC100.IDSTATUSNFE = 'D' OR C_REGC100.IDSTATUSNFE = 'I' THEN
            V_DADOS_2 := '|';
         ELSE
            IF C_REGC100.IDENTRSAIDOP = 'E' THEN
               V_DADOS_2 := TO_CHAR(C_REGC100.DTENTRSAID,'ddmmyyyy') || '|';
            ELSE
               V_DADOS_2 := TO_CHAR(C_REGC100.DTEMISSAO,'ddmmyyyy') || '|';
            END IF;
         END IF;

         /* verifica a situacao do documento
         IF C_REGC100.IDENTRSAIDOP = 'E' THEN
            IF C_REGC100.IDSTATUS = 'C' THEN
               -- documentos cancelados
               V_DADOS_2 := '02|';
            ELSE
               IF NOT C_REGC100.DTENTRSAID BETWEEN P_DTINICIAL AND P_DTFINAL THEN
                  -- documentos de entrada fora do periodo
                  V_DADOS_2 := '01|';
               ELSE
                  V_DADOS_2 := '00|';
               END IF;
            END IF;
         ELSE
            IF C_REGC100.IDSTATUS = 'C' THEN
               -- documentos cancelados
               V_DADOS_2 := '02|';
            ELSE
               IF NOT C_REGC100.DTENTRSAID BETWEEN P_DTINICIAL AND P_DTFINAL THEN
                  -- documentos de entrada fora do periodo
                  V_DADOS_2 := '01|';
               ELSE
                  V_DADOS_2 := '00|';
               END IF;
            END IF;
         END IF;
         -- valor utilizado para o campo valores recolhidos ou a recolher, extra apuracao - E110
         IF V_DADOS_2 = '01|' AND C_REGC100.IDENTRSAIDOP = 'S' THEN
            V_VRDEBESP := NVL(V_VRDEBESP,0)+ C_REGC100.VRIMPOSTONF;
         END IF;
         */

         V_VRDEBESP := 0;
         /* valor total de imposto fora do periodo - nf saida */
         V_VRFORAPER := 0;
         IF (C_REGC100.SITU_DOC IN ('01', '07')) AND (C_REGC100.IDENTRSAIDOP = 'S') THEN
            BEGIN
               SELECT SUM(VRIMPOSTONF + NVL(VRADICFECP,0))
                 INTO V_VRFORAPER
                 FROM IMPOSTONF IP, IMPOSTO IM
                WHERE CDFILIAL        = C_REGC100.CDFILIAL
                  AND NRLANCTONF      = C_REGC100.NRLANCTONF
                  AND CDFISCALNF      = '1'
                  AND NVL(IDIMPOSTONF,'1') <> '3'
                  AND IP.CDIMPOSTO    = IM.CDIMPOSTO
                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VRFORAPER := 0;
            END;
            V_TOTFORPER_S := NVL(V_TOTFORPER_S,0)+NVL(V_VRFORAPER,0);
         END IF;

         /* valor total de imposto fora do periodo - nf entrada
         V_VRFORAPER_E := 0;
         IF (V_DADOS_2 = '01|') AND (C_REGC100.IDENTRSAIDOP = 'E') THEN
            BEGIN
               SELECT SUM(VRIMPOSTONF)
               INTO V_VRFORAPER_E
               FROM IMPOSTONF
               WHERE CDFILIAL = C_REGC100.CDFILIAL
                 AND NRLANCTONF = C_REGC100.NRLANCTONF;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VRFORAPER_E := 0;
            END;
            V_TOTFORPER_E :=  NVL(V_TOTFORPER_E,0)+NVL(V_VRFORAPER_E,0);
         END IF;
         */

         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC100.DADOS_1||V_DADOS_2||C_REGC100.DADOS_3, P_NRSEQARQMAG);
         V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
         V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

         /* CODIGO DO PARTICIPANTE */
         SELECT MAX(CDCHAVEREG)
           INTO V_COD_PAR
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_REGC100.COD_PAR
            AND CDREGISTRO = '0150';

         IF (V_COD_PAR IS NULL) AND (C_REGC100.COD_PAR IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
              (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
              ('0150', V_SEQUPROD, C_REGC100.COD_PAR);
         END IF;

         /*REGISTRO C101 - INFORMAO COMPLEMENTAR DOS DOCUMENTOS FISCAIS QUANDO DAS
          OPERAES INTERESTADUAIS DESTINADAS A CONSUMIDOR FINAL NO CONTRIBUINTE EC 87/15*/
         FOR C_REGC101 IN (SELECT '|C101'                                                           || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(VRFCP,       '999999999990.00')), '.', ',') || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(VRDIFALDEST, '999999999990.00')), '.', ',') || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(VRDIFALORIG, '999999999990.00')), '.', ',') || '|'  AS ARQC101
                             FROM (SELECT SUM(ROUND(DECODE(C_REGC100.IDENTRSAIDOP,'S',I.VRIMPOFCP,     DECODE(C.IDTIPOCFOP,'D',I.VRIMPOFCP,     0)),2)) AS VRFCP,
                                          SUM(ROUND(DECODE(C_REGC100.IDENTRSAIDOP,'S',I.VRIMPOPARTDEST,DECODE(C.IDTIPOCFOP,'D',I.VRIMPOPARTDEST,0)),2)) AS VRDIFALDEST,
                                          SUM(ROUND(DECODE(C_REGC100.IDENTRSAIDOP,'S',I.VRIMPOPARTREME,DECODE(C.IDTIPOCFOP,'D',I.VRIMPOPARTREME,0)),2)) AS VRDIFALORIG
                                     FROM ITEMPROIMPOS I, IMPOSTO IM, CFOPPADRAO C
                                    WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                      AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                      AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                      AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                      AND I.CDFISCOPERIT  = C.CDCFOPPADRAO
                                      AND C_REGC100.CDMODDOCFISC = '55')
                            WHERE VRFCP > 0 OR VRDIFALDEST > 0 OR VRDIFALORIG > 0) LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC101.ARQC101 , P_NRSEQARQMAG);
            V_CONTREGC   :=  NVL(V_CONTREGC,0) + 1;
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
         END LOOP;

         V_COD_PAR := null;

         /*REGISTRO C110 - OBSERVAO DO DOCUMENTO*/
         FOR C_REGC110 IN (SELECT '|C110'                                  ||'|'||
                                  LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0')    ||'|'||
                                  'CUPOM FISCAL REFERENCIADO - COO NMERO '||TRIM(D.NRCOOCUPOMNF)||'|'  AS DSREGC110,
                                  '|C114'                                  ||'|'||
                                  '2D'                                     ||'|'||
                                  SUBSTR(D.NRSERIEIMPNF,1,21)              ||'|'||
                                  SUBSTR(LPAD(D.NRCOOCUPOMNF,10,'0'),5,6)  ||'|'||
                                  TO_CHAR(C_REGC100.DTEMISSAO,'DDMMYYYY')  ||'|' AS DSREGC114
                             FROM DADOSNF D, NOTAFISCAL N
                            WHERE D.NRLANCTONF  = C_REGC100.NRLANCTONF
                              AND D.CDFILIAL    = C_REGC100.CDFILIAL
                              AND D.NRECFCUPOMNF IS NOT NULL
                              AND D.NRLANCTONF  = N.NRLANCTONF
                              AND D.CDFILIAL    = N.CDFILIAL
                              AND C_REGC100.CDMODDOCFISC <> '65'
                              AND NOT ((N.IDSTATUSNFE = 'A') OR (N.CDMODDOCFISC = '55')))LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC110.DSREGC110 , P_NRSEQARQMAG);
            V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

            /*REGISTRO C114 - CUPOM FISCAL REFERENCIADO*/
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC110.DSREGC114 , P_NRSEQARQMAG);
            V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
            V_SEQADIC := V_SEQADIC +1;
         END LOOP;

         /*REGISTRO C110 - OBSERVAO DO DOCUMENTO -- DADOSADIC*/
         FOR C_REGC110 IN (SELECT D.DSDADOADIC AS DSREGC110
                             FROM DADOSADIC D, NOTAFISCAL N
                            WHERE D.NRLANCTONF = C_REGC100.NRLANCTONF
                              AND D.CDFILIAL   = C_REGC100.CDFILIAL
                              AND D.NRLANCTONF = N.NRLANCTONF
                              AND D.CDFILIAL   = N.CDFILIAL
                              AND C_REGC100.CDMODDOCFISC <> '65')LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C110|'||LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0')||'|'||TRIM(SUBSTR(C_REGC110.DSREGC110, 0,499))||'|', P_NRSEQARQMAG);
            V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
            VALUES
               ('0450', V_SEQUPROD, LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0'), TRIM(SUBSTR(C_REGC110.DSREGC110, 0, 499)));
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
            V_SEQADIC    := V_SEQADIC +1;
         END LOOP;

         V_GERAC113 := 'N';
         /* C113 - documento fiscal referenciado */
         FOR C_REGC113 IN (SELECT REG        ||'|'||
                                  IND_OPER   ||'|'||
                                  IND_EMIT   ||'|'||
                                  REPLACE(REPLACE(REPLACE(REPLACE(COD_PART,'.'),'-'),'/'),' ') ||'|'||
                                  COD_MOD    ||'|'||
                                  SER        ||'|'||
                                  SUB        ||'|'||
                                  NUM_DOC    ||'|'||
                                  DT_DOC     ||'|'||
                                  CASE WHEN TO_NUMBER(P_VERSAO) >= 11 THEN CHV_DOCe ||'|' ELSE '' END AS DSREG_C113,
                                  COD_PART, CDFORNECED
                             FROM (SELECT '|C113' AS REG,
                                          '0' AS IND_OPER,
                                          DECODE(SUBSTR(NP.NRACESSONFE,7,14),REPLACE(REPLACE(REPLACE(I.NRINSJURIEST,'-',''),'.',''),'/',''),'0','1') AS IND_EMIT,
                                          'F'||NVL(F.CDFORNECED,NVL(NP.NRINSJURIEST,SUBSTR(NP.NRACESSONFE,7,14))) AS  COD_PART,
                                          NVL(NP.CDMODDOCFISC,SUBSTR(NP.NRACESSONFE,21,2)) AS COD_MOD,
                                          NVL(NP.CDSERIE,SUBSTR(NP.NRACESSONFE,23,3)) AS SER,
                                          '' AS SUB,
                                          NVL(NP.NRNOTAFISC,SUBSTR(NP.NRACESSONFE,26,9)) AS NUM_DOC,
                                          TO_CHAR(NP.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                          NP.NRACESSONFE AS CHV_DOCe,
                                          'F'||F.CDFORNECED AS CDFORNECED
                                     FROM NFPRODRURAL NP, FORNECEDOR F, INSCRESTAD I
                                    WHERE NP.CDFILIAL     = C_REGC100.CDFILIAL
                                      AND NP.NRLANCTONF   = C_REGC100.NRLANCTONF
                                      AND I.CDINSCESTA    = P_CDINSCESTA
                                      AND C_REGC100.CDMODDOCFISC <> '65'
                                      AND NVL(NP.NRINSJURIEST,SUBSTR(NP.NRACESSONFE,7,14)) = REPLACE(REPLACE(REPLACE(F.NRINSJURFORN(+),'-',''),'.',''),'/','')))LOOP
            IF V_GERAC113 = 'N' THEN
               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C110|'||LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0')||'|'||'NOTAS FISCAIS DE PRODUTOR RURAL REFERENCIADAS A NF: '||C_REGC100.NRNOTAFISC||'|', P_NRSEQARQMAG);
               V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
               V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
               VALUES
                  ('0450', V_SEQUPROD, LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0'), 'NOTAS FISCAIS DE PRODUTOR RURAL REFERENCIADAS A NF: '||C_REGC100.NRNOTAFISC);
               V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
               V_SEQADIC    := V_SEQADIC +1;
            END IF;
            V_GERAC113 := 'S';

            /* verifica se o cnpj est cadastrado no sistema - o registro 0150  obrigatrio */
            IF C_REGC113.CDFORNECED IS NOT NULL THEN

               /* CODIGO DO PARTICIPANTE */
               SELECT MAX(CDCHAVEREG)
                 INTO V_COD_PAR
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC113.CDFORNECED
                  AND CDREGISTRO = '0150';

               IF (V_COD_PAR IS NULL) AND (C_REGC113.CDFORNECED IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                  VALUES
                    ('0150', V_SEQUPROD, C_REGC113.CDFORNECED);
               END IF;
            END IF;
            V_CDFORNECED := '';

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC113.DSREG_C113, P_NRSEQARQMAG);
            V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
         END LOOP;

         /*QUANDO A OPERAO FOR A PRAZO PARA AS ENTRADAS NOS MODELOS 1 E 1A DEVER SER GERADOS OS REGISTROS REFERENTES A FATURA*/
         IF (C_REGC100.CDMODDOCFISC IN ('01','1A')) AND (C_REGC100.QTDEPARC > 1) THEN
            /*REGISTRO C140*/
            FOR C_REGC140 IN (SELECT '|C140'                                                               ||'|'||
                                     DECODE(N.IDENTRSAIDOP,'E','1','S','0')                                ||'|'||
                                     DECODE(F.IDTPTITULOCRED,'XX','',F.IDTPTITULOCRED)                     ||'|'||
                                     TRIM(DECODE(F.IDTPTITULOCRED,'99',F.DSTPTITULOCRED,''))               ||'|'||
                                     LTRIM(N.NRNOTAFISC,'0')                                               ||'|'||
                                     LPAD(RTRIM(TO_CHAR(C_REGC100.QTDEPARC)),2,'0')                        ||'|'||
                                     REPLACE(LTRIM(TO_CHAR(SUM(C.VRORIGPAG),'999999999990.00')), '.', ',') ||'|' AS DSREG_C140
                                FROM NOTAFISCAL N, FORNECEDOR F, CONTAPAGAR C
                               WHERE N.CDFILIAL   = C_REGC100.CDFILIAL
                                 AND N.NRLANCTONF = C_REGC100.NRLANCTONF
                                 AND N.CDFORNECED = F.CDFORNECED
                                 AND N.CDFILIAL   = C.CDFILIAL
                                 AND N.NRLANCTONF = C.NRLANCTONF
                               GROUP BY N.IDENTRSAIDOP, F.IDTPTITULOCRED, F.DSTPTITULOCRED,
                                     N.NRNOTAFISC, C_REGC100.QTDEPARC) LOOP

               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC140.DSREG_C140, P_NRSEQARQMAG);
               V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
            END LOOP;

            /*REGISTRO C141*/
            FOR C_REGC141 IN (SELECT '|C141'                                                               ||'|'||
                                     LPAD(RTRIM(TO_CHAR(C.NRPARCELAPAG)),2,'0')                             ||'|'||
                                     TO_CHAR(C.DTORIGVENPAG,'DDMMYYYY')                                    ||'|'||
                                     REPLACE(LTRIM(TO_CHAR(SUM(C.VRORIGPAG),'999999999990.00')), '.', ',') ||'|' AS DSREG_C141
                                FROM CONTAPAGAR C
                               WHERE C.CDFILIAL   = C_REGC100.CDFILIAL
                                 AND C.NRLANCTONF = C_REGC100.NRLANCTONF
                               GROUP BY C.NRPARCELAPAG, C.DTORIGVENPAG
                               ORDER BY C.NRPARCELAPAG) LOOP

               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC141.DSREG_C141, P_NRSEQARQMAG);
               V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
            END LOOP;
         END IF;

         BEGIN
            SELECT IDATUESTTPOP
              INTO V_IDATUESTTPOP
              FROM TIPOOPERAC
             WHERE CDTIPOOPER   = C_REGC100.CDTIPOOPER
               AND IDENTRSAIDOP = C_REGC100.IDENTRSAIDOP;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_IDATUESTTPOP := 'N';
         END;

         /*REGISTRO C170*/
         FOR C_REGC170 IN (SELECT COD_ITEM       || '|' ||
                                  DESCR_COMPL    || '|' ||
                                  QTD            || '|' AS PARTE1,
                                                    '|' ||
                                  VL_ITEM        || '|' ||
                                  VL_DESC        || '|' ||
                                  IND_MOV        || '|' ||
                                  CST_ICMS       || '|' ||
                                  CFOP           || '|' ||
                                  CFOP           || '|' || -- natureza da operacao campo 12
                                  VL_BC_ICMS     || '|' ||
                                  ALIQ_ICMS      || '|' ||
                                  VL_ICMS        || '|' ||
                                  VL_BC_ICMS_ST  || '|' || --16
                                  ALIQ_ST        || '|' || --17
                                  VL_ICMS_ST     || '|' || --18
                                  ''             || '|' || -- indicador de apurao do IPI CAMPO 19
                                  CST_IPI        || '|' || -- cst ipi campo 20
                                  '' 		        || '|' || -- Cdigo enquadramento IPI campo 21
                                  VL_BC_IPI      || '|' || --22
                                  ALIQ_IPI       || '|' || --23
                                  VL_IPI         || '|' || --24
                                  CST_PIS        || '|' || -- cst pis   campo 25
                                  VL_BC_PIS      || '|' ||
                                  ALIQ_PIS       || '|' ||
                                  ''   		    || '|' || -- quantidade base de calculo
                                  ''             || '|' || -- aliquota pis quantidade
                                  VL_PIS         || '|' ||
                                  CST_COFINS     || '|' || -- cst cofins campo 31
                                  VL_BC_COFINS   || '|' ||
                                  ALIQ_COFINS    || '|' ||
                                  ''	          || '|' || -- quantidade base de calculo
                                  ''             || '|' || -- aliquota cofins quantidade
                                  VL_COFINS      || '|' ||
                                  COD_CTA        || '|' ||
                                  CASE WHEN P_VERSAO >= '013' THEN VL_ABAT_NT || '|' ELSE '' END AS ARQ_C170,  -- codigo da conta analitica contabil deb/cred
                                  CDPRODUTO, CFOP AS CDFISCOPERIT, DSCDFISOPEIT, CDCLASFISC, COD_CTA, SGUNIDADE, VRFATOCONV, CDEXPPROD, IDPRODEST
                             FROM (/* NOTAS NO ELETRNICAS COM E SEM CARGA TRIBUTRIA */
                                  SELECT NVL(PA.CDARVPROD,PR.CDARVPROD) AS COD_ITEM,
                                         DECODE(C_REGC100.IDENTRSAIDOP, 'E', TRIM(RETIRA_CARACTER_ESPECIAL(IT.DSPRODEMIS, 'S'))) AS DESCR_COMPL,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRTOTAITEM,0),2)+ROUND(NVL(VRENCARGOIMPXML,0),2), '999999999990.00')), '.', ',') AS VL_ITEM,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                         DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                         LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0') AS CST_ICMS,
                                         IP.CDFISCOPERIT AS CFOP,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                          THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'B','I','1'),0)
                                                                          ELSE 0 END +
                                                                     DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'B','C','1'),0))), 2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT,'1',DECODE(DT.NRSEQDETITMAPA,'',IP.VRALIQITEM+NVL(IP.VRADICALIQFECP,0),0),0),2),'999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                          THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','I','1'),0)
                                                                          ELSE 0 END +
                                                                     NVL(VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, '00', 'I', '1', '1'),0) +
                                                                     DECODE(V_IDTPCARGATRIB,'O',0,DECODE(C_REGC100.IDENTRSAIDOP,'S',NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','C','1'),0),
                                                                                                                                    DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','C','1'),0)))),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_IPI)  AS CST_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                         CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, NVL(PA.CDPRODUTO,PR.CDPRODUTO), C_REGC100.CDTIPOOPER, C_REGC100.FILIAL) AS COD_CTA,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT+NVL(IP.VRADICFECP,0),0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                         NVL(PA.CDPRODUTO,PR.CDPRODUTO) AS CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC, PR.SGUNIDADE, PR.VRFATOCONV,
                                         '' AS CDEXPPROD, DECODE(PA.CDPRODUTO,PR.CDPRODUTO,'S','N') AS IDPRODEST
                                    FROM ITEMPRODUTO IT, PRODUTO PR, PRODUTO PA, ITEMPROIMPOS IP, IMPOSTO IM, DETITMAPARECUP DT
                                   WHERE IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND PR.CDPRODESTO    = PA.CDPRODUTO(+)
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.CDMODDOCFISC NOT IN ('55','65')
                                     AND (ROUND(IT.QTITEMPROD,3) > 0 OR C_REGC100.SITU_DOC IN ('06','07','08'))
                                     AND IP.CDFILIAL      = DT.CDFILIAL(+)
                                     AND IP.NRLANCTONF    = DT.NRLANCTONF(+)
                                     AND IP.CDIMPOSTO     = DT.CDIMPOSTO(+)
                                     AND IP.NRSEQITPROD   = DT.NRSEQITPROD(+)
                                     AND IP.NRITPROIMPOS  = DT.NRITPROIMPOS(+)
                                   UNION ALL
                                  /*NOTAS DE ENTRADA ELETRNICAS COM E SEM CARGA TRIBUTRIA */
                                  SELECT NVL(PA.CDARVPROD,PR.CDARVPROD) AS COD_ITEM,
                                         DECODE(C_REGC100.IDENTRSAIDOP, 'E', TRIM(RETIRA_CARACTER_ESPECIAL(IT.DSPRODEMIS, 'S'))) AS DESCR_COMPL,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRTOTAITEM,0),2)+ROUND(NVL(VRENCARGOIMPXML,0),2), '999999999990.00')), '.', ',') AS VL_ITEM,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                         DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                         LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0') AS CST_ICMS,
                                         IP.CDFISCOPERIT AS CFOP,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                          THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'B','I','1'),0)
                                                                          ELSE 0 END +
                                                                     DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'B','C','1'),0))),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', DECODE(DT.NRSEQDETITMAPA,'',IP.VRALIQITEM+NVL(IP.VRADICALIQFECP,0),0),0),2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                          THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','I','1'),0)
                                                                          ELSE 0 END +
                                                                     NVL(VALOR_FECP_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'00','I','1','1'),0) +
                                                                     DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','C','1'),0))),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_IPI) AS CST_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                         CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, NVL(PA.CDPRODUTO,PR.CDPRODUTO), C_REGC100.CDTIPOOPER, C_REGC100.FILIAL) AS COD_CTA,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT+NVL(IP.VRADICFECP,0),0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                         NVL(PA.CDPRODUTO,PR.CDPRODUTO) AS CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC, PR.SGUNIDADE, PR.VRFATOCONV,
                                         (SELECT CP.CDEXPPROD FROM CODEXPPROD CP WHERE CP.CDLIVROMAG = P_LIVROMAG AND CP.CDPRODUTO = IT.CDPRODUTO) AS CDEXPPROD,
                                         DECODE(PA.CDPRODUTO,PR.CDPRODUTO,'S','N') AS IDPRODEST
                                    FROM ITEMPRODUTO IT, PRODUTO PR, PRODUTO PA, ITEMPROIMPOS IP, IMPOSTO IM, DETITMAPARECUP DT
                                   WHERE IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND PR.CDPRODESTO    = PA.CDPRODUTO(+)
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.IDENTRSAIDOP = 'E'
                                     AND C_REGC100.CDMODDOCFISC = '55'
                                     AND C_REGC100.IDSTATUSNFE <> 'A'
                                     AND (ROUND(IT.QTITEMPROD,3) > 0 OR C_REGC100.SITU_DOC IN ('06','07','08'))
                                     AND IP.CDFILIAL      = DT.CDFILIAL(+)
                                     AND IP.NRLANCTONF    = DT.NRLANCTONF(+)
                                     AND IP.CDIMPOSTO     = DT.CDIMPOSTO(+)
                                     AND IP.NRSEQITPROD   = DT.NRSEQITPROD(+)
                                     AND IP.NRITPROIMPOS  = DT.NRITPROIMPOS(+)
                                   UNION ALL
                                   /*NOTAS DE SADA ELETRNICAS COM E SEM CARGA TRIBUTRIA - COM CDIGO DE INFORMAO ADICIONAL PARA O ESTADO DE PE */
                                  SELECT NVL(PA.CDARVPROD,PR.CDARVPROD) AS COD_ITEM,
                                         ' ' AS DESCR_COMPL,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRTOTAITEM,0),2)+ROUND(NVL(VRENCARGOIMPXML,0),2), '999999999990.00')), '.', ',') AS VL_ITEM,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                         DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                         LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0') AS CST_ICMS,
                                         IP.CDFISCOPERIT AS CFOP,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                          THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'B','I','1'),0)
                                                                          ELSE 0 END +
                                                                     DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'B','C','1'),0))),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', DECODE(DT.NRSEQDETITMAPA,'',IP.VRALIQITEM+NVL(IP.VRADICALIQFECP,0),0), 0),2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                          THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','I','1'),0)
                                                                          ELSE 0 END +
                                                                     NVL(VALOR_FECP_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'00','I','1','1'),0) +
                                                                     DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','C','1'),0))),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_IPI) AS CST_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                         CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, NVL(PA.CDPRODUTO,PR.CDPRODUTO), C_REGC100.CDTIPOOPER, C_REGC100.FILIAL) AS COD_CTA,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT,0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                         NVL(PA.CDPRODUTO,PR.CDPRODUTO) AS CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC, PR.SGUNIDADE, PR.VRFATOCONV,
                                         CP.CDEXPPROD, DECODE(PA.CDPRODUTO,PR.CDPRODUTO,'S','N') AS IDPRODEST
                                    FROM ITEMPRODUTO IT, PRODUTO PR, PRODUTO PA, ITEMPROIMPOS IP, IMPOSTO IM, DETITMAPARECUP DT, CODEXPPROD CP
                                   WHERE V_SGESTADO       = 'PE'
                                     AND IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND PR.CDPRODESTO    = PA.CDPRODUTO(+)
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.IDENTRSAIDOP = 'S'
                                     AND C_REGC100.CDMODDOCFISC = '55'
                                     AND (ROUND(IT.QTITEMPROD,3) > 0 OR C_REGC100.SITU_DOC IN ('06','07','08'))
                                     AND IP.CDFILIAL      = DT.CDFILIAL(+)
                                     AND IP.NRLANCTONF    = DT.NRLANCTONF(+)
                                     AND IP.CDIMPOSTO     = DT.CDIMPOSTO(+)
                                     AND IP.NRSEQITPROD   = DT.NRSEQITPROD(+)
                                     AND IP.NRITPROIMPOS  = DT.NRITPROIMPOS(+)
                                     AND CP.CDLIVROMAG    = P_LIVROMAG
                                     AND CP.CDPRODUTO     = IT.CDPRODUTO
                                     AND CP.CDEXPPROD     IS NOT NULL)) LOOP

            /* CODIGO DO CFOP */
            SELECT MAX(CDCHAVEREG)
              INTO V_COD_NAT
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.CDFISCOPERIT
               AND CDREGISTRO = '0400';

            IF (V_COD_NAT IS NULL) AND (C_REGC170.CDFISCOPERIT IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1, CDCAMPO2)
               VALUES
                 ('0400', V_SEQUPROD, C_REGC170.CDFISCOPERIT, C_REGC170.DSCDFISOPEIT, C_REGC100.IDENTRSAIDOP);
            END IF;
            V_COD_NAT := NULL;

            V_UNIDADE := C_REGC170.SGUNIDADE||CASE WHEN C_REGC170.IDPRODEST = 'N' THEN CONT_FATCONVERSAO_SPED(C_REGC170.SGUNIDADE, C_REGC170.VRFATOCONV) ELSE '' END;

            /* UNIDADE DE MEDIDA */
            SELECT MAX(CDCHAVEREG)
              INTO V_UNID
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = V_UNIDADE
               AND CDREGISTRO = '0190';

            IF (V_UNID IS NULL) AND (V_UNIDADE IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCAMPO1, CDCAMPO2, CDCAMPO3, CDCHAVEREG)
               VALUES
                 ('0190', V_SEQUPROD, C_REGC170.SGUNIDADE, C_REGC170.VRFATOCONV, SUBSTR(V_UNIDADE,LENGTH(C_REGC170.SGUNIDADE)+1,LENGTH(V_UNIDADE)), V_UNIDADE);
            END IF;
            V_UNID := NULL;

            /* CODIGO DO PRODUTO */
            SELECT MAX(CDCHAVEREG)
              INTO V_PRODUTO
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.CDPRODUTO
               AND CDREGISTRO = '0200';
            IF (V_PRODUTO IS NULL) AND (C_REGC170.CDPRODUTO IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
               VALUES
                 ('0200', V_SEQUPROD, C_REGC170.CDPRODUTO, C_REGC170.CDCLASFISC);
            END IF;
            V_PRODUTO := NULL;

            /* PLANO DE CONTAS REFERENCIAL */
            SELECT MAX(CDCHAVEREG)
              INTO V_CONTCTBL
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.COD_CTA
               AND CDREGISTRO = '0500';

            IF (V_CONTCTBL IS NULL) AND (C_REGC170.COD_CTA IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                  ('0500', V_SEQUPROD, C_REGC170.COD_CTA);
            END IF;
            V_CONTCTBL := NULL;

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C170'|| '|' ||V_SEQUENCIAL|| '|' || C_REGC170.PARTE1 ||V_UNIDADE||C_REGC170.ARQ_C170, P_NRSEQARQMAG);
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER(RTRIM(V_SEQUENCIAL))+1)), 3,'0');
            V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;

            IF (V_SGESTADO = 'PE') AND (C_REGC170.CDEXPPROD IS NOT NULL) AND (P_VERSAO >= '013') THEN
               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C177'|| '|' || C_REGC170.CDEXPPROD || '|', P_NRSEQARQMAG);
               V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
            END IF;
         END LOOP;

         IF P_VERSAO NOT IN ( '001', '002') THEN
            /*REGISTRO C190*/
            /* PASSADO O CSOSN APENAS QUANDO A EMPRESA  DO SIMPLES E O FORNECEDOR TAMBM, CASO A EMPRESA NAO SEJA DO SIMPLES, MAIS O FORNECEDOR
            SIM, MANDA O CST MESMO. NESTE CASO A EMPRESA NAO  SIMPLES */
            FOR C_REGC190 IN(SELECT ('|C190'      || '|' ||
                                     T.CST_ICMS   || '|' ||
                                     T.CFOP       || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.ALIQ_ICMS,0),2), '999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.VL_OPR,0),2),    '999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.VL_BC_ICMS,0),2),'999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.VL_ICMS,0),2),   '999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.BC_ST,0),2),     '999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.IMP_ST,0),2),    '999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.VL_RED_BC,0),2), '999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VL_IPI,0),2),      '999999999990.00')), '.', ',') || '|' ||
                                     '' || '|') ARQ_C190,
                                     T.VL_ICMS, T.CFOP AS COD_NAT, T.CST_ICMS, T.ALIQ_ICMS
                               FROM (/*NOTAS DE SAIDA COM E SEM CARGA TRIBUTRIA*/
                                     SELECT I.CDSITUTRIBIT AS CST_ICMS,
                                            I.CDFISCOPERIT AS CFOP,
                                            CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                 THEN DECODE(I.CDFISCALIT,'1',I.VRALIQITEM+NVL(VRADICALIQFECP,0),0)
                                                 ELSE 0 END AS ALIQ_ICMS,
                                            SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                            SUM(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                     THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'B','I','1'),0) +
                                                          DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'B','C','1'),0)))
                                                     ELSE 0 END) AS VL_BC_ICMS,
                                            SUM(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                     THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'I','I','1'),0) +
                                                          NVL(VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'00','I','1','1'),0) +
                                                          DECODE(V_IDTPCARGATRIB,'O',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'I','C','1'),0))
                                                     ELSE 0 END) AS VL_ICMS,
                                            NVL(SUM(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                         THEN DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL),0)
                                                         ELSE 0 END),0) AS VL_RED_BC,
                                            SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                   FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                  WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                        (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                        (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                        (IT.NRITPROIMPOS = '1'                  ) AND
                                                        (IT.CDFISCALIT   = '1'                  ) AND
                                                        (IM.CDIMPOSTONFE = '10'                 ) AND
                                                        I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                            '' AS COD_OBS,
                                            SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                            SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                       FROM ITEMPROIMPOS I, ITEMPRODUTO P, IMPOSTO IM, DETITMAPARECUP DT
                                      WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                        AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                        AND C_REGC100.IDENTRSAIDOP = 'S'
                                        AND C_REGC100.CDMODDOCFISC <> '65'
                                        AND I.NRITPROIMPOS  = '1'
                                        AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                        AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                        AND I.CDFILIAL      = DT.CDFILIAL(+)
                                        AND I.NRLANCTONF    = DT.NRLANCTONF(+)
                                        AND I.CDIMPOSTO     = DT.CDIMPOSTO(+)
                                        AND I.NRSEQITPROD   = DT.NRSEQITPROD(+)
                                        AND I.NRITPROIMPOS  = DT.NRITPROIMPOS(+)
                                        AND I.CDFILIAL      = P.CDFILIAL
                                        AND I.NRLANCTONF    = P.NRLANCTONF
                                        AND I.NRSEQITPROD   = P.NRSEQITPROD
                                        AND (ROUND(P.QTITEMPROD,3) > 0 OR C_REGC100.SITU_DOC IN ('06','07','08'))
                                      GROUP BY I.CDSITUTRIBIT, I.CDFISCOPERIT, CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                                    THEN DECODE(I.CDFISCALIT,'1',I.VRALIQITEM+NVL(I.VRADICALIQFECP,0),0)
                                                                                    ELSE 0 END
                                      UNION ALL
                                     /*NOTAS DE ENTRADA COM E SEM CARGA TRIBUTRIA*/
                                     SELECT I.CDSITUTRIBIT AS CST_ICMS,
                                            I.CDFISCOPERIT AS CFOP,
                                            CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                 THEN DECODE(I.CDFISCALIT,'1',I.VRALIQITEM+NVL(I.VRADICALIQFECP,0),0)
                                                 ELSE 0 END AS ALIQ_ICMS,
                                            SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                            SUM(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                     THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'B','I','1'),0) +
                                                          DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'B','C','1'),0)))
                                                     ELSE 0 END) AS VL_BC_ICMS,
                                            SUM(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                     THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'I','I','1'),0) +
                                                          NVL(VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'00','I','1','1'),0) +
                                                          DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'I','C','1'),0)))
                                                     ELSE 0 END) AS VL_ICMS,
                                            NVL(SUM(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                         THEN DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL),0)
                                                         ELSE 0 END),0) AS VL_RED_BC,
                                            SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                   FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                  WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                        (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                        (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                        (IT.NRITPROIMPOS = '1'                  ) AND
                                                        (IT.CDFISCALIT   = '1'                  ) AND
                                                        (IM.CDIMPOSTONFE = '10'                 ) AND
                                                        I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                            '' AS COD_OBS,
                                            SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                            SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                       FROM ITEMPROIMPOS I, ITEMPRODUTO P, IMPOSTO IM, DETITMAPARECUP DT
                                      WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                        AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                        AND C_REGC100.IDENTRSAIDOP = 'E'
                                        AND C_REGC100.CDMODDOCFISC <> '65'
                                        AND I.NRITPROIMPOS  = '1'
                                        AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                        AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                        AND I.CDFILIAL      = DT.CDFILIAL(+)
                                        AND I.NRLANCTONF    = DT.NRLANCTONF(+)
                                        AND I.CDIMPOSTO     = DT.CDIMPOSTO(+)
                                        AND I.NRSEQITPROD   = DT.NRSEQITPROD(+)
                                        AND I.NRITPROIMPOS  = DT.NRITPROIMPOS(+)
                                        AND I.CDFILIAL      = P.CDFILIAL
                                        AND I.NRLANCTONF    = P.NRLANCTONF
                                        AND I.NRSEQITPROD   = P.NRSEQITPROD
                                        AND (ROUND(P.QTITEMPROD,3) > 0 OR C_REGC100.SITU_DOC IN ('06','07','08'))
                                      GROUP BY I.CDSITUTRIBIT, I.CDFISCOPERIT, CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                                    THEN DECODE(I.CDFISCALIT,'1',I.VRALIQITEM+NVL(I.VRADICALIQFECP,0),0)
                                                                                    ELSE 0 END
                                      UNION ALL
                                     /*NFC-e*/
                                     SELECT NVL(LPAD(CDCSTPRODI,3,'0'), (CASE WHEN IM.IDTPIMPOSFIS = 'T' THEN '000'
                                                                              WHEN IM.IDTPIMPOSFIS = 'I' THEN '040'
                                                                              WHEN IM.IDTPIMPOSFIS = 'F' THEN '060'
                                                                              WHEN IM.IDTPIMPOSFIS = 'N' THEN '041' END)) AS CST_ICMS,
                                            NVL(CDCFOPPROD, '5102') AS CFOP,
                                            ROUND(IP.VRPEALPRODIT,2) AS ALIQ_ICMS,
                                            SUM(TRUNC((IT.QTPRODVEND  * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0),2)) AS VL_OPR,
                                            SUM(CASE WHEN IM.IDTPIMPOSFIS = 'T' AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                                     THEN CASE WHEN IP.VRPRBCREDUICMS > 0
                                                               THEN IP.VRBASECALCREDUZ
                                                               ELSE TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0),2) END
                                                     ELSE 0 END) AS VL_BC_ICMS,
                                            SUM(CASE WHEN IM.IDTPIMPOSFIS = 'T' AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                                     THEN CASE WHEN IP.VRPRBCREDUICMS > 0
                                                               THEN IP.VRIMPOPRODREDUZ
                                                               ELSE TRUNC(VRIMPOPRODIT,2) END
                                                     ELSE 0 END) AS VL_ICMS,
                                            SUM(DECODE(IP.VRPRBCREDUICMS,0,0,IP.VRBCREDUZICMS)) AS VL_RED_BC,
                                            0 AS VL_IPI,
                                            '' AS COD_OBS,
                                            0 AS BC_ST,
                                            0 AS IMP_ST
                                       FROM ITEMVENDA IT, ITVENDAIMPOS IP, IMPOSTO IM
                                      WHERE IT.CDFILIAL     = C_REGC100.CDFILIAL
                                        AND IT.CDCAIXA      = C_REGC100.CDCAIXA
                                        AND IT.NRSEQVENDA   = C_REGC100.NRLANCTONF
                                        AND IT.CDFILIAL     = IP.CDFILIAL
                                        AND IT.CDCAIXA      = IP.CDCAIXA
                                        AND IT.NRSEQUITVEND = IP.NRSEQUITVEND
                                        AND IT.NRSEQVENDA   = IP.NRSEQVENDA
                                        AND IP.CDIMPOSTO    = IM.CDIMPOSTO
                                        AND NVL(C_REGC100.IDSTATUS,'A') <>  'C'
                                      GROUP BY NVL(LPAD(CDCSTPRODI,3,'0'), (CASE WHEN IM.IDTPIMPOSFIS = 'T' THEN '000'
                                                                 WHEN IM.IDTPIMPOSFIS = 'I' THEN '040'
                                                                 WHEN IM.IDTPIMPOSFIS = 'F' THEN '060'
                                                                 WHEN IM.IDTPIMPOSFIS = 'N' THEN '041' END)),
                                               NVL(CDCFOPPROD, '5102'), IP.VRPEALPRODIT) T) LOOP
               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC190.ARQ_C190, P_NRSEQARQMAG);
               V_CONTREGC := NVL(V_CONTREGC,0) + 1;

               IF P_VERSAO >= '013' THEN
                  FOR C_REGC191 IN (SELECT '|C191'         || '|' ||
                                           REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN SUBSTR(IT.CDSITUTRIBIT,2,2) IN ('00','10','20','51','70','90') AND IM.CDIMPOSTONFE = '00'
                                                THEN ROUND(IT.VRADICFECP,2)
                                                ELSE 0 END),'999999999990.00')), '.', ',') || '|' ||
                                           REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN SUBSTR(IT.CDSITUTRIBIT,2,2) IN ('10','30','70','90') AND IM.CDIMPOSTONFE = '80'
                                                THEN ROUND(IT.VRADICFECP,2)
                                                ELSE 0 END),'999999999990.00')), '.', ',') || '|' ||
                                           REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN SUBSTR(IT.CDSITUTRIBIT,2,2) IN ('60')
                                                THEN ROUND(IT.VRADICFECP,2)
                                                ELSE 0 END),'999999999990.00')), '.', ',') || '|' AS ARQ_C191, IT.CDFISCOPERIT
                                      FROM ITEMPROIMPOS IT, ITEMPROIMPOS II, IMPOSTO IM, PARAMESTSPED PE
                                     WHERE IT.CDFILIAL      = C_REGC100.CDFILIAL
                                       AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                       AND IT.CDFISCOPERIT  = C_REGC190.COD_NAT
                                       AND IT.CDSITUTRIBIT  = C_REGC190.CST_ICMS
                                       AND IT.VRALIQITEM    = C_REGC190.ALIQ_ICMS
                                       AND IT.NRITPROIMPOS  = '1'
                                       AND IT.CDFILIAL      = II.CDFILIAL
                                       AND IT.NRLANCTONF    = II.NRLANCTONF
                                       AND IT.NRSEQITPROD   = II.NRSEQITPROD
                                       AND II.CDFISCOPERIT  = C_REGC190.COD_NAT
                                       AND II.CDSITUTRIBIT  = C_REGC190.CST_ICMS
                                       AND II.CDIMPOSTO     = IM.CDIMPOSTO
                                       AND IM.CDIMPOSTONFE  IN ('00','80')
                                       AND II.VRADICFECP    > 0
                                       AND PE.CDEMPRESA     = P_CDEMPRESA
                                       AND PE.CDINSCESTA    = P_CDINSCESTA
                                       AND PE.IDFECPC191    = 'S'
                                     GROUP BY IT.CDFISCOPERIT) LOOP
                      INSERT INTO ARQMAGNETICO
                         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                      VALUES
                         ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC191.ARQ_C191, P_NRSEQARQMAG);
                      V_CONTREGC := NVL(V_CONTREGC,0) + 1;
                  END LOOP;
               END IF;
            END LOOP;
         END IF;

         V_C195 := 'N';
         /* GERACAO DOS REGISTROS COM DIFERENCIAL DE ALIQUOTA E ANTECIPAO DE ICMS DO ARROZ*/
         FOR C_REGC197 IN (SELECT COD_AJ, DESCR_COMPL_AJ, COD_ITEM, IDTIPOITMAPR,
                                  REPLACE(LTRIM(TO_CHAR(ROUND(VL_BC_ICMS,2),'999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                  REPLACE(LTRIM(TO_CHAR(ROUND(ALIQ_ICMS+NVL(ALIQ_FECP,0),2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                  REPLACE(LTRIM(TO_CHAR(ROUND(VL_ICMS,2),   '999999999990.00')), '.', ',') AS VL_ICMS,
                                  REPLACE(LTRIM(TO_CHAR(ROUND(VL_OUTROS,2), '999999999990.00')), '.', ',') AS VL_OUTROS,
                                  CDCFOPPADRAO, CDCLASFISC, CDPRODUTO
                             FROM (SELECT IM.CDAJUSTEITMAPA AS COD_AJ, IM.DSITEMMAPR AS DESCR_COMPL_AJ, '' AS COD_ITEM,
                                          0 AS VL_BC_ICMS, 0 AS ALIQ_ICMS, 0 AS ALIQ_FECP,
                                          IM.VRITEMMAPR AS VL_ICMS,
                                          IM.VROUTROSITMAPR AS VL_OUTROS, IM.IDTIPOITMAPR,
                                          IM.CDCFOPPADRAO AS CDCFOPPADRAO, '' AS CDCLASFISC, '' AS CDPRODUTO
                                     FROM ITMAPARECUP IM
                                    WHERE IM.CDFILIAL     = C_REGC100.CDFILIAL
                                      AND IM.NRLANCTONF   = C_REGC100.NRLANCTONF
                                      AND C_REGC100.CDMODDOCFISC <> '65'
                                      AND IM.IDCOMPOEC197 = 'D'
                                    UNION ALL
                                   SELECT IM.CDAJUSTEITMAPA AS COD_AJ, IM.DSITEMMAPR AS DESCR_COMPL_AJ,
                                          NVL(PA.CDARVPROD,PR.CDARVPROD) AS COD_ITEM,
                                          SUM(DECODE(DT.IDSUBSTSOLIDST,'S',IT.VRBASECALCIT,DECODE(IT.CDFISCALIT,'1',IT.VRBASECALCIT,0))) AS VL_BC_ICMS,
                                          DECODE(DT.IDSUBSTSOLIDST,'S',IT.VRALIQITEM,DECODE(IT.CDFISCALIT,'1',IT.VRALIQITEM,0)) AS ALIQ_ICMS,
                                          DECODE(DT.IDSUBSTSOLIDST,'S',IT.VRADICALIQFECP,DECODE(IT.CDFISCALIT,'1',IT.VRADICALIQFECP,0)) AS ALIQ_FECP,
                                          SUM(ROUND(DECODE(DT.IDSUBSTSOLIDST,'S',DT.VRIMPOSTOIT,IT.VRIMPOSTOIT+NVL(IT.VRADICFECP,0)),2)) AS VL_ICMS,
                                          SUM(ROUND(IM.VROUTROSITMAPR,2)) AS VL_OUTROS, IM.IDTIPOITMAPR, '' AS CDCFOPPADRAO, IP.CDPRODNCMTRANS AS CDCLASFISC,
                                          NVL(PA.CDPRODUTO,PR.CDPRODUTO) AS CDPRODUTO
                                     FROM ITMAPARECUP IM, IMPOSTO IM, ITEMPROIMPOS IT, DETITMAPARECUP DT, PRODUTO PA, PRODUTO PR, ITEMPRODUTO IP
                                    WHERE IM.CDFILIAL     = C_REGC100.CDFILIAL
                                      AND IM.NRLANCTONF   = C_REGC100.NRLANCTONF
                                      AND C_REGC100.CDMODDOCFISC <> '65'
                                      AND IM.IDCOMPOEC197 = 'I'
                                      AND IM.CDFILIAL     = IT.CDFILIAL
                                      AND IM.NRLANCTONF   = IT.NRLANCTONF
                                      AND IT.CDIMPOSTO    = IM.CDIMPOSTO
                                      AND IM.CDIMPOSTONFE IN ('00','80')
                                      AND IT.CDIMPOSTO    = DT.CDIMPOSTO
                                      AND IM.NRSEQUMAPAPU = DT.NRSEQUMAPAPU
                                      AND IM.IDTIPOITMAPR = DT.IDTIPOITMAPR
                                      AND IM.NRSEQITMAPR  = DT.NRSEQITMAPR
                                      AND IT.CDFILIAL     = DT.CDFILIAL
                                      AND IT.NRLANCTONF   = DT.NRLANCTONF
                                      AND IT.NRSEQITPROD  = DT.NRSEQITPROD
                                      AND IT.NRITPROIMPOS = DT.NRITPROIMPOS
                                      AND IT.CDFILIAL     = IP.CDFILIAL
                                      AND IT.NRLANCTONF   = IP.NRLANCTONF
                                      AND IT.NRSEQITPROD  = IP.NRSEQITPROD
                                      AND DT.CDFILIAL     = IP.CDFILIAL
                                      AND DT.NRLANCTONF   = IP.NRLANCTONF
                                      AND DT.NRSEQITPROD  = IP.NRSEQITPROD
                                      AND PR.CDPRODUTO    = IP.CDPRODUTO
                                      AND PR.CDPRODESTO   = PA.CDPRODUTO(+)
                                      AND DT.IDTIPOITMAPR <> 'VI'
                                      AND ((IT.NRITPROIMPOS = '1' AND IT.CDFISCALIT = '1') OR (IT.NRITPROIMPOS = '3') OR (DT.IDSUBSTSOLIDST = 'S'))
                                    GROUP BY IM.CDAJUSTEITMAPA, IM.DSITEMMAPR, IT.CDFISCALIT, IT.VRALIQITEM, IT.VRADICALIQFECP, DT.IDSUBSTSOLIDST,
                                          NVL(PA.CDARVPROD,PR.CDARVPROD), IM.IDTIPOITMAPR, IP.CDPRODNCMTRANS, NVL(PA.CDPRODUTO,PR.CDPRODUTO)
                                    UNION ALL
                                   SELECT IM.CDAJUSTEITMAPA AS COD_AJ, IM.DSITEMMAPR AS DESCR_COMPL_AJ,
                                          NVL(PA.CDARVPROD,PR.CDARVPROD) AS COD_ITEM,
                                          SUM(DT.VROUTBASE) AS VL_BC_ICMS,
                                          NVL(DT.VROUTALIQ,0) AS ALIQ_ICMS, 0 AS ALIQ_FECP,
                                          0 AS VL_ICMS,
                                          SUM(ROUND(DT.VROUTROSIMPIT,2)) AS VL_OUTROS, IM.IDTIPOITMAPR,
                                          IM.CDCFOPPADRAO, IP.CDPRODNCMTRANS AS CDCLASFISC,
                                          NVL(PA.CDPRODUTO,PR.CDPRODUTO) AS CDPRODUTO
                                     FROM ITMAPARECUP IM, DETITMAPARECUP DT, PRODUTO PA, PRODUTO PR, ITEMPRODUTO IP
                                    WHERE IM.CDFILIAL     = C_REGC100.CDFILIAL
                                      AND IM.NRLANCTONF   = C_REGC100.NRLANCTONF
                                      AND C_REGC100.CDMODDOCFISC <> '65'
                                      AND IM.IDCOMPOEC197 = 'I'
                                      AND IM.IDTIPOITMAPR = 'VI'
                                      AND IM.NRSEQUMAPAPU = DT.NRSEQUMAPAPU
                                      AND IM.IDTIPOITMAPR = DT.IDTIPOITMAPR
                                      AND IM.NRSEQITMAPR  = DT.NRSEQITMAPR
                                      AND DT.CDFILIAL     = IP.CDFILIAL
                                      AND DT.NRLANCTONF   = IP.NRLANCTONF
                                      AND DT.NRSEQITPROD  = IP.NRSEQITPROD
                                      AND PR.CDPRODUTO    = IP.CDPRODUTO
                                      AND PR.CDPRODESTO   = PA.CDPRODUTO(+)
                                    GROUP BY IM.CDAJUSTEITMAPA, IM.DSITEMMAPR,
                                          NVL(PA.CDARVPROD,PR.CDARVPROD), DT.VROUTALIQ,
                                          IM.IDTIPOITMAPR, IM.CDCFOPPADRAO, IP.CDPRODNCMTRANS,
                                          NVL(PA.CDPRODUTO,PR.CDPRODUTO)
                                    UNION ALL
                                   SELECT IM.CDAJUSTEITMAPA AS COD_AJ, IM.DSITEMMAPR AS DESCR_COMPL_AJ,
                                          NVL(PA.CDARVPROD,PR.CDARVPROD) AS COD_ITEM,
                                          SUM(DT.VROUTBASE) AS VL_BC_ICMS,
                                          NVL(DT.VROUTALIQ,0) AS ALIQ_ICMS, 0 AS ALIQ_FECP,
                                          0 AS VL_ICMS,
                                          SUM(ROUND(DT.VROUTROSIMPIT,2)) AS VL_OUTROS, IM.IDTIPOITMAPR,
                                          IM.CDCFOPPADRAO, IP.CDCLASFISC AS CDCLASFISC,
                                          NVL(PA.CDPRODUTO,PR.CDPRODUTO) AS CDPRODUTO
                                     FROM ITMAPARECUP IM, DETITMAPARECUP DT, PRODUTO PA, PRODUTO PR, ITEMVENDA IP
                                    WHERE DT.CDFILIALVND   = C_REGC100.CDFILIAL
                                      AND DT.NRSEQVENDA    = C_REGC100.NRLANCTONF
                                      AND DT.CDCAIXA       = C_REGC100.CDCAIXA
                                      AND C_REGC100.CDMODDOCFISC = '65'
                                      AND IM.IDCOMPOEC197  = 'I'
                                      AND IM.IDTIPOITMAPR  = 'VI'
                                      AND IM.NRSEQUMAPAPU  = DT.NRSEQUMAPAPU
                                      AND IM.IDTIPOITMAPR  = DT.IDTIPOITMAPR
                                      AND IM.NRSEQITMAPR   = DT.NRSEQITMAPR
                                      AND DT.CDFILIALVND   = IP.CDFILIAL
                                      AND DT.CDCAIXA       = IP.CDCAIXA
                                      AND DT.NRSEQVENDA    = IP.NRSEQVENDA
                                      AND DT.NRSEQUITVEND  = IP.NRSEQUITVEND
                                      AND PR.CDPRODUTO     = IP.CDPRODUTO
                                      AND PR.CDPRODESTO    = PA.CDPRODUTO(+)
                                    GROUP BY IM.CDAJUSTEITMAPA, IM.DSITEMMAPR,
                                          NVL(PA.CDARVPROD,PR.CDARVPROD), DT.VROUTALIQ,
                                          IM.IDTIPOITMAPR, IM.CDCFOPPADRAO, IP.CDCLASFISC,
                                          NVL(PA.CDPRODUTO,PR.CDPRODUTO))
                            ORDER BY SUBSTR(COD_AJ,8,3), IDTIPOITMAPR, CDCFOPPADRAO, CDCLASFISC, CDPRODUTO) LOOP

             BEGIN
                SELECT LPAD(NVL(IT.CDITEMVARIAVEL,'0')||DECODE(C_REGC197.CDCFOPPADRAO,'','',SUBSTR(C_REGC197.DESCR_COMPL_AJ,2,3)),6,'0') AS COD_OBS,
                       TRIM(IT.DSAJUSTE) AS TXT
                  INTO V_CODC195, V_TXTC195
                  FROM ITEMVARAJEFD IT
                 WHERE IT.SGESTADO       = SUBSTR(C_REGC197.COD_AJ,1,2)
                   AND IT.CDITEMVARIAVEL = SUBSTR(C_REGC197.COD_AJ,8,3);
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_CODC195 := '';
                   V_TXTC195 := '';
             END;

            /* CODIGO DO PRODUTO */
            SELECT MAX(CDCHAVEREG)
              INTO V_PRODUTO
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC197.CDPRODUTO
               AND CDREGISTRO = '0200';

            IF (V_PRODUTO IS NULL) AND (C_REGC197.CDPRODUTO IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
               VALUES
                 ('0200', V_SEQUPROD, C_REGC197.CDPRODUTO, C_REGC197.CDCLASFISC);
            END IF;
            V_PRODUTO := NULL;

             V_COD_OBS := NULL;
             SELECT MAX(CDCHAVEREG)
               INTO V_COD_OBS
               FROM TMP_REGDADOSSPED
              WHERE CDCHAVEREG = V_CODC195
                AND CDREGISTRO = '0460';

             IF (V_COD_OBS IS NULL) THEN
                V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                INSERT INTO TMP_REGDADOSSPED
                   (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
                VALUES
                   ('0460', V_SEQUPROD, NVL(V_CODC195,SUBSTR(C_REGC197.COD_AJ,8,3)), V_TXTC195);
             END IF;

             IF (V_C195 IS NULL) OR (V_C195 <> SUBSTR(C_REGC197.COD_AJ,8,3)||CASE WHEN C_REGC197.CDCFOPPADRAO IS NOT NULL THEN SUBSTR(C_REGC197.DESCR_COMPL_AJ,2,3) ELSE '' END) THEN
                INSERT INTO ARQMAGNETICO
                   (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                VALUES
                   ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C195'  || '|' || V_CODC195 || '|' || '' || '|', P_NRSEQARQMAG);
                V_CONTREGC := NVL(V_CONTREGC,0) + 1;
             END IF;

             V_REG_C197 := '|C197'                   || '|' ||
                           C_REGC197.COD_AJ          || '|' ||
                           C_REGC197.DESCR_COMPL_AJ  || '|' ||
                           C_REGC197.COD_ITEM        || '|' ||
                           C_REGC197.VL_BC_ICMS      || '|' ||
                           C_REGC197.ALIQ_ICMS       || '|' ||
                           C_REGC197.VL_ICMS         || '|' ||
                           C_REGC197.VL_OUTROS       || '|' ;
             INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), V_REG_C197, P_NRSEQARQMAG);
             V_CONTREGC := NVL(V_CONTREGC,0) + 1;

             V_C195 := SUBSTR(C_REGC197.COD_AJ,8,3)||CASE WHEN C_REGC197.CDCFOPPADRAO IS NOT NULL THEN SUBSTR(C_REGC197.DESCR_COMPL_AJ,2,3) ELSE '' END;
         END LOOP;
      END LOOP;
   END IF;

   IF V_CDSITUCRT = '1' THEN  /*SIMPLES NACIONAL*/
       FOR C_REGC100 IN(SELECT ('|C100'                                                              || '|' ||
                                NF.CAMPO2                                                            || '|' ||
                                (CASE WHEN ((NF.CDSERIEENTR BETWEEN '890' AND '899') AND (NF.CDMODDOCFISC = '55')) THEN '1' ELSE NF.CAMPO3 END) || '|' ||
                                DECODE(NF.IDSTATUSNFE,'D','',DECODE(NF.IDSTATUS,'C','',REPLACE(REPLACE(REPLACE(REPLACE(NF.IDORIGDESTNF||DECODE(NF.IDORIGDESTNF, 'F', NF.CDFORNECED, DECODE(NF.IDORIGDESTNF, 'C', NF.CDCLIENTE , DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIEMIT, NF.CDFILIRECE))),'.'),'-'),'/'),' '))) || '|' ||
                                NF.CDMODDOCFISC                                                      || '|' ||
                                DECODE(NF.IDSTATUSNFE, 'D', '04', DECODE(IDSTATUS,'C','02',DECODE(IDREGESPECIAL,'S','08', DECODE(NF.IDENTRSAIDOP,'S', (CASE WHEN DTEMISSAO < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_S,'07','01') ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_S,'06','00') END), (CASE WHEN ((NF.CDSERIEENTR BETWEEN '890' AND '899') AND (NF.CDMODDOCFISC = '55')) THEN '08'ELSE (CASE WHEN DTENTRSAID < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_E,'07','01')ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_E,'06','00') END) END))))) ||'|'||
                                CASE WHEN LENGTH(NF.NRACESSONFE) = '44' THEN SUBSTR(NRACESSONFE,23,3) ELSE REPLACE(REPLACE(DECODE(NF.IDENTRSAIDOP, 'E', NF.CDSERIEENTR, NF.CDSERIE),'-',''),'.','') END   || '|' ||
                                DECODE(NF.IDENTRSAIDOP, 'E', LTRIM(NF.NRNOTAFISC,'0'), DECODE(NF.NRACESSONFE, '', LTRIM(REPLACE(LTRIM(NF.NRNOTAFISC, '0'),' ')),DECODE(NF.IDSTATUS,'C',LTRIM(NF.NRNOTAFISC,'0'),LTRIM(NF.NRNOTAFISCALELE, '0')) )  )|| '|' ||
                                NRACESSONFE                                                                                        || '|' ||  --chave da nota fiscal eletronica
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', TO_CHAR(NF.DTEMISSAO,'ddmmyyyy')) )   || '|' ) AS DADOS_1,
                                (REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF,2), '999999999990.00')), '.', ',')                    || '|' ||
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NVL(NF.QTDEPARC,0),0,'2',1,'0','1'))) || '|' || -- campo 13
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', REPLACE(LTRIM(TO_CHAR((SELECT SUM(ROUND(VRENCARGODESC,2)) FROM ITEMPRODUTO WHERE CDFILIAL = NF.CDFILIAL AND NRLANCTONF = NF.NRLANCTONF AND NRSEQITPROD IS NOT NULL), '999999999990.00')), '.', ','))) || '|' ||
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDDESCONTO, '03'))),2), '999999999990.00')), '.', ',') || '|' ||  -- abatimento no tributado e nao comercial desconto ICMS
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRPRODUTOS,2), '999999999990.00')), '.', ','))) || '|' ||
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', RPAD(NVL(NF.IDPGTOFRETE, '9'), 1 , ' ')))                                      || '|' ||
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDFRETE,  '01'))),2), '999999999990.00')), '.', ',') || '|' ||
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDSEGUR,  '02'))),2), '999999999990.00')), '.', ',') || '|' ||
                                /*REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUS, 'C', '', ABS(VALOR_IMPOSTO_NF(NF.CDFILIAL, NF.NRLANCTONF,V_CDIMPOSTRIB, 'I','1')) + ABS(VALOR_IMPOSTO_NF(NF.CDFILIAL, NF.NRLANCTONF, V_IPI, 'I','1'))),2), '999999999990.00')), '.', ',')  || '|' || --campo20*/
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDOUTROS, '04'))),2), '999999999990.00')), '.', ',') || '|' || -- Campo 20 outras obrigaes acessrias
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', NF.VRBASECALCNF)),2), '999999999990.00')), '.', ',') || '|' || -- campo 21
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', NF.VRIMPOSTONF)),2), '999999999990.00')), '.', ',') || '|' || -- campo 22
                                REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS,'C','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','B','1'))), '999999999990.00')), '.', ',') || '|' || -- base de calc susbt. trib
                                REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS,'C','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','I','1') + VALOR_FECP_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','I','1'))), '999999999990.00')), '.', ',') || '|' || -- valor do icms retido susbt. trib
                                REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS,'C','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'10','I','1'))), '999999999990.00')), '.', ',') || '|' || -- valor do IPI
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF, '50', 'I','1'))),2), '999999999990.00')), '.', ',') || '|' || -- valor do PIS
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF, '60', 'I','1'))),2), '999999999990.00')), '.', ',') || '|' || -- valor do COFINS
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', '0,00')) || '|' || -- pis retido por subst. trib.
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', '0,00')) || '|'  ) AS DADOS_3,
                                NF.CDFILIAL AS CDFILIAL, NF.NRLANCTONF AS NRLANCTONF, NF.NRINSJURTRAN, NF.IDTPIJURTRAN, NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU,
                                NF.NRPLACAVEIC, NF.DSQTDEVOLU, NF.DSESPECVOLU, NF.DSMARCAVOLU, NF.DSNUMEVOLU, NF.CDFISCOPERNF, NF.NRNOTAFISC AS NRNOTAFISC,
                                NF.DTEMISSAO, NF.DTENTRSAID, NF.IDENTRSAIDOP, NF.VRIMPOSTONF, NF.CDMODDOCFISC, NF.IDSTATUS, NF.IDORIGDESTNF,
                                NF.IDORIGDESTNF||DECODE(NF.IDORIGDESTNF, 'F', NF.CDFORNECED, DECODE(NF.IDORIGDESTNF, 'C', NF.CDCLIENTE , DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIEMIT, NF.CDFILIRECE))) AS COD_PAR,
                                DECODE(IDSTATUS,'C','02',DECODE(IDREGESPECIAL,'S','08',DECODE(NF.IDENTRSAIDOP,'S', (CASE WHEN DTEMISSAO < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_S,'07','01') ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_S,'06','00') END),(CASE WHEN DTENTRSAID < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_E,'07','01')ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_E,'06','00') END)))) AS SITU_DOC,
                                NF.IDSTATUSNFE, NVL(NF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL, NF.QTDEPARC, NF.CDTIPOOPER, DECODE(NF.IDENTRSAIDOP,'S',NF.CDFILIEMIT,NF.CDFILIRECE) AS FILIAL
                        FROM (/*NF SADA SEM CARGA TRIBUTRIA*/
                              SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                     DECODE(N.IDENTRSAIDOP, 'E', DECODE(IDSTATUSNFE,'A','0',DECODE(IDSTATUS,'E','0','1')), '0') AS CAMPO3, NRACESSONFE,
                                     I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                     N.NRINSJURNF, N.IDSTATUS,T.IDREGESPECIAL, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                     N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                     TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0))) AS VRBASECALCNF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0)))  AS VRIMPOSTONF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                     N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'S') AS IDSIMPLESNACIONAL,
                                     MAX((SELECT COUNT(DISTINCT NRPARCELAREC)
                                            FROM CONTARECEBER C
                                           WHERE N.CDFILIAL = C.CDFILIAL
                                             AND N.NRLANCTONF = C.NRLANCTONF
                                             AND C.NRLANBOLREC IS NOT NULL)) AS QTDEPARC
                              FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP, PARAMFORNE PF, SERIENF SS, SERIEENTR SE, TIPOOPERAC T
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                AND N.CDINSCESTA      = P_CDINSCESTA
                                AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SS.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP    = 'S'
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND N.CDFORNECED      = PF.CDFORNECED(+)
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                AND NVL(P_GERAFORSALE,'N') = 'N'
                                AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') = 0
								AND T.IDENTRSAIDOP    = N.IDENTRSAIDOP
                                AND T.CDTIPOOPER	  =	T.CDTIPOOPER						
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR),
                                     N.NRINSJURNF, N.IDSTATUS,T.IDREGESPECIAL, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE,
                                     N.DTEMISSAO, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                     N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE,
                                     DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'S')
                              UNION ALL
                              /*NF SADA COM CARGA TRIBUTRIA*/
                              SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                     DECODE(N.IDENTRSAIDOP, 'E', DECODE(IDSTATUSNFE,'A','0',DECODE(IDSTATUS,'E','0','1')), '0') AS CAMPO3, NRACESSONFE,
                                     I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                     N.NRINSJURNF, N.IDSTATUS,T.IDREGESPECIAL, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                     N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                     TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     TO_CHAR(DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','B','1')))) AS VRBASECALCNF,
                                     TO_CHAR(DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1')))  AS VRIMPOSTONF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                     N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'S') AS IDSIMPLESNACIONAL,
                                     MAX((SELECT COUNT(DISTINCT NRPARCELAREC)
                                            FROM CONTARECEBER C
                                           WHERE N.CDFILIAL = C.CDFILIAL
                                             AND N.NRLANCTONF = C.NRLANCTONF
                                             AND C.NRLANBOLREC IS NOT NULL)) AS QTDEPARC
                              FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP, PARAMFORNE PF, SERIENF SS, SERIEENTR SE, TIPOOPERAC T
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                AND N.CDINSCESTA      = P_CDINSCESTA
                                AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SS.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP    = 'S'
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND N.CDFORNECED      = PF.CDFORNECED(+)
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                AND NVL(P_GERAFORSALE,'N') = 'N'
                                AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') > 0
								AND T.IDENTRSAIDOP    = N.IDENTRSAIDOP
								AND T.CDTIPOOPER      = N.CDTIPOOPER
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR),
                                     N.NRINSJURNF, N.IDSTATUS,T.IDREGESPECIAL, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE,
                                     N.DTEMISSAO, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                     N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE,
                                     DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'S'), VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','B','1'), VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1')
                              UNION ALL
                              /******** NOTA CANCELADA *******/
                              SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                     '0' AS CAMPO3, NRACESSONFE,
                                     N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC,NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                     '' AS NRINSJURNF, N.IDSTATUS,'' AS IDREGESPECIAL, N.DTENTRSAID, N.VRNOTAFISC, '' AS VRPRODUTOS, N.IDPGTOFRETE,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                     '' AS CDFILIEMIT, '' AS CDFILIRECE, N.DTEMISSAO, '' AS CDFISCOPERNF, N.CDMODDOCFISC, '' AS CDCLIENTE, '' AS CDFORNECED, N.IDORIGDESTNF,
                                     '' AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     '' AS VRBASECALCNF,
                                     '' AS VRIMPOSTONF,
                                     '' AS VROUTRCRED,
                                     '' AS VRISENTRIB,
                                     NRNOTAFISCALELE,
                                     N.CDTIPOOPER, N.IDSTATUSNFE, 'N' AS IDSIMPLESNACIONAL, 0 AS QTDEPARC
                               FROM NOTAFISCAL N, SERIENF SS, SERIEENTR SE
                              WHERE (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SS.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP = 'S'
                                AND N.IDSTATUS = 'C'
                                AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                AND N.DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL
                                AND N.CDINSCESTA = P_CDINSCESTA
                                AND N.CDEMPRESA = P_CDEMPRESA
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR),
                                       N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, N.IDPGTOFRETE, N.CDMODDOCFISC, N.CDCLIENTE,
                                       N.CDFORNECED, N.IDORIGDESTNF, N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, N.NRINSJURTRAN, N.IDTPIJURTRAN,
                                       N.VRPBRUTOVOLU, N.VRPLIQUVOLU, N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU,
                                       N.DSNUMEVOLU, N.NRACESSONFE, N.CDTIPOOPER, N.IDSTATUSNFE, N.NRNOTAFISCALELE
                              UNION ALL
                              /*NF ENTRADA SEM CARGA TRIBUTRIA*/
                              SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                     DECODE(N.IDENTRSAIDOP, 'E', DECODE(IDSTATUSNFE,'A','0',DECODE(IDSTATUS,'E','0','1')), '0') AS CAMPO3, NRACESSONFE,
                                     I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                     N.NRINSJURNF, N.IDSTATUS,T.IDREGESPECIAL, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                     N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                     TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0))) AS VRBASECALCNF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0)))  AS VRIMPOSTONF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                     N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL,
                                     MAX((SELECT COUNT(DISTINCT C.NRPARCELAPAG)
                                            FROM CONTAPAGAR C
                                           WHERE N.CDFILIAL   = C.CDFILIAL
                                             AND N.NRLANCTONF = C.NRLANCTONF
                                             AND C.NRLANBOLPAG IS NOT NULL)) AS QTDEPARC
                              FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP, PARAMFORNE PF, SERIENF SS, SERIEENTR SE, TIPOOPERAC T
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                AND N.CDINSCESTA      = P_CDINSCESTA
                                AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS')  <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'FIS')
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SS.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP    = 'E'
                                AND PF.CDFORNECED(+)  = N.CDFORNECED
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                AND NVL(P_GERAFORSALE,'N') = 'N'
                                AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') = 0
								AND T.IDENTRSAIDOP    = N.IDENTRSAIDOP
								AND T.CDTIPOOPER      = N.CDTIPOOPER
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP,
                                     N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), N.NRINSJURNF, N.IDSTATUS,T.IDREGESPECIAL, N.DTENTRSAID, NRACESSONFE,
                                     N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE, N.DTEMISSAO , N.CDMODDOCFISC, N.CDCLIENTE,
                                     N.CDFORNECED, N.IDORIGDESTNF, N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE, N.CDTIPOOPER, IDSTATUSNFE,
                                     DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N')
                              UNION ALL
                              /*NF ENTRADA COM CARGA TRIBUTRIA*/
                              SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                     DECODE(N.IDENTRSAIDOP, 'E', DECODE(IDSTATUSNFE,'A','0',DECODE(IDSTATUS,'E','0','1')), '0') AS CAMPO3, NRACESSONFE,
                                     I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                     N.NRINSJURNF, N.IDSTATUS, T.IDREGESPECIAL, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                     N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                     TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)+DECODE(V_IDTPCARGATRIB,'O',0,CASE WHEN V_SGESTADO <> 'SP' THEN VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','B','1') ELSE 0 END))) AS VRBASECALCNF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF, 0)+DECODE(V_IDTPCARGATRIB,'O',0,CASE WHEN V_SGESTADO <> 'SP' THEN VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') ELSE 0 END))) AS VRIMPOSTONF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                     N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL,
                                     MAX((SELECT COUNT(DISTINCT NRPARCELAPAG)
                                            FROM CONTAPAGAR C
                                           WHERE N.CDFILIAL = C.CDFILIAL
                                             AND N.NRLANCTONF = C.NRLANCTONF
                                             AND C.NRLANBOLPAG IS NOT NULL)) AS QTDEPARC
                              FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP, PARAMFORNE PF, SERIENF SS, SERIEENTR SE, TIPOOPERAC T
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                AND N.CDINSCESTA      = P_CDINSCESTA
                                AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS')  <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'FIS')
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SS.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP    = 'E'
                                AND PF.CDFORNECED(+)  = N.CDFORNECED
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                AND NVL(P_GERAFORSALE,'N') = 'N'
                                AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') > 0
								AND T.IDENTRSAIDOP    = N.IDENTRSAIDOP
								AND T.CDTIPOOPER      = N.CDTIPOOPER
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP,
                                     N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), N.NRINSJURNF, N.IDSTATUS,T.IDREGESPECIAL, N.DTENTRSAID, NRACESSONFE,
                                     N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE, N.DTEMISSAO , N.CDMODDOCFISC, N.CDCLIENTE,
                                     N.CDFORNECED, N.IDORIGDESTNF, N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE, N.CDTIPOOPER, IDSTATUSNFE,
                                     DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N')
                              UNION
                              /*******NOTAS FISCAIS FORSALE - C100 FOS ***********/
                              SELECT DECODE(NF.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                     DECODE(NF.IDENTRSAIDOP, 'E', DECODE(IDSTATUS,'E','0','1'), '0') AS CAMPO3, NRACESSONFE,
                                     NF.CDFILIAL, NF.NRLANCTONF, NF.IDENTRSAIDOP, NF.NRNOTAFISC, NF.CDSERIE, NF.CDSERIEENTR,
                                     NF.NRINSJURNF, NF.IDSTATUS,'' AS IDREGESPECIAL, NF.DTENTRSAID, NF.VRNOTAFISC, TO_CHAR(NF.VRPRODUTOS) AS VRPRODUTOS, NF.IDPGTOFRETE,
                                     NF.NRPLACAVEIC, NF.DSQTDEVOLU, NF.DSESPECVOLU, NF.DSMARCAVOLU, NF.DSNUMEVOLU,
                                     NF.CDFILIEMIT, NF.CDFILIRECE, NF.DTEMISSAO, MAX(NF.CDFISCOPERNF) AS CDFISCOPERNF, NF.CDMODDOCFISC, NF.CDCLIENTE, NF.CDFORNECED, NF.IDORIGDESTNF,
                                     NF.VRCONTABILNF AS VRCONTABILNF,
                                     NF.NRINSJURTRAN, NF.IDTPIJURTRAN, NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU,
                                     TO_CHAR(VRBASECALCNF) AS VRBASECALCNF,
                                     TO_CHAR(VRIMPOSTONF),
                                     TO_CHAR(VROUTRCRED),
                                     TO_CHAR(VRISENTRIB),
                                     NF.NRNOTAFISCALELE,
                                     NF.CDTIPOOPER, '' AS IDSTATUSNFE, NF.IDSIMPLESNACIONAL, NF.QTDEPARC
                               FROM  ENDECLIE EC, ENDEFORN EF, ENDEFILI EFI,
                                (SELECT DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSJURCLIE,'F',FO.NRINSJURFORN,'L',FI.NRINSJURFILI) AS NRINSJURNF,
                                        DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSESTCLIE,'F',FO.NRINSESTFORN,'L',FI.CDINSCESTA  ) AS NRINSEST,
                                        N.IDORIGDESTNF, N.CDCLIENTE, N.CDFORNECED, N.CDFILIEMIT, N.CDFILIRECE, N.NRNOTAFISC, I.CDFISCOPERNF,
                                        N.NRLANCTONF,N.CDFILIAL, N.IDENTRSAIDOP, DECODE(N.CDMODDOCFISC,'2D','55',N.CDMODDOCFISC) AS CDMODDOCFISC,
                                        NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR, N.DTENTRSAID, N.DTEMISSAO,
                                        TO_CHAR(SUM(VRCONTABILNF)) AS VRCONTABILNF,
                                        DECODE(I.CDFISCALNF,'1',SUM(VRBASECALCNF),0) AS VRBASECALCNF,
                                        DECODE(I.CDFISCALNF,'2',SUM(VRCONTABILNF),'1',SUM(DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF)),0) AS VRISENTRIB,
                                        DECODE(I.CDFISCALNF,'3',SUM(VRCONTABILNF),0) AS VROUTRCRED,
                                        DECODE(I.CDFISCALNF,'1',SUM(VRIMPOSTONF ),0) AS VRIMPOSTONF,
                                        SUM(N.VRPRODUTOS) AS VRPRODUTOS,
                                        N.NRINSJURTRAN,N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU, N.NRNOTAFISCALELE, I.VRPERREDBCNF,N.IDSTATUS,N.IDPGTOFRETE,
                                        N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,N.VRNOTAFISC, NRACESSONFE, N.CDTIPOOPER,
                                        DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'S') AS IDSIMPLESNACIONAL,
                                        MAX((SELECT COUNT(DISTINCT NRPARCELAREC)
                                               FROM CONTARECEBER C
                                              WHERE N.CDFILIAL    = C.CDFILIAL
                                                AND N.NRLANCTONF  = C.NRLANCTONF
                                                AND C.NRLANBOLREC IS NOT NULL)) AS QTDEPARC
                                   FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IMP, CLIENTE CL, FORNECEDOR FO, FILIAL FI, PARAMFORNE PF, SERIENF SS, SERIEENTR SE
                                  WHERE N.CDFILIAL     = I.CDFILIAL
                                    AND N.NRLANCTONF   = I.NRLANCTONF
                                    AND IMP.CDIMPOSTO  = I.CDIMPOSTO
                                    AND N.CDCLIENTE    = CL.CDCLIENTE(+)
                                    AND N.CDFORNECED   = FO.CDFORNECED(+)
                                    AND N.CDFORNECED   = PF.CDFORNECED(+)
                                    AND N.CDFILIRECE   = FI.CDFILIAL(+)
                                    AND N.CDFILIEMIT   = FI.CDFILIAL(+)
                                    AND DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL
                                    AND ((N.IDSTATUS   = 'A' OR N.IDSTATUS = 'E') OR (N.IDSTATUSNFE = 'A' OR N.IDSTATUSNFE = 'T'))
                                    AND N.CDINSCESTA   = P_CDINSCESTA
                                    AND IMP.CDIMPOSTONFE = P_CDIMPOSTO
                                    AND (I.IDIMPOSTONF <> '3' OR IDIMPOSTONF IS NULL)
                                    AND (NVL(N.IDSISTEMA, 'DFS') <> 'REC'
                                    AND NVL(N.IDSISTEMA, 'DFS')  <> 'PAG'
                                    AND NVL(N.IDSISTEMA, 'DFS')  <> 'CMP'
                                    AND NVL(N.IDSISTEMA, 'DFS')  <> 'SUP'
                                    AND NVL(N.IDSISTEMA, 'DFS')  <> 'TMP'
                                    AND NVL(N.IDSISTEMA, 'DFS')  <> 'FIS')
                                    AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                    AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                    AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                    AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                    AND SS.CDSERIE(+)     = N.CDSERIE
                                    AND N.CDMODDOCFISC IN ('01','1B','04','55','2D')
                                    AND N.IDENTRSAIDOP = 'S'
                                    AND NVL(P_GERAFORSALE,'N') = 'S'
                                  GROUP BY DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSJURCLIE,'F',FO.NRINSJURFORN,'L',FI.NRINSJURFILI),
                                           DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSESTCLIE,'F',FO.NRINSESTFORN,'L',FI.CDINSCESTA),N.IDORIGDESTNF,
                                           N.CDCLIENTE, N.CDFORNECED, N.CDFILIEMIT, N.CDFILIRECE, N.NRNOTAFISC, I.CDFISCOPERNF, N.NRLANCTONF,
                                           N.CDFILIAL, N.IDENTRSAIDOP, N.CDMODDOCFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR),
                                           N.DTENTRSAID, N.DTEMISSAO,  I.CDFISCALNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU,
                                           N.VRPLIQUVOLU,N.NRNOTAFISCALELE,I.VRPERREDBCNF,N.IDSTATUS,IDPGTOFRETE,
                                           N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,N.VRNOTAFISC,NRACESSONFE,N.CDTIPOOPER,DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'S'))NF
                              WHERE NF.CDCLIENTE    = EC.CDCLIENTE(+)
                                AND NF.CDFORNECED   = EF.CDFORNECED(+)
                                AND NF.CDFILIEMIT   = EFI.CDFILIAL(+)
                                AND NF.CDFILIRECE   = EFI.CDFILIAL(+)
                                AND IDTPENDECLIE(+) = 'P'
                                AND IDTPENDEFORN(+) = 'P'
                                AND IDTPENDEFILI(+) = 'P'
                                AND NVL(P_GERAFORSALE,'N') = 'S'
                              GROUP BY DECODE(NF.IDENTRSAIDOP, 'E', '0','1'),
                                       DECODE(NF.IDENTRSAIDOP, 'E', DECODE(IDSTATUS,'E','0','1'), '0'), NRACESSONFE,
                                       NF.CDFILIAL, NF.NRLANCTONF, NF.IDENTRSAIDOP, NF.NRNOTAFISC, NF.CDSERIE, NF.CDSERIEENTR,
                                       NF.NRINSJURNF, NF.IDSTATUS, NF.DTENTRSAID, NF.VRNOTAFISC, TO_CHAR(NF.VRPRODUTOS), NF.IDPGTOFRETE,
                                       NF.NRPLACAVEIC, NF.DSQTDEVOLU, NF.DSESPECVOLU, NF.DSMARCAVOLU, NF.DSNUMEVOLU,
                                       NF.CDFILIEMIT, NF.CDFILIRECE, NF.DTEMISSAO, NF.CDMODDOCFISC, NF.CDCLIENTE, NF.CDFORNECED, NF.IDORIGDESTNF,
                                       NF.VRCONTABILNF, NF.NRINSJURTRAN, NF.IDTPIJURTRAN, NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU,
                                       TO_CHAR(VRBASECALCNF), TO_CHAR(VRIMPOSTONF), TO_CHAR(VROUTRCRED), TO_CHAR(VRISENTRIB),
                                       NF.NRNOTAFISCALELE,NF.CDTIPOOPER,NF.IDSIMPLESNACIONAL, NF.QTDEPARC)NF )LOOP
           IF C_REGC100.IDSTATUS = 'C' THEN
              V_DADOS_2 := '|';
           ELSE
              IF C_REGC100.IDENTRSAIDOP = 'E' THEN
                 V_DADOS_2 := TO_CHAR(C_REGC100.DTENTRSAID,'ddmmyyyy') || '|';
              ELSE
                 V_DADOS_2 := TO_CHAR(C_REGC100.DTEMISSAO,'ddmmyyyy') || '|';
              END IF;
           END IF;
          V_VRDEBESP := 0;
          /* valor total de imposto fora do periodo - nf saida */
          V_VRFORAPER := 0;
          IF (C_REGC100.SITU_DOC IN ('01', '07')) AND (C_REGC100.IDENTRSAIDOP = 'S') THEN
             BEGIN
                SELECT SUM(VRIMPOSTONF)
                INTO V_VRFORAPER
                FROM IMPOSTONF
                WHERE CDFILIAL = C_REGC100.CDFILIAL
                  AND NRLANCTONF = C_REGC100.NRLANCTONF
                  AND CDFISCALNF = '1'
                  AND NVL(IDIMPOSTONF,'1') <> '3';
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_VRFORAPER := 0;
             END;
             V_TOTFORPER_S :=  NVL(V_TOTFORPER_S,0)+NVL(V_VRFORAPER,0);
          END IF;

          INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
            ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC100.DADOS_1||V_DADOS_2||C_REGC100.DADOS_3, P_NRSEQARQMAG);
          V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
          V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

          /* CODIGO DO PARTICIPANTE */
          SELECT MAX(CDCHAVEREG)
            INTO V_COD_PAR
            FROM TMP_REGDADOSSPED
           WHERE CDCHAVEREG = C_REGC100.COD_PAR
             AND CDREGISTRO = '0150';

          IF (V_COD_PAR IS NULL) AND (C_REGC100.COD_PAR IS NOT NULL) THEN
             V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
             INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
             VALUES
               ('0150', V_SEQUPROD, C_REGC100.COD_PAR);
          END IF;
          V_COD_PAR := NULL;
          /*REGISTRO C110 - OBSERVAO DO DOCUMENTO*/
          FOR C_REGC110 IN (SELECT '|C110'                                  ||'|'||
                                   LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0')    ||'|'||
                                   'CUPOM FISCAL REFERENCIADO - COO NMERO '||TRIM(D.NRCOOCUPOMNF)||'|'  AS DSREGC110,
                                   '|C114'                                  ||'|'||
                                   '2D'                                     ||'|'||
                                   SUBSTR(D.NRSERIEIMPNF,1,21)              ||'|'||
                                   SUBSTR(LPAD(D.NRCOOCUPOMNF,10,'0'),5,6)  ||'|'||
                                   TO_CHAR(C_REGC100.DTEMISSAO,'DDMMYYYY')  ||'|' AS DSREGC114
                              FROM DADOSNF D, NOTAFISCAL N
                             WHERE D.NRLANCTONF  = C_REGC100.NRLANCTONF
                               AND D.CDFILIAL    = C_REGC100.CDFILIAL
                               AND D.NRECFCUPOMNF IS NOT NULL
                               AND D.NRLANCTONF  = N.NRLANCTONF
                               AND D.CDFILIAL    = N.CDFILIAL
                               AND NOT ((N.IDSTATUSNFE = 'A') OR (N.CDMODDOCFISC = '55')))LOOP

             INSERT INTO ARQMAGNETICO
                (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
              VALUES ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC110.DSREGC110 , P_NRSEQARQMAG);
                   V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
                   V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

             /*REGISTRO C114 - CUPOM FISCAL REFERENCIADO*/
             INSERT INTO ARQMAGNETICO
                (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
              VALUES ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC110.DSREGC114 , P_NRSEQARQMAG);
                   V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
                   V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
              V_SEQADIC := V_SEQADIC +1;
          END LOOP;

          /*REGISTRO C110 - OBSERVAO DO DOCUMENTO -- DADOSADIC*/
          FOR C_REGC110 IN (SELECT D.DSDADOADIC AS DSREGC110
                              FROM DADOSADIC D, NOTAFISCAL N
                             WHERE D.NRLANCTONF  = C_REGC100.NRLANCTONF
                               AND D.CDFILIAL    = C_REGC100.CDFILIAL
                               AND D.NRLANCTONF  = N.NRLANCTONF
                               AND D.CDFILIAL    = N.CDFILIAL)LOOP
             V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;

             INSERT INTO ARQMAGNETICO (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C110|'||LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0')||'|'||TRIM(SUBSTR(C_REGC110.DSREGC110, 0,499))||'|', P_NRSEQARQMAG);
             V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
             V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

             INSERT INTO TMP_REGDADOSSPED (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
             VALUES ('0450', V_SEQUPROD, LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0'), TRIM(SUBSTR(C_REGC110.DSREGC110, 0, 499)));
             V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
             V_SEQADIC := V_SEQADIC +1;
          END LOOP;

          /*QUANDO A OPERAO FOR A PRAZO PARA AS ENTRADAS NOS MODELOS 1 E 1A DEVER SER GERADOS OS REGISTROS REFERENTES A FATURA*/
          IF (C_REGC100.CDMODDOCFISC IN ('01','1A')) AND (C_REGC100.QTDEPARC > 1) THEN
             /*REGISTRO C140*/
             FOR C_REGC140 IN (SELECT '|C140'                                                               ||'|'||
                                      DECODE(N.IDENTRSAIDOP,'E','1','S','0')                                ||'|'||
                                      DECODE(F.IDTPTITULOCRED,'XX','',F.IDTPTITULOCRED)                     ||'|'||
                                      DECODE(F.IDTPTITULOCRED,'99',F.DSTPTITULOCRED,'')                     ||'|'||
                                      LTRIM(N.NRNOTAFISC,'0')                                               ||'|'||
                                      LPAD(RTRIM(TO_CHAR(C_REGC100.QTDEPARC)),2,'0')                        ||'|'||
                                      REPLACE(LTRIM(TO_CHAR(SUM(C.VRORIGPAG),'999999999990.00')), '.', ',') ||'|' AS DSREG_C140
                                 FROM NOTAFISCAL N, FORNECEDOR F, CONTAPAGAR C
                                WHERE N.CDFILIAL   = C_REGC100.CDFILIAL
                                  AND N.NRLANCTONF = C_REGC100.NRLANCTONF
                                  AND N.CDFORNECED = F.CDFORNECED
                                  AND N.CDFILIAL   = C.CDFILIAL
                                  AND N.NRLANCTONF = C.NRLANCTONF
                                GROUP BY N.IDENTRSAIDOP, F.IDTPTITULOCRED, F.DSTPTITULOCRED,
                                      N.NRNOTAFISC, C_REGC100.QTDEPARC) LOOP

                INSERT INTO ARQMAGNETICO
                   (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                VALUES
                   ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC140.DSREG_C140, P_NRSEQARQMAG);
                V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
             END LOOP;

             /*REGISTRO C141*/
             FOR C_REGC141 IN (SELECT '|C141'                                                               ||'|'||
                                      LPAD(RTRIM(TO_CHAR(C.NRPARCELAPAG)),2,'0')                            ||'|'||
                                      TO_CHAR(C.DTORIGVENPAG,'DDMMYYYY')                                    ||'|'||
                                      REPLACE(LTRIM(TO_CHAR(SUM(C.VRORIGPAG),'999999999990.00')), '.', ',') ||'|' AS DSREG_C141
                                 FROM CONTAPAGAR C
                                WHERE C.CDFILIAL   = C_REGC100.CDFILIAL
                                  AND C.NRLANCTONF = C_REGC100.NRLANCTONF
                                GROUP BY C.NRPARCELAPAG, C.DTORIGVENPAG
                                ORDER BY C.NRPARCELAPAG) LOOP

                INSERT INTO ARQMAGNETICO
                   (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                VALUES
                   ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC141.DSREG_C141, P_NRSEQARQMAG);
                V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
             END LOOP;
          END IF;

          BEGIN
            SELECT IDATUESTTPOP
              INTO V_IDATUESTTPOP
              FROM TIPOOPERAC
             WHERE CDTIPOOPER   = C_REGC100.CDTIPOOPER
               AND IDENTRSAIDOP = C_REGC100.IDENTRSAIDOP;
          EXCEPTION
             WHEN NO_DATA_FOUND THEN
                V_IDATUESTTPOP := 'N';
          END;

          /*REGISTRO C170*/
          FOR C_REGC170 IN (SELECT COD_ITEM       || '|' ||
                                  DESCR_COMPL    || '|' ||
                                  QTD            || '|' ||
                                  UNID           || '|' ||
                                  VL_ITEM        || '|' ||
                                  VL_DESC        || '|' ||
                                  IND_MOV        || '|' ||
                                  CST_ICMS       || '|' ||
                                  CFOP           || '|' ||
                                  CFOP           || '|' || -- natureza da operacao campo 12
                                  VL_BC_ICMS     || '|' ||
                                  ALIQ_ICMS      || '|' ||
                                  VL_ICMS        || '|' ||
                                  VL_BC_ICMS_ST  || '|' || --16
                                  ALIQ_ST        || '|' || --17
                                  VL_ICMS_ST     || '|' || --18
                                  ''             || '|' || -- indicador de apurao do IPI CAMPO 19
                                  CST_IPI        || '|' || -- cst ipi campo 20
                                  '' 		       || '|' || -- Cdigo enquadramento IPI campo 21
                                  VL_BC_IPI      || '|' || --22
                                  ALIQ_IPI       || '|' || --23
                                  VL_IPI         || '|' || --24
                                  CST_PIS        || '|' || -- cst pis   campo 25
                                  VL_BC_PIS      || '|' ||
                                  ALIQ_PIS       || '|' ||
                                  ''  			    || '|' || -- quantidade base de calculo
                                  ''             || '|' || -- aliquota pis quantidade
                                  VL_PIS         || '|' ||
                                  CST_COFINS     || '|' || -- cst cofins campo 31
                                  VL_BC_COFINS   || '|' ||
                                  ALIQ_COFINS    || '|' ||
                                  ''    	       || '|' || -- quantidade base de calculo
                                  ''             || '|' || -- aliquota cofins quantidade
                                  VL_COFINS      || '|' ||
                                  COD_CTA        || '|' ||
                                  CASE WHEN P_VERSAO >= '013' THEN VL_ABAT_NT || '|' ELSE '' END AS ARQ_C170,  -- codigo da conta analitica contabil deb/cred
                                  CDPRODUTO, UNID, CFOP AS CDFISCOPERIT, DSCDFISOPEIT, CDCLASFISC, COD_CTA
                             FROM (/* NOTAS NO ELETRNICAS SEM CARGA TRIBUTRIA */
                                   SELECT PR.CDARVPROD AS COD_ITEM,
                                           DECODE(C_REGC100.IDENTRSAIDOP, 'E', TRIM(RETIRA_CARACTER_ESPECIAL(IT.DSPRODEMIS, 'S'))) AS DESCR_COMPL,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                           PR.SGUNIDADE  AS UNID,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.VRTOTAITEM,2), '999999999990.00')), '.', ',') AS VL_ITEM,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                           DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                           LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0') AS CST_ICMS,
                                           IP.CDFISCOPERIT AS CFOP,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRBASECALCIT, 0),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRALIQITEM+NVL(IP.VRADICALIQFECP,0), 0),2), '999999999990.00')), '.', ',')   AS ALIQ_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRIMPOSTOIT+NVL(IP.VRADICFECP,0), 0),2), '999999999990.00')), '.', ',')  AS VL_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_IPI) AS CST_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                           CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, PR.CDPRODUTO, C_REGC100.CDTIPOOPER, C_REGC100.FILIAL)  AS COD_CTA,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT,0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                           PR.CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC
                                   FROM ITEMPRODUTO IT, PRODUTO PR, ITEMPROIMPOS IP, IMPOSTO IM
                                   WHERE IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.CDMODDOCFISC <> '55'
                                     AND (ROUND(IT.QTITEMPROD,3) > 0 OR C_REGC100.SITU_DOC IN ('06','07','08'))
                                     AND VALOR_IMPOSTO_NFE(IP.CDFILIAL,IP.NRLANCTONF,'03','I','1') = 0
                                   UNION ALL
                                   /* NOTAS NO ELETRNICAS COM CARGA TRIBUTRIA */
                                   SELECT PR.CDARVPROD AS COD_ITEM,
                                           DECODE(C_REGC100.IDENTRSAIDOP, 'E', TRIM(RETIRA_CARACTER_ESPECIAL(IT.DSPRODEMIS, 'S'))) AS DESCR_COMPL,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                           PR.SGUNIDADE AS UNID,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.VRTOTAITEM,2), '999999999990.00')), '.', ',')  AS VL_ITEM,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                           DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                           LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0') AS CST_ICMS,
                                           IP.CDFISCOPERIT AS CFOP,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRBASECALCIT, 0) + DECODE(V_IDTPCARGATRIB,'O',0,CASE WHEN V_SGESTADO <> 'SP' THEN VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'03','B','1') ELSE 0 END),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRALIQITEM+NVL(IP.VRADICALIQFECP,0), 0),2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRIMPOSTOIT+NVL(IP.VRADICFECP,0), 0) + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(C_REGC100.IDENTRSAIDOP, 'S', VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'03','I','1'), CASE WHEN V_SGESTADO <> 'SP' THEN VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'03','I','1') ELSE 0 END)),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_IPI) AS CST_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,

                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                           CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, PR.CDPRODUTO, C_REGC100.CDTIPOOPER, C_REGC100.FILIAL)  AS COD_CTA,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT,0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                           PR.CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC
                                   FROM ITEMPRODUTO IT, PRODUTO PR, ITEMPROIMPOS IP, IMPOSTO IM
                                   WHERE IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.CDMODDOCFISC <> '55'
                                     AND (ROUND(IT.QTITEMPROD,3) > 0 OR C_REGC100.SITU_DOC IN ('06','07','08'))
                                     AND VALOR_IMPOSTO_NFE(IP.CDFILIAL,IP.NRLANCTONF,'03','I','1') > 0
                                   UNION ALL
                                   /* NOTAS DE ENTRADA ELETRNICAS SEM CARGA TRIBUTRIA */
                                   SELECT PR.CDARVPROD AS COD_ITEM,
                                           DECODE(C_REGC100.IDENTRSAIDOP, 'E', TRIM(RETIRA_CARACTER_ESPECIAL(IT.DSPRODEMIS, 'S'))) AS DESCR_COMPL,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                           PR.SGUNIDADE AS UNID,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.VRTOTAITEM,2), '999999999990.00')), '.', ',') AS VL_ITEM,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                           DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                           DECODE(C_REGC100.IDSIMPLESNACIONAL,'S',(DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),LPAD(NVL(IT.CDFISCOPERSN,0),3,'0'))),LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0')) AS CST_ICMS,
                                           IP.CDFISCOPERIT AS CFOP,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRBASECALCIT, 0),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRALIQITEM+NVL(IP.VRADICALIQFECP,0), 0),2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRIMPOSTOIT+NVL(IP.VRADICFECP,0), 0),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_IPI) AS CST_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                           CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, PR.CDPRODUTO, C_REGC100.CDTIPOOPER, C_REGC100.FILIAL)  AS COD_CTA,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT,0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                           PR.CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC
                                    FROM ITEMPRODUTO IT, PRODUTO PR, ITEMPROIMPOS IP, IMPOSTO IM
                                   WHERE IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.IDENTRSAIDOP = 'E'
                                     AND C_REGC100.CDMODDOCFISC = '55'
                                     AND C_REGC100.IDSTATUSNFE <> 'A'
                                     AND(ROUND(IT.QTITEMPROD,3) > 0 OR C_REGC100.SITU_DOC IN ('06','07','08'))
                                     AND VALOR_IMPOSTO_NFE(IP.CDFILIAL,IP.NRLANCTONF,'03','I','1') = 0
                                   UNION ALL
                                   /* NOTAS DE ENTRADA ELETRNICAS COM CARGA TRIBUTRIA */
                                   SELECT PR.CDARVPROD AS COD_ITEM,
                                           DECODE(C_REGC100.IDENTRSAIDOP, 'E', TRIM(RETIRA_CARACTER_ESPECIAL(IT.DSPRODEMIS,'S'))) AS DESCR_COMPL,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                           PR.SGUNIDADE AS UNID,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.VRTOTAITEM,2), '999999999990.00')), '.', ',') AS VL_ITEM,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                           DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                           DECODE(C_REGC100.IDSIMPLESNACIONAL,'S',(DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),LPAD(NVL(IT.CDFISCOPERSN,0),3,'0'))), LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0')) AS CST_ICMS,
                                           IP.CDFISCOPERIT AS CFOP,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRBASECALCIT, 0) + DECODE(V_IDTPCARGATRIB,'O',0,CASE WHEN V_SGESTADO <> 'SP' THEN VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'03','B','1') ELSE 0 END),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRALIQITEM+NVL(IP.VRADICALIQFECP,0), 0),2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRIMPOSTOIT+NVL(IP.VRADICFECP,0),  0) + DECODE(V_IDTPCARGATRIB,'O',0,CASE WHEN V_SGESTADO <> 'SP' THEN VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'03','I','1') ELSE 0 END),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_IPI) AS CST_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,

                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                           CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, PR.CDPRODUTO, C_REGC100.CDTIPOOPER, C_REGC100.FILIAL)  AS COD_CTA,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT,0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                           PR.CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC
                                    FROM ITEMPRODUTO IT, PRODUTO PR, ITEMPROIMPOS IP, IMPOSTO IM
                                   WHERE IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.IDENTRSAIDOP = 'E'
                                     AND C_REGC100.CDMODDOCFISC = '55'
                                     AND C_REGC100.IDSTATUSNFE <> 'A'
                                     AND (ROUND(IT.QTITEMPROD,3) > 0 OR C_REGC100.SITU_DOC IN ('06','07','08'))
                                     AND VALOR_IMPOSTO_NFE(IP.CDFILIAL,IP.NRLANCTONF,'03','I','1') > 0)) LOOP
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C170'|| '|' ||V_SEQUENCIAL|| '|' || C_REGC170.ARQ_C170, P_NRSEQARQMAG);
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER(RTRIM(V_SEQUENCIAL))+1)), 3,'0');
            V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;

            /* CODIGO DO CFOP */
            SELECT MAX(CDCHAVEREG)
              INTO V_COD_NAT
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.CDFISCOPERIT
               AND CDREGISTRO = '0400';

            IF (V_COD_NAT IS NULL) AND (C_REGC170.CDFISCOPERIT IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1, CDCAMPO2)
               VALUES
                 ('0400', V_SEQUPROD, C_REGC170.CDFISCOPERIT, C_REGC170.DSCDFISOPEIT, C_REGC100.IDENTRSAIDOP);
            END IF;
            V_COD_NAT := NULL;

            /* UNIDADE DE MEDIDA */
            SELECT MAX(CDCHAVEREG)
              INTO V_UNID
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.UNID
               AND CDREGISTRO = '0190';

            IF (V_UNID IS NULL) AND (C_REGC170.UNID IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                 ('0190', V_SEQUPROD, C_REGC170.UNID);
            END IF;
            V_UNID := NULL;

            /* CODIGO DO PRODUTO */
            SELECT MAX(CDCHAVEREG)
              INTO V_PRODUTO
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.CDPRODUTO
               AND CDREGISTRO = '0200';

            IF (V_PRODUTO IS NULL) AND (C_REGC170.CDPRODUTO IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
               VALUES
                 ('0200', V_SEQUPROD, C_REGC170.CDPRODUTO, C_REGC170.CDCLASFISC);
            END IF;
            V_PRODUTO := NULL;

            /* PLANO DE CONTAS REFERENCIAL */
            SELECT MAX(CDCHAVEREG)
              INTO V_CONTCTBL
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.COD_CTA
               AND CDREGISTRO = '0500';

            IF (V_CONTCTBL IS NULL) AND (C_REGC170.COD_CTA IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                  ('0500', V_SEQUPROD, C_REGC170.COD_CTA);
            END IF;
            V_CONTCTBL := NULL;
          END LOOP;

          IF P_VERSAO NOT IN ( '001', '002') THEN
             /*REGISTRO C190*/
             IF (C_REGC100.IDSIMPLESNACIONAL <> 'S') OR (C_REGC100.IDSIMPLESNACIONAL = 'S' AND C_REGC100.CDMODDOCFISC <> '55') THEN
                 FOR C_REGC190 IN(SELECT ('|C190'      || '|' ||
                                          T.CST_ICMS   || '|' ||
                                          T.CFOP       || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.ALIQ_ICMS,2), '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_OPR,2),    '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_BC_ICMS,2),'999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_ICMS,2),   '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.BC_ST,2),     '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.IMP_ST,2),    '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_RED_BC,2), '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(VL_IPI,2),      '999999999990.00')), '.', ',') || '|' ||
                                          '' || '|') ARQ_C190,
                                          T.VL_ICMS, T.CFOP AS COD_NAT, T.CST_ICMS, T.ALIQ_ICMS
                                  FROM (/* NOTAS DE SADA SEM CARGA TRIBUTRIA */
                                        SELECT I.CDSITUTRIBIT AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRBASECALCIT, 0)) AS VL_BC_ICMS,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRIMPOSTOIT+NVL(I.VRADICFECP,0), 0)) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'S'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') = 0
                                         GROUP BY I.CDSITUTRIBIT, I.CDFISCOPERIT, DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0)
                                        UNION ALL
                                        /* NOTAS DE SADA COM CARGA TRIBUTRIA */
                                        SELECT I.CDSITUTRIBIT AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                               DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','B','1')))) AS VL_BC_ICMS,
                                               SUM(DECODE(V_IDTPCARGATRIB,'O',0,NVL(I.VRADICFECP,0)+VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','I','1'))) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'S'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') > 0
                                         GROUP BY I.CDSITUTRIBIT, I.CDFISCOPERIT, DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0)
                                        UNION ALL
                                        /* NOTAS DE ENTRADA SEM CARGA TRIBUTRIA */
                                        SELECT I.CDSITUTRIBIT AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRBASECALCIT, 0)) AS VL_BC_ICMS,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRIMPOSTOIT+NVL(I.VRADICFECP,0), 0)) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(IT.VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'E'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') = 0
                                         GROUP BY I.CDSITUTRIBIT, I.CDFISCOPERIT, DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0)
                                        UNION ALL
                                        /* NOTAS DE ENTRADA COM CARGA TRIBUTRIA */
                                        SELECT I.CDSITUTRIBIT AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                               SUM(DECODE(CDFISCALIT,'1',I.VRBASECALCIT, 0) + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(I.CDFISCALIT, '1', CASE WHEN V_SGESTADO <> 'SP' THEN I.VRBASECALCIT ELSE 0 END, 0))) AS VL_BC_ICMS,
                                               SUM(DECODE(CDFISCALIT,'1',I.VRIMPOSTOIT,  0) + NVL(I.VRADICFECP,0) + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(I.CDFISCALIT, '1', CASE WHEN V_SGESTADO <> 'SP' THEN I.VRIMPOSTOIT  ELSE 0 END, 0))) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'E'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') > 0
                                         GROUP BY I.CDSITUTRIBIT, I.CDFISCOPERIT, DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0) ) T ) LOOP
                    INSERT INTO ARQMAGNETICO
                      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                    VALUES
                      ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC190.ARQ_C190, P_NRSEQARQMAG);
                    V_CONTREGC := NVL(V_CONTREGC,0) + 1;

                    IF P_VERSAO >= '013' THEN
                       FOR C_REGC191 IN (SELECT '|C191'          || '|' ||
                                                REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN SUBSTR(IT.CDSITUTRIBIT,2,2) IN ('00','10','20','51','70','90') AND IM.CDIMPOSTONFE = '00'
                                                     THEN ROUND(IT.VRADICFECP,2)
                                                     ELSE 0 END),'999999999990.00')), '.', ',') || '|' ||
                                                REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN SUBSTR(IT.CDSITUTRIBIT,2,2) IN ('10','30','70','90') AND IM.CDIMPOSTONFE = '80'
                                                     THEN ROUND(IT.VRADICFECP,2)
                                                     ELSE 0 END),'999999999990.00')), '.', ',') || '|' ||
                                                REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN SUBSTR(IT.CDSITUTRIBIT,2,2) IN ('60')
                                                     THEN ROUND(IT.VRADICFECP,2)
                                                     ELSE 0 END),'999999999990.00')), '.', ',') || '|' AS ARQ_C191, IT.CDFISCOPERIT
                                           FROM ITEMPROIMPOS IT, ITEMPROIMPOS II, IMPOSTO IM
                                          WHERE IT.CDFILIAL     = C_REGC100.CDFILIAL
                                            AND IT.NRLANCTONF   = C_REGC100.NRLANCTONF
                                            AND IT.CDFISCOPERIT = C_REGC190.COD_NAT
                                            AND IT.CDSITUTRIBIT = C_REGC190.CST_ICMS
                                            AND IT.VRALIQITEM   = C_REGC190.ALIQ_ICMS
                                            AND IT.NRITPROIMPOS = '1'
                                            AND IT.CDFILIAL     = II.CDFILIAL
                                            AND IT.NRLANCTONF   = II.NRLANCTONF
                                            AND IT.NRSEQITPROD  = II.NRSEQITPROD
                                            AND II.CDFISCOPERIT = C_REGC190.COD_NAT
                                            AND II.CDSITUTRIBIT = C_REGC190.CST_ICMS
                                            AND II.CDIMPOSTO    = IM.CDIMPOSTO
                                            AND IM.CDIMPOSTONFE IN ('00','80')
                                            AND II.VRADICFECP   > 0
                                          GROUP BY IT.CDFISCOPERIT) LOOP
                          INSERT INTO ARQMAGNETICO
                             (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                          VALUES
                             ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC191.ARQ_C191, P_NRSEQARQMAG);
                          V_CONTREGC := NVL(V_CONTREGC,0) + 1;
                       END LOOP;
                    END IF;
                 END LOOP;
             END IF;

             IF (C_REGC100.IDSIMPLESNACIONAL = 'S' AND C_REGC100.CDMODDOCFISC = '55') THEN
                 FOR C_REGC190 IN(SELECT ('|C190'      || '|' ||
                                          T.CST_ICMS   || '|' ||
                                          T.CFOP       || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.ALIQ_ICMS,2), '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_OPR,2),    '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_BC_ICMS,2),'999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_ICMS,2),   '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.BC_ST,2),     '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.IMP_ST,2),    '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_RED_BC,2), '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(VL_IPI,2),      '999999999990.00')), '.', ',') || '|' ||
                                          '' || '|') ARQ_C190,
                                          T.VL_ICMS, T.CFOP AS COD_NAT, T.CST_ICMS, T.ALIQ_ICMS
                                  FROM (/* NOTAS DE SADA SEM CARGA TRIBUTRIA */
                                        SELECT DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN) AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL)),0) VL_OPR,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRBASECALCIT, 0)) AS VL_BC_ICMS,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRIMPOSTOIT+NVL(I.VRADICFECP,0), 0)) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM, ITEMPRODUTO IT
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'S'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND I.CDFILIAL      = IT.CDFILIAL
                                           AND I.NRLANCTONF    = IT.NRLANCTONF
                                           AND I.NRSEQITPROD   = IT.NRSEQITPROD
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') = 0
                                         GROUP BY DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN), I.CDFISCOPERIT, DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0)
                                        UNION ALL
                                        /* NOTAS DE SADA COM CARGA TRIBUTRIA */
                                        SELECT DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN) AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL)),0) VL_OPR,
                                               DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','B','1')))) AS VL_BC_ICMS,
                                               SUM(DECODE(V_IDTPCARGATRIB,'O',0,NVL(I.VRADICFECP,0)+VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','I','1'))) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM, ITEMPRODUTO IT
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'S'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND I.CDFILIAL      = IT.CDFILIAL
                                           AND I.NRLANCTONF    = IT.NRLANCTONF
                                           AND I.NRSEQITPROD   = IT.NRSEQITPROD
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') > 0
                                         GROUP BY DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN), I.CDFISCOPERIT, DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0)
                                        UNION ALL
                                        /* NOTAS DE ENTRADA SEM CARGA TRIBUTRIA */
                                        SELECT DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN) AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL)),0) VL_OPR,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRBASECALCIT, 0)) AS VL_BC_ICMS,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRIMPOSTOIT+NVL(I.VRADICFECP,0), 0)) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM, ITEMPRODUTO IT
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'E'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND I.CDFILIAL      = IT.CDFILIAL
                                           AND I.NRLANCTONF    = IT.NRLANCTONF
                                           AND I.NRSEQITPROD   = IT.NRSEQITPROD
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') = 0
                                         GROUP BY DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN), I.CDFISCOPERIT, DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0)
                                        UNION ALL
                                        /* NOTAS DE ENTRADA COM CARGA TRIBUTRIA */
                                        SELECT DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN) AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL)),0) VL_OPR,
                                               SUM(DECODE(I.CDFISCALIT,'1',I.VRBASECALCIT, 0) + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(I.CDFISCALIT,'1',CASE WHEN V_SGESTADO <> 'SP' THEN I.VRBASECALCIT ELSE 0 END, 0))) AS VL_BC_ICMS,
                                               SUM(DECODE(I.CDFISCALIT,'1',I.VRIMPOSTOIT,  0) + NVL(I.VRADICFECP,0) + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(I.CDFISCALIT,'1',CASE WHEN V_SGESTADO <> 'SP' THEN I.VRIMPOSTOIT  ELSE 0 END, 0))) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM, ITEMPRODUTO IT
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'E'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND I.CDFILIAL      = IT.CDFILIAL
                                           AND I.NRLANCTONF    = IT.NRLANCTONF
                                           AND I.NRSEQITPROD   = IT.NRSEQITPROD
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') > 0
                                         GROUP BY DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN), I.CDFISCOPERIT, DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0) ) T ) LOOP
                    INSERT INTO ARQMAGNETICO
                      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                    VALUES
                      ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC190.ARQ_C190, P_NRSEQARQMAG);
                    V_CONTREGC := NVL(V_CONTREGC,0) + 1;

                    IF P_VERSAO >= '013' THEN
                       FOR C_REGC191 IN (SELECT '|C191'          || '|' ||
                                                REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN DECODE(LENGTH(IP.CDFISCOPERSN),4,SUBSTR(IP.CDFISCOPERSN,2,3),IP.CDFISCOPERSN) <> '500' AND IM.CDIMPOSTONFE = '00'
                                                     THEN ROUND(IT.VRADICFECP,2)
                                                     ELSE 0 END),'999999999990.00')), '.', ',') || '|' ||
                                                REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN DECODE(LENGTH(IP.CDFISCOPERSN),4,SUBSTR(IP.CDFISCOPERSN,2,3),IP.CDFISCOPERSN) IN ('201','202','203','900') AND IM.CDIMPOSTONFE = '80'
                                                     THEN ROUND(IT.VRADICFECP,2)
                                                     ELSE 0 END),'999999999990.00')), '.', ',') || '|' ||
                                                REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN DECODE(LENGTH(IP.CDFISCOPERSN),4,SUBSTR(IP.CDFISCOPERSN,2,3),IP.CDFISCOPERSN) = '500'
                                                     THEN ROUND(IT.VRADICFECP,2)
                                                     ELSE 0 END),'999999999990.00')), '.', ',') || '|' AS ARQ_C191, IT.CDFISCOPERIT
                                           FROM ITEMPROIMPOS IT, ITEMPROIMPOS II, IMPOSTO IM, ITEMPRODUTO IP
                                          WHERE IT.CDFILIAL     = C_REGC100.CDFILIAL
                                            AND IT.NRLANCTONF   = C_REGC100.NRLANCTONF
                                            AND IT.CDFISCOPERIT = C_REGC190.COD_NAT
                                            AND IT.VRALIQITEM   = C_REGC190.ALIQ_ICMS
                                            AND IT.NRITPROIMPOS = '1'
                                            AND IT.CDFILIAL     = II.CDFILIAL
                                            AND IT.NRLANCTONF   = II.NRLANCTONF
                                            AND IT.NRSEQITPROD  = II.NRSEQITPROD
                                            AND II.CDFISCOPERIT = C_REGC190.COD_NAT
                                            AND II.CDIMPOSTO    = IM.CDIMPOSTO
                                            AND IM.CDIMPOSTONFE IN ('00','80')
                                            AND II.VRADICFECP   > 0
                                            AND II.CDFILIAL     = IP.CDFILIAL
                                            AND II.NRLANCTONF   = IP.NRLANCTONF
                                            AND II.NRSEQITPROD  = IP.NRSEQITPROD
                                            AND DECODE(LENGTH(IP.CDFISCOPERSN),4,SUBSTR(IP.CDFISCOPERSN,2,3),IP.CDFISCOPERSN) = C_REGC190.CST_ICMS
                                          GROUP BY IT.CDFISCOPERIT) LOOP
                          INSERT INTO ARQMAGNETICO
                             (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                          VALUES
                             ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC191.ARQ_C191, P_NRSEQARQMAG);
                          V_CONTREGC := NVL(V_CONTREGC,0) + 1;
                       END LOOP;
                    END IF;
                 END LOOP;
             END IF;
          END IF;
          /* geracao dos registros com diferencial  de aliquota */
          IF P_IDDIFALIQ = 'S' THEN
             SELECT MAX(SGESTADO)
               INTO V_SGESTADO
               FROM INSCRESTAD
              WHERE CDEMPRESA = P_CDEMPRESA
                AND CDINSCESTA = P_CDINSCESTA;

             IF C_REGC100.IDENTRSAIDOP = 'E' THEN

                /*BUSCA O CDIGO DE AJUSTE CADASTRADO PARA ESTA IE*/
                BEGIN
                   SELECT CDAJUSTEC195, IDGERREGC197, IDDIFEALIQUOTA
                     INTO V_CDAJUSTEC195,V_IDGERREGC197, V_IDDIFEALIQUOTA
                     FROM PARAMESTSPED
                    WHERE CDEMPRESA  = P_CDEMPRESA
                      AND CDINSCESTA = P_CDINSCESTA;
                EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                      V_CDAJUSTEC195:= NULL;
                      V_IDGERREGC197:= NULL;
                END;

                /* REGISTRO C195 */
                FOR C_REGC195 IN (SELECT REPLACE(LTRIM(TO_CHAR(ROUND(SUM(I.VRBASECALCIT),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND((SUM(I.VRIMPOSTOIT+NVL(I.VRADICFECP,0))/SUM(I.VRBASECALCIT))*100,2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(SUM(I.VRIMPOSTOIT+NVL(I.VRADICFECP,0)),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                         0 AS VL_OUTROS,
                                         'Diferencial de Alquota' AS DESCR_COMPL_AJ,
                                         V_CDAJUSTEC195 AS COD_AJ
                                    FROM ITEMPROIMPOS I, IMPOSTO IM
                                   WHERE NRITPROIMPOS    = '3'
                                     AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                     AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                     AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND I.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND V_CDAJUSTEC195  IS NOT NULL
                                     AND V_IDGERREGC197  = 'S'
                                     AND NVL(V_IDDIFEALIQUOTA,'DA') <> 'OD'
                                    GROUP BY V_CDAJUSTEC195,'Diferencial de Alquota')LOOP
                   INSERT INTO ARQMAGNETICO
                     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                   VALUES
                     ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C195'  || '|' || '000001' || '|' || ''  || '|', P_NRSEQARQMAG);
                   V_CONTREGC := NVL(V_CONTREGC,0) + 1;

                   IF NVL(V_IDGERREGC197,'N') = 'S' THEN
                      V_REG_C197 := '|C197'                   || '|' ||
                                    C_REGC195.COD_AJ          || '|' ||
                                    C_REGC195.DESCR_COMPL_AJ  || '|' ||
                                    ''                        || '|' ||
                                    C_REGC195.VL_BC_ICMS      || '|' ||
                                    C_REGC195.ALIQ_ICMS       || '|' ||
                                    C_REGC195.VL_ICMS         || '|' ||
                                    C_REGC195.VL_OUTROS       || '|' ;
                      INSERT INTO ARQMAGNETICO
                        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                      VALUES
                        ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), V_REG_C197, P_NRSEQARQMAG);
                      V_CONTREGC := NVL(V_CONTREGC,0) + 1;
                   END IF;
                   SELECT MAX(CDCHAVEREG)
                     INTO V_COD_OBS
                     FROM TMP_REGDADOSSPED
                    WHERE CDCHAVEREG = '000001'
                      AND CDREGISTRO = '0460';

                   IF (V_COD_OBS IS NULL) THEN

                      V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                      INSERT INTO TMP_REGDADOSSPED
                        (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
                      VALUES
                        ('0460', V_SEQUPROD, '000001', 'Diferencial de Alquota');
                   END IF;

                END LOOP;
             END IF;
          END IF;
       END LOOP;
   END IF;


   IF V_CDSITUCRT IN ('2','3') AND P_PERFIL = 'B' THEN
      FOR C_REGC300 IN (SELECT ('|C300'    || '|' ||
                               COD_MOD     || '|' ||
                               SERIE       || '|' ||
                               ''          || '|' ||
                               NUM_DOC     || '|' ||
                               NUM_DOC     || '|' ||
                               DT_DOC      || '|' ||
                               VL_DOC      || '|' ||
                               VL_PIS      || '|' ||
                               VL_COFINS   || '|' ||
                               COD_CTA     || '|' ) AS ARQ_C300, NRLANCTONF, CDFILIAL, COD_CTA
                          FROM (SELECT N.CDMODDOCFISC  AS COD_MOD,
                                       NVL(SS.CDSERIENFE,N.CDSERIE) AS SERIE,
                                       SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6) AS NUM_DOC,
                                       TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(N.VRNOTAFISC,2), '999999999990.00')), '.', ',') AS VL_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                       MAX((SELECT MAX(CONTCTBL_SPED(N.IDENTRSAIDOP,I.CDPRODUTO,N.CDTIPOOPER,N.CDFILIEMIT))
                                              FROM ITEMPRODUTO I
                                             WHERE I.CDFILIAL   = N.CDFILIAL
                                               AND I.NRLANCTONF = N.NRLANCTONF)) AS COD_CTA,
                                       I.NRLANCTONF, I.CDFILIAL
                                  FROM IMPOSTONF I, NOTAFISCAL N, IMPOSTO IM, SERIENF SS
                                 WHERE IM.CDIMPOSTONFE   = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU
                                   AND IM.CDIMPOSTO      = I.CDIMPOSTO
                                   AND N.CDMODDOCFISC    = '02'
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND I.CDFILIAL        = N.CDFILIAL
                                   AND I.NRLANCTONF      = N.NRLANCTONF
                                   AND N.IDENTRSAIDOP    = 'S'
                                   AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                   AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                   AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                   AND SS.CDSERIE(+)     = N.CDSERIE
                                   AND NVL(P_GERAFORSALE,'N')  = 'N'
                                   AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                 GROUP BY N.CDMODDOCFISC,  NVL(SS.CDSERIENFE,N.CDSERIE), SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6), N.DTEMISSAO,N.VRNOTAFISC,
                                       VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),
                                       VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),
                                       I.NRLANCTONF, I.CDFILIAL)) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC300.ARQ_C300, P_NRSEQARQMAG);
         V_CONTREGC := NVL(V_CONTREGC,0) + 1;

         /* PLANO DE CONTAS REFERENCIAL */
         SELECT MAX(CDCHAVEREG)
           INTO V_CONTCTBL
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_REGC300.COD_CTA
            AND CDREGISTRO = '0500';

         IF (V_CONTCTBL IS NULL) AND (C_REGC300.COD_CTA IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
               ('0500', V_SEQUPROD, C_REGC300.COD_CTA);
         END IF;
         V_CONTCTBL := NULL;

         FOR C_REGC310 IN (SELECT ('|C310'       || '|' ||
                                  LTRIM(N.NRNOTAFISC, '0')  || '|'  ) AS ARQ_C310
                             FROM NOTAFISCAL N
                            WHERE N.CDFILIAL = C_REGC300.CDFILIAL
                              AND N.NRLANCTONF = C_REGC300.NRLANCTONF
                              AND N.IDENTRSAIDOP = 'S'
                              AND N.IDSTATUS = 'C') LOOP
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC310.ARQ_C310, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         END LOOP;

         FOR C_REGC320 IN(SELECT ('|C320'         || '|' ||
                                   CDSITUTRIBIT    || '|' ||
                                   CDFISCOPERIT    || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(ROUND(IT.VRALIQITEM+NVL(IT.VRADICALIQFECP,0),2), '999999999990.00')), '.', ',')    || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(ABS(SUM(ROUND(IT.VRCONTITIMP,2))+NVL(SUM(ROUND(VALOR_REDUCAO(CDFILIAL, NRLANCTONF, CDSITUTRIBIT, NRSEQITPROD, CDFISCOPERIT, NULL, NULL, NULL),2)),0)), '999999999990.00')), '.', ',')    || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(SUM(ROUND(DECODE(CDFISCALIT,'1',IT.VRBASECALCIT,0) + DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(IT.CDFILIAL,IT.NRLANCTONF,IT.NRSEQITPROD,'03','B','1')),2)), '999999999990.00')), '.', ',')    || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(SUM(ROUND(DECODE(CDFISCALIT,'1',IT.VRIMPOSTOIT + NVL(IT.VRADICFECP,0), 0) + DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(IT.CDFILIAL,IT.NRLANCTONF,IT.NRSEQITPROD,'03','I','1')),2)), '999999999990.00')), '.', ',')    || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(ABS(NVL(SUM(ROUND(VALOR_REDUCAO(CDFILIAL, NRLANCTONF, CDSITUTRIBIT, NRSEQITPROD, CDFISCOPERIT, NULL, NULL, NULL),2)),0)), '999999999990.00')), '.', ',')    || '|' ||
                                   ''  || '|'  ) AS ARQ_C320, IT.CDFILIAL, IT.NRLANCTONF, IT.CDSITUTRIBIT, IT.CDFISCOPERIT, IT.VRALIQITEM+NVL(IT.VRADICALIQFECP,0) AS VRALIQITEM
                             FROM ITEMPROIMPOS IT, IMPOSTO IM
                            WHERE IT.CDFILIAL     = C_REGC300.CDFILIAL
                              AND IT.NRLANCTONF   = C_REGC300.NRLANCTONF
                              AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                              AND IM.CDIMPOSTO    = IT.CDIMPOSTO
                              AND IT.NRITPROIMPOS = '1'
                            GROUP BY IT.CDSITUTRIBIT, IT.CDFISCOPERIT, IT.VRALIQITEM+NVL(IT.VRADICALIQFECP,0),
                                  IT.CDFILIAL, IT.NRLANCTONF) LOOP
             INSERT INTO ARQMAGNETICO 
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES 
               ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC320.ARQ_C320, P_NRSEQARQMAG); 
             V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
             FOR C_REGC321 IN(SELECT ('|C321'         || '|' ||
                                      P.CDARVPROD      || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IT.QTITEMPROD),3), '999999999990.000')), '.', ',')  || '|' ||
                                      P.SGUNIDADE     || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ABS(ROUND(SUM(VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0),2)), '999999999990.00')), '.', ',')    || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IT.VRENCARGODESC),2), '999999999990.00')), '.', ',')    || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(CDFISCALIT,'1',I.VRBASECALCIT, 0)+DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','B','1'))),2), '999999999990.00')), '.', ',')   || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(CDFISCALIT,'1',I.VRIMPOSTOIT+NVL(I.VRADICFECP,0),0)+DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','I','1'))),2), '999999999990.00')), '.', ',')    || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1')),2), '999999999990.00')), '.', ',')    || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1')),2), '999999999990.00')), '.', ',')    || '|'  ) AS ARQ_C321,
                                      P.CDPRODUTO, P.SGUNIDADE UNID, IT.CDPRODNCMTRANS AS CDCLASFISC
                                 FROM ITEMPROIMPOS I, ITEMPRODUTO IT, PRODUTO P, IMPOSTO IM
                                WHERE IT.CDFILIAL     = C_REGC320.CDFILIAL
                                  AND IT.NRLANCTONF   = C_REGC320.NRLANCTONF
                                  AND I.CDFILIAL      = IT.CDFILIAL
                                  AND I.NRLANCTONF    = IT.NRLANCTONF
                                  AND I.NRSEQITPROD   = IT.NRSEQITPROD
                                  AND IT.CDPRODUTO    = P.CDPRODUTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                  AND I.VRALIQITEM+NVL(I.VRADICALIQFECP,0) = C_REGC320.VRALIQITEM
                                  AND I.CDSITUTRIBIT  = C_REGC320.CDSITUTRIBIT
                                  AND I.CDFISCOPERIT  = C_REGC320.CDFISCOPERIT
                                  AND I.NRITPROIMPOS  = '1'
                                GROUP BY P.CDARVPROD, P.CDPRODUTO, P.SGUNIDADE, IT.CDPRODNCMTRANS) LOOP
                   INSERT INTO ARQMAGNETICO 
                     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
                   VALUES 
                     ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC321.ARQ_C321, P_NRSEQARQMAG); 
                   V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
                /* CODIGO DO PRODUTO */
                SELECT MAX(CDCHAVEREG)
                  INTO V_PRODUTO 
                  FROM TMP_REGDADOSSPED 
                 WHERE CDCHAVEREG = C_REGC321.CDPRODUTO 
                   AND CDREGISTRO = '0200';
                IF (V_PRODUTO IS NULL) AND (C_REGC321.CDPRODUTO IS NOT NULL) THEN
                   V_SEQUPROD := NVL(V_SEQUPROD,0) + 1; 
                   INSERT INTO TMP_REGDADOSSPED 
                     (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
                   VALUES 
                     ('0200', V_SEQUPROD, C_REGC321.CDPRODUTO, C_REGC321.CDCLASFISC);
                END IF; 
                V_PRODUTO := NULL; 
                /* UNIDADE DE MEDIDA */
                SELECT MAX(CDCHAVEREG) 
                  INTO V_UNID 
                  FROM TMP_REGDADOSSPED 
                 WHERE CDCHAVEREG = C_REGC321.UNID 
                   AND CDREGISTRO = '0190'; 
                IF (V_UNID IS NULL) AND (C_REGC321.UNID IS NOT NULL) THEN 
                   V_SEQUPROD := NVL(V_SEQUPROD,0) + 1; 
                   INSERT INTO TMP_REGDADOSSPED 
                     (CDREGISTRO, CDCONTREGI, CDCHAVEREG) 
                   VALUES 
                     ('0190', V_SEQUPROD, C_REGC321.UNID); 
                END IF; 
                V_UNID := NULL; 
             END LOOP; 
          END LOOP; 
       END LOOP; 
   END IF;
 
   IF V_CDSITUCRT = '1' AND P_PERFIL = 'B' THEN /*SIMPLES NACIONAL*/
      FOR C_REGC300 IN (SELECT '|C300'     || '|' ||
                               COD_MOD     || '|' ||
                               SERIE       || '|' ||
                               ''          || '|' ||
                               NUM_DOC     || '|' ||
                               NUM_DOC     || '|' ||
                               DT_DOC      || '|' ||
                               VL_DOC      || '|' ||
                               VL_PIS      || '|' ||
                               VL_COFINS   || '|' ||
                               COD_CTA     || '|'  AS ARQ_C300, NRLANCTONF, CDFILIAL, COD_CTA
                          FROM (SELECT N.CDMODDOCFISC AS COD_MOD,
                                       NVL(SS.CDSERIENFE,N.CDSERIE) AS SERIE,
                                       SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6) AS NUM_DOC,
                                       TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(N.VRNOTAFISC,2), '999999999990.00')), '.', ',') AS VL_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                       MAX((SELECT MAX(CONTCTBL_SPED(N.IDENTRSAIDOP,I.CDPRODUTO,N.CDTIPOOPER,N.CDFILIEMIT))
                                              FROM ITEMPRODUTO I
                                             WHERE I.CDFILIAL   = N.CDFILIAL
                                               AND I.NRLANCTONF = N.NRLANCTONF)) AS COD_CTA, I.NRLANCTONF, I.CDFILIAL
                                  FROM IMPOSTONF I, NOTAFISCAL N, IMPOSTO IM, SERIENF SS
                                 WHERE IM.CDIMPOSTONFE = P_CDIMPOSTO
                                   AND N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                   AND N.CDINSCESTA    = P_CDINSCESTA
                                   AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                   AND N.CDMODDOCFISC  = '02'
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND I.CDFILIAL      = N.CDFILIAL
                                   AND I.NRLANCTONF    = N.NRLANCTONF
                                   AND N.IDENTRSAIDOP  = 'S'
                                   AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                   AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                   AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                   AND SS.CDSERIE(+)     = N.CDSERIE
                                   AND NVL(P_GERAFORSALE,'N') = 'N'
                                   AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                 GROUP BY N.CDMODDOCFISC, NVL(SS.CDSERIENFE,N.CDSERIE), SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6), N.DTEMISSAO,N.VRNOTAFISC,
                                       VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'), VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),
                                       I.NRLANCTONF, I.CDFILIAL)) LOOP

         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC300.ARQ_C300, P_NRSEQARQMAG);
         V_CONTREGC := NVL(V_CONTREGC,0) + 1;

         /* PLANO DE CONTAS REFERENCIAL */
         SELECT MAX(CDCHAVEREG)
           INTO V_CONTCTBL
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_REGC300.COD_CTA
            AND CDREGISTRO = '0500';

         IF (V_CONTCTBL IS NULL) AND (C_REGC300.COD_CTA IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
               ('0500', V_SEQUPROD, C_REGC300.COD_CTA);
         END IF;
         V_CONTCTBL := NULL;

         FOR C_REGC310 IN (SELECT ('|C310'       || '|' ||
                                  LTRIM(N.NRNOTAFISC, '0')  || '|'  ) AS ARQ_C310
                             FROM NOTAFISCAL N
                            WHERE N.CDFILIAL = C_REGC300.CDFILIAL
                              AND N.NRLANCTONF = C_REGC300.NRLANCTONF
                              AND N.IDENTRSAIDOP = 'S'
                              AND N.IDSTATUS = 'C') LOOP
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC310.ARQ_C310, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         END LOOP;

         FOR C_REGC320 IN (SELECT ('|C320'         || '|' ||
                                  CDSITUTRIBIT    || '|' ||
                                  CDFISCOPERIT    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(IT.VRALIQITEM+NVL(IT.VRADICALIQFECP,0),2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ABS(ROUND(SUM(IT.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(IT.CDFILIAL, IT.NRLANCTONF, IT.CDSITUTRIBIT, IT.NRSEQITPROD, IT.CDFISCOPERIT, NULL, NULL, NULL)),0),2)), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(IT.CDFISCALIT,'1',IT.VRBASECALCIT,0)+DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(IT.CDFILIAL,IT.NRLANCTONF,IT.NRSEQITPROD,'03','I','1'))),2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT+NVL(IT.VRADICFECP,0), 0)+DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(IT.CDFILIAL,IT.NRLANCTONF,IT.NRSEQITPROD,'03','I','1'))),2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ABS(ROUND(NVL(SUM(VALOR_REDUCAO(IT.CDFILIAL, IT.NRLANCTONF, IT.CDSITUTRIBIT, IT.NRSEQITPROD, IT.CDFISCOPERIT, NULL, NULL, NULL) ),0),2)), '999999999990.00')), '.', ',')    || '|' ||
                                  ''  || '|'  ) AS ARQ_C320, IT.CDFILIAL, IT.NRLANCTONF, IT.CDSITUTRIBIT, IT.CDFISCOPERIT, IT.VRALIQITEM+NVL(IT.VRADICALIQFECP,0) AS VRALIQITEM
                             FROM ITEMPROIMPOS IT, IMPOSTO IM
                            WHERE IT.CDFILIAL     = C_REGC300.CDFILIAL
                              AND IT.NRLANCTONF   = C_REGC300.NRLANCTONF
                              AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                              AND IM.CDIMPOSTO    = IT.CDIMPOSTO
                              AND IT.NRITPROIMPOS = '1'
                            GROUP BY IT.CDSITUTRIBIT, IT.CDFISCOPERIT, IT.VRALIQITEM+NVL(IT.VRADICALIQFECP,0),
                                  IT.CDFILIAL, IT.NRLANCTONF) LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC320.ARQ_C320, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;

            FOR C_REGC321 IN (SELECT ('|C321'         || '|' ||
                                     P.CDARVPROD      || '|' ||
                                     ROUND(SUM(IT.QTITEMPROD),3)   || '|' ||
                                     P.SGUNIDADE     || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ABS(ROUND(SUM(VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0),2)), '999999999990.00')), '.', ',')    || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IT.VRENCARGODESC),2), '999999999990.00')), '.', ',')    || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(CDFISCALIT,'1',VRBASECALCIT, 0)+DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','I','1'))),2), '999999999990.00')), '.', ',')   || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(CDFISCALIT,'1',I.VRIMPOSTOIT+NVL(I.VRADICFECP,0),0)+DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','I','1'))),2), '999999999990.00')), '.', ',')   || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1')),2), '999999999990.00')), '.', ',')    || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1')),2), '999999999990.00')), '.', ',')    || '|'  ) AS ARQ_C321,
                                     P.CDPRODUTO, P.SGUNIDADE AS UNID, IT.CDPRODNCMTRANS AS CDCLASFISC
                                FROM ITEMPROIMPOS I, ITEMPRODUTO IT, PRODUTO P, IMPOSTO IM
                               WHERE IT.CDFILIAL     = C_REGC320.CDFILIAL
                                 AND IT.NRLANCTONF   = C_REGC320.NRLANCTONF
                                 AND I.CDFILIAL      = IT.CDFILIAL
                                 AND I.NRLANCTONF    = IT.NRLANCTONF
                                 AND I.NRSEQITPROD   = IT.NRSEQITPROD
                                 AND IT.CDPRODUTO    = P.CDPRODUTO
                                 AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                 AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                 AND I.VRALIQITEM+NVL(I.VRADICALIQFECP,0) = C_REGC320.VRALIQITEM
                                 AND CDSITUTRIBIT    = C_REGC320.CDSITUTRIBIT
                                 AND CDFISCOPERIT    = C_REGC320.CDFISCOPERIT
                                 AND NRITPROIMPOS    = '1'
                               GROUP BY P.CDARVPROD, P.CDPRODUTO, P.SGUNIDADE, IT.CDPRODNCMTRANS) LOOP

               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC321.ARQ_C321, P_NRSEQARQMAG);
               V_CONTREGC := NVL(V_CONTREGC,0) + 1;

               /* CODIGO DO PRODUTO */
               SELECT MAX(CDCHAVEREG)
                 INTO V_PRODUTO
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC321.CDPRODUTO
                  AND CDREGISTRO = '0200';
               IF (V_PRODUTO IS NULL) AND (C_REGC321.CDPRODUTO IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
                  VALUES
                    ('0200', V_SEQUPROD, C_REGC321.CDPRODUTO, C_REGC321.CDCLASFISC);
               END IF;
               V_PRODUTO := NULL;

               /* UNIDADE DE MEDIDA */
               SELECT MAX(CDCHAVEREG)
                 INTO V_UNID
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC321.UNID
                  AND CDREGISTRO = '0190';
               IF (V_UNID IS NULL) AND (C_REGC321.UNID IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                  VALUES
                    ('0190', V_SEQUPROD, C_REGC321.UNID);
               END IF;
               V_UNID := NULL;
            END LOOP;
         END LOOP;
      END LOOP;
   END IF;

   IF V_CDSITUCRT IN ('2','3') AND P_PERFIL = 'A' THEN
      /*REGISTRO C350*/
      FOR C_REGC350 IN (SELECT '|C350'       || '|' ||
                               SERIE         || '|' ||
                               ''            || '|' ||
                               NUM_DOC       || '|' ||
                               DT_DOC        || '|' ||
                               CNPJ_CPF      || '|' || --CPF_CNPJ
                               VL_MERC       || '|' ||
                               VL_DOC        || '|' ||
                               VL_DESC       || '|' ||
                               VL_PIS        || '|' ||
                               VL_COFINS     || '|' ||
                               COD_CTA       || '|' AS ARQ_C350, NRLANCTONF, CDFILIAL, CDCLIENTE, CDCAIXA, COD_CTA
                          FROM (SELECT NVL(SS.CDSERIENFE,N.CDSERIE) AS SERIE,
                                       SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6) AS NUM_DOC,
                                       TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                       NVL(SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(CASE WHEN (LENGTH(N.NRINSJURNF) = 14 OR LENGTH(N.NRINSJURNF) = 11) THEN N.NRINSJURNF ELSE N.NRINSJURNFPAULI END,'.'),'-'),'/'),' '),1,14),'') AS CNPJ_CPF,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(N.VRPRODUTOS,2), '999999999990.00')), '.', ',') AS VL_MERC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(N.VRNOTAFISC,2), '999999999990.00')), '.', ',') AS VL_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(SUM(T.VRITEMENCA),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                       MAX((SELECT MAX(CONTCTBL_SPED(N.IDENTRSAIDOP,I.CDPRODUTO,N.CDTIPOOPER,N.CDFILIEMIT))
                                                     FROM ITEMPRODUTO I
                                                    WHERE I.CDFILIAL   = N.CDFILIAL
                                                      AND I.NRLANCTONF = N.NRLANCTONF)) AS COD_CTA,
                                       I.NRLANCTONF, I.CDFILIAL, N.CDCLIENTE, '' AS  CDCAIXA
                                  FROM IMPOSTONF I, NOTAFISCAL N, ENCARGO E, ITEMENCARGO T, IMPOSTO IM, SERIENF SS
                                 WHERE I.CDIMPOSTO      = IM.CDIMPOSTO
                                   AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU   = V_NRSEQUMAPAPU
                                   AND N.CDFILIAL       = T.CDFILIAL
                                   AND N.NRLANCTONF     = T.NRLANCTONF
                                   AND E.CDENCARGO      = T.CDENCARGO
                                   AND E.IDENCARGO      = 'D'
                                   AND N.CDMODDOCFISC   = '02'
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND I.CDFILIAL       = N.CDFILIAL
                                   AND I.NRLANCTONF     = N.NRLANCTONF
                                   AND N.IDENTRSAIDOP   = 'S'
                                   AND SS.CDEMPRESA(+)  = N.CDEMPRESA
                                   AND SS.CDINSCESTA(+) = N.CDINSCESTA
                                   AND SS.CDINSCMUNI(+) = N.CDINSCMUNI
                                   AND SS.CDSERIE(+)    = N.CDSERIE
                                   AND NVL(P_GERAFORSALE,'N') = 'N'
                                   AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                 GROUP BY NVL(SS.CDSERIENFE,N.CDSERIE), SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                       N.CDCLIENTE, N.VRPRODUTOS, N.VRNOTAFISC,
                                       VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),
                                       VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),
                                       I.NRLANCTONF, I.CDFILIAL, '',
                                       NVL(SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(CASE WHEN (LENGTH(N.NRINSJURNF) = 14 OR LENGTH(N.NRINSJURNF) = 11) THEN N.NRINSJURNF ELSE N.NRINSJURNFPAULI END,'.'),'-'),'/'),' '),1,14),'')
                                 UNION
                                 /*GERA C350 PARA O FORSALE - C300 FOS*/
                                SELECT 'D' AS SERIE,
                                       SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6) AS NUM_DOC,
                                       TO_CHAR(DTEMISSAO,'DDMMYYYY') AS DT_DOC,
                                       NVL(REPLACE(REPLACE(REPLACE(REPLACE(NRINSCRCONS,'.'),'-'),'/'),' '),'') AS CNPJ_CPF,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC+VRDESITVEND,2), '999999999990.00')), '.', ',') AS VL_MERC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '999999999990.00')), '.', ',')  AS VL_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRDESITVEND,2), '999999999990.00')), '.', ',') AS VL_DESC,
                                       '0,00' AS VL_PIS,
                                       '0,00' AS VL_COFINS,
                                       CONTCTBL_SPED('S','',CDTIPOOPER,CDFILIAL) AS COD_CTA,
                                       NRLANCTONF, CDFILIAL, '' CDCLIENTE, CDCAIXA
                                  FROM (SELECT VE.DTENTRVENDA AS DTEMISSAO, VE.NRSERIEVND AS CDSERIE ,VE.NRSUBSERIEVND ,VE.NRORDEMVND AS NRNOTAFISC,
                                               SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS VRNOTAFISC,
                                               SUM(VRDESITVEND) AS VRDESITVEND, PV.CDTPOPERCNTREC AS CDTIPOOPER,
                                               VE.CDFILIAL, VE.NRSEQVENDA AS NRLANCTONF, VE.CDCAIXA, VE.NRINSCRCONS
                                          FROM VENDA VE, ITEMVENDA IT, PARAVEND PV
                                         WHERE VE.CDEMPRESA     =  P_CDEMPRESA
                                           AND VE.CDFILIAL      = IT.CDFILIAL
                                           AND VE.NRSEQVENDA    = IT.NRSEQVENDA
                                           AND VE.CDCAIXA       = IT.CDCAIXA
                                           AND VE.DTENTRVENDA   BETWEEN P_DTINICIAL AND P_DTFINAL
                                           AND VE.IDSITUVENDA   = 'O'
                                           AND VE.NRORDEMVND    IS NOT NULL
                                           AND VE.NRSUBSERIEVND IS NOT NULL
                                           AND VE.NRSERIEVND    IS NOT NULL
                                           AND NVL(P_GERAFORSALE,'N') = 'S'
                                           AND VE.CDFILIAL      = PV.CDFILIAL(+)
                                         GROUP BY VE.DTENTRVENDA, VE.NRSERIEVND, VE.NRSUBSERIEVND, VE.NRORDEMVND, VE.NRSEQVENDA,
                                               VE.CDFILIAL, VE.CDCAIXA, VE.NRINSCRCONS, PV.CDTPOPERCNTREC))) LOOP
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('24'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC350.ARQ_C350, P_NRSEQARQMAG);
         V_CONTREGC := NVL(V_CONTREGC,0) + 1;

         /* PLANO DE CONTAS REFERENCIAL */
         SELECT MAX(CDCHAVEREG)
           INTO V_CONTCTBL
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_REGC350.COD_CTA
            AND CDREGISTRO = '0500';

         IF (V_CONTCTBL IS NULL) AND (C_REGC350.COD_CTA IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
               ('0500', V_SEQUPROD, C_REGC350.COD_CTA);
         END IF;
         V_CONTCTBL := NULL;

         V_NRSEQITEM := 0;
         FOR C_REGC370 IN(SELECT (P.CDARVPROD  || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '99999999990.000')), '.', ',')  ||'|'||
                                  P.SGUNIDADE               || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND((SUM(I.VRCONTITIMP)),2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND((SUM(IT.VRENCARGODESC)),2), '999999999990.00')), '.', ',')    || '|' ) AS ARQ_C370,
                                  P.CDPRODUTO, P.SGUNIDADE AS UNID, IT.CDPRODNCMTRANS AS CDCLASFISC
                            FROM ITEMPROIMPOS I, ITEMPRODUTO IT, PRODUTO P, IMPOSTO IM
                           WHERE IT.CDFILIAL      = C_REGC350.CDFILIAL
                             AND IT.NRLANCTONF    = C_REGC350.NRLANCTONF
                             AND I.CDIMPOSTO      = IM.CDIMPOSTO
                             AND I.CDFILIAL       = IT.CDFILIAL
                             AND I.NRLANCTONF     = IT.NRLANCTONF
                             AND I.NRSEQITPROD    = IT.NRSEQITPROD
                             AND IT.CDPRODUTO     = P.CDPRODUTO
                             AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                             AND NVL(P_GERAFORSALE,'N') = 'N'
                           GROUP BY SUBSTR(I.NRSEQITPROD,2,3), P.CDARVPROD, IT.QTITEMPROD, P.SGUNIDADE, P.CDPRODUTO, IT.CDPRODNCMTRANS
                           UNION
                          SELECT CDARVPROD    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(QTPRODVEND,3), '99999999990.000')), '.', ',')  ||'|'||
                                 SGUNIDADE    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_TOT_IT,2), '999999999990.00')), '.', ',')   ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VRDESITVEND,2), '999999999990.00')), '.', ',') ||'|' AS ARQ_C370,
                                 CDPRODUTO, SGUNIDADE AS UNID, CDCLASFISC
                           FROM (SELECT NRSEQUITVEND,
                                        CDARVPROD,
                                        QTPRODVEND,
                                        P.SGUNIDADE,
                                        (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)+NVL(IV.VRACRITVEND,0)) AS VR_TOT_IT,
                                        VRDESITVEND, P.CDPRODUTO, IV.CDCLASFISC
                                   FROM ITEMVENDA IV, PRODUTO P
                                  WHERE IV.CDFILIAL = C_REGC350.CDFILIAL
                                    AND IV.CDCAIXA = C_REGC350.CDCAIXA
                                    AND IV.NRSEQVENDA =  C_REGC350.NRLANCTONF
                                    AND NVL(P_GERAFORSALE,'N') = 'S'
                                    AND IV.CDPRODUTO = P.CDPRODUTO)NF) LOOP

               V_NRSEQITEM := NVL(V_NRSEQITEM,0)+1;
               INSERT INTO ARQMAGNETICO
                 (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
               VALUES
                 ('24'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C370|'||LPAD(V_NRSEQITEM,3,'0')||'|'||C_REGC370.ARQ_C370, P_NRSEQARQMAG);
               V_CONTREGC := NVL(V_CONTREGC,0) + 1;
 
               /* CODIGO DO PRODUTO */
               SELECT MAX(CDCHAVEREG)
                 INTO V_PRODUTO
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC370.CDPRODUTO
                  AND CDREGISTRO = '0200';

               IF (V_PRODUTO IS NULL) AND (C_REGC370.CDPRODUTO IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1; 
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
                  VALUES
                    ('0200', V_SEQUPROD, C_REGC370.CDPRODUTO, C_REGC370.CDCLASFISC);
               END IF;
               V_PRODUTO := NULL;

               /* UNIDADE DE MEDIDA */
               SELECT MAX(CDCHAVEREG)
                 INTO V_UNID 
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC370.UNID
                  AND CDREGISTRO = '0190';

               IF (V_UNID IS NULL) AND (C_REGC370.UNID IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                  VALUES
                    ('0190', V_SEQUPROD, C_REGC370.UNID);
               END IF;
               V_UNID := NULL;
         END LOOP;

         FOR C_REGC390 IN(SELECT ('|C390'         || '|' ||
                                  NF.CDSITUTRIBNF|| '|' ||
                                  NF.CDFISCOPERNF    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRALIQNF,2),     '999999999990.00')), '.', ',')  || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF,2), '999999999990.00')), '.', ',')  || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRBASECALCNF + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(NF.VRBASECARGA,0))),2), '999999999990.00')), '.', ',')  || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRIMPOSTONF  + DECODE(V_IDTPCARGATRIB,'O',0,NVL(NF.VRIMPCARGA, 0)),2), '999999999990.00')), '.', ',')  || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRREDBCALC,2),   '999999999990.00')), '.', ',')  || '|' ||
                                  ''  || '|'  ) AS ARQ_C390, CDFISCOPERNF
                            FROM (SELECT NVL(CDSITUTRIBNF,'000') AS CDSITUTRIBNF,
                                         CDFISCOPERNF,
                                         VRALIQNF+NVL(VRADICFECP,0) AS VRALIQNF,
                                         SUM(ROUND(VRCONTABILNF,2)) AS VRCONTABILNF,
                                         SUM((SELECT SUM(ROUND(VRBASECALCNF,2))
                                                FROM IMPOSTONF IP
                                               WHERE IP.CDFILIAL     = I.CDFILIAL
                                                 AND IP.NRLANCTONF   = I.NRLANCTONF
                                                 AND IP.CDFISCOPERNF = I.CDFISCOPERNF
                                                 AND IP.CDIMPOSTO    = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                         SUM(ROUND(VRBASECALCNF,2)) AS VRBASECALCNF,
                                         SUM(ROUND(VRIMPCARGATRIBI,2)) AS VRIMPCARGA,
                                         SUM(ROUND(VRIMPOSTONF+NVL(VRADICFECP,0),2)) AS VRIMPOSTONF,
                                         SUM(ROUND(DECODE(IDIMPOSTONF,'2',VRCONTABILNF,'0'),2)) AS VRREDBCALC
                                    FROM IMPOSTONF I, IMPOSTO IM
                                   WHERE I.CDFILIAL      = C_REGC350.CDFILIAL
                                     AND I.NRLANCTONF    = C_REGC350.NRLANCTONF
                                     AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                     AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                     AND IDIMPOSTONF     <> '3'
                                     AND NVL(P_GERAFORSALE,'N') = 'N' 
                                   GROUP BY NVL(CDSITUTRIBNF,'000'), CDFISCOPERNF, VRALIQNF+NVL(VRADICFECP,0))NF
                           UNION
                          /*GERA REGISTRO C390 PARA O FOS - C390 FOS*/
                          SELECT '|C390'      ||'|'||
                                 CDSITUTRIBIT ||'|'||
                                 CDFISCOPERIT ||'|'||
                                 VRALIQITEM   ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_OPER,2), '999999999990.00')), '.', ',')    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_BC_ICMS,2), '999999999990.00')), '.', ',') ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_ICMS,2), '999999999990.00')), '.', ',')    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_RED,2), '999999999990.00')), '.', ',')     ||'|'||
                                 COD_OB       ||'|' AS ARQ_C390, CDFISCOPERIT AS CDFISCOPERNF
                            FROM (SELECT (NVL(LPAD(IVI.CDCSTPRODI,3,'0'), CASE WHEN IP.IDTPIMPOSFIS = 'T' THEN '000'
                                                                               WHEN IP.IDTPIMPOSFIS = 'I' THEN '040'
                                                                               WHEN IP.IDTPIMPOSFIS = 'F' THEN '060'
                                                                               WHEN IP.IDTPIMPOSFIS = 'N' THEN '041' END)) AS CDSITUTRIBIT,
                                         NVL(IVI.CDCSTPRODPC,'5102')  AS CDFISCOPERIT,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(IVI.VRPEALPRODIT,2), '999999999990.00')), '.', ',') AS VRALIQITEM,
                                         (CASE WHEN IP.CDIMPOSTONFE = P_CDIMPOSTO
                                               THEN SUM(TRUNC(IV.QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0))
                                               ELSE 0 END) AS VR_OPER,
                                         (CASE WHEN IP.IDTPIMPOSFIS = 'T' AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                               THEN SUM(TRUNC(IV.QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0))
                                               ELSE 0 END) AS VR_BC_ICMS,
                                         (CASE WHEN IP.IDTPIMPOSFIS = 'T' AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                               THEN SUM(IVI.VRIMPOPRODIT)
                                               ELSE 0 END) AS VR_ICMS,
                                         0 AS VR_RED,'' AS COD_OB, IP.CDIMPOSTONFE
                                    FROM ITEMVENDA IV, ITVENDAIMPOS IVI, IMPOSTO IP
                                   WHERE IV.CDFILIAL     = IVI.CDFILIAL
                                     AND IV.CDCAIXA      = IVI.CDCAIXA
                                     AND IV.NRSEQUITVEND = IVI.NRSEQUITVEND
                                     AND IV.NRSEQVENDA   = IVI.NRSEQVENDA
                                     AND IV.CDFILIAL     = C_REGC350.CDFILIAL
                                     AND IV.CDCAIXA      =  C_REGC350.CDCAIXA
                                     AND IV.NRSEQVENDA   = C_REGC350.NRLANCTONF
                                     AND NVL(P_GERAFORSALE,'N') = 'S'
                                     AND IP.CDIMPOSTO    = IVI.CDIMPOSTO
                                   GROUP BY IVI.CDCSTPRODI, IVI.CDCSTPRODPC, IP.IDTPIMPOSFIS, IVI.VRPEALPRODIT, IP.CDIMPOSTONFE)NF
                           WHERE NF.CDIMPOSTONFE = P_CDIMPOSTO) LOOP
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('24'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC390.ARQ_C390, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         END LOOP;
      END LOOP;
   END IF;

   IF V_CDSITUCRT = '1' AND P_PERFIL = 'A' THEN  /*SIMPLES NACIONAL*/
      /*REGISTRO C350*/
      FOR C_REGC350 IN (SELECT '|C350'     || '|' ||
                               SERIE       || '|' ||
                               ''          || '|' ||
                               NUM_DOC     || '|' ||
                               DT_DOC      || '|' ||
                               CNPJ_CPF    || '|' ||
                               VL_MERC     || '|' ||
                               VL_DOC      || '|' ||
                               VL_DESC     || '|' ||
                               VL_PIS      || '|' ||
                               VL_COFINS   || '|' ||
                               COD_CTA     || '|' AS ARQ_C350, NRLANCTONF, CDFILIAL, CDCLIENTE, CDCAIXA, COD_CTA
                          FROM (SELECT NVL(SS.CDSERIENFE,N.CDSERIE) AS SERIE,
                                       LTRIM(NRNOTAFISC, '0') AS NUM_DOC,
                                       TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                       NVL(SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(N.NRINSJURNF,'.'),'-'),'/'),' '),1,14),'') AS CNPJ_CPF,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(N.VRPRODUTOS,2), '999999999990.00')), '.', ',') AS VL_MERC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(N.VRNOTAFISC,2), '999999999990.00')), '.', ',') AS VL_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(SUM(T.VRITEMENCA),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                       MAX((SELECT MAX(CONTCTBL_SPED(N.IDENTRSAIDOP,I.CDPRODUTO,N.CDTIPOOPER,N.CDFILIEMIT))
                                                     FROM ITEMPRODUTO I
                                                    WHERE I.CDFILIAL   = N.CDFILIAL
                                                      AND I.NRLANCTONF = N.NRLANCTONF)) AS COD_CTA,
                                       I.NRLANCTONF, I.CDFILIAL, N.CDCLIENTE, '' AS  CDCAIXA
                                  FROM IMPOSTONF I, NOTAFISCAL N, ENCARGO E, ITEMENCARGO T, IMPOSTO IM, SERIENF SS
                                 WHERE I.CDIMPOSTO = IM.CDIMPOSTO
                                   AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                   AND N.NRSEQUMAPAPUSN = V_NRSEQUMAPAPU
                                   AND N.CDINSCESTA = P_CDINSCESTA
                                   AND N.CDFILIAL = T.CDFILIAL
                                   AND N.NRLANCTONF = T.NRLANCTONF
                                   AND E.CDENCARGO = T.CDENCARGO
                                   AND E.IDENCARGO = 'D'
                                   AND N.CDMODDOCFISC = '02'
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND I.CDFILIAL = N.CDFILIAL
                                   AND I.NRLANCTONF = N.NRLANCTONF
                                   AND N.IDENTRSAIDOP = 'S'
                                   AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                   AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                   AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                   AND SS.CDSERIE(+)     = N.CDSERIE
                                   AND NVL(P_GERAFORSALE,'N') = 'N'
                                   AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                 GROUP BY NVL(SS.CDSERIENFE,N.CDSERIE), LTRIM(NRNOTAFISC, '0'),TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                          NVL(SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(N.NRINSJURNF,'.'),'-'),'/'),' '),1,14),''),
                                          N.CDCLIENTE, N.VRPRODUTOS, N.VRNOTAFISC,
                                          VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),
                                          VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),
                                          I.NRLANCTONF, I.CDFILIAL, ''
                                 UNION
                                /*GERA C350 PARA O FORSALE - C300 FOS*/
                                SELECT 'D' AS SERIE,
                                       SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6) AS NUM_DOC,
                                       TO_CHAR(DTEMISSAO,'DDMMYYYY') AS DT_DOC,
                                       NVL(REPLACE(REPLACE(REPLACE(REPLACE(NRINSCRCONS,'.'),'-'),'/'),' '),'') AS CNPJ_CPF,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC+VRDESITVEND,2), '999999999990.00')), '.', ',') AS VL_MERC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '999999999990.00')), '.', ',') AS VL_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRDESITVEND,2), '999999999990.00')), '.', ',') AS VL_DESC,
                                       '0,00' AS VL_PIS,
                                       '0,00' AS VL_COFINS,
                                       CONTCTBL_SPED('S','',CDTIPOOPER,CDFILIAL) AS COD_CTA,
                                       NRLANCTONF, CDFILIAL, '' CDCLIENTE ,CDCAIXA
                                  FROM (SELECT VE.DTENTRVENDA AS DTEMISSAO, VE.NRSERIEVND AS CDSERIE ,VE.NRSUBSERIEVND ,VE.NRORDEMVND AS NRNOTAFISC,
                                               SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS VRNOTAFISC,
                                               SUM(VRDESITVEND) AS VRDESITVEND, PV.CDTPOPERCNTREC AS CDTIPOOPER,
                                               VE.CDFILIAL, VE.NRSEQVENDA AS NRLANCTONF, VE.CDCAIXA, VE.NRINSCRCONS
                                          FROM VENDA VE, ITEMVENDA IT, PARAVEND PV
                                         WHERE VE.CDEMPRESA   =  P_CDEMPRESA
                                           AND VE.CDFILIAL    = IT.CDFILIAL
                                           AND VE.NRSEQVENDA  = IT.NRSEQVENDA
                                           AND VE.CDCAIXA     = IT.CDCAIXA
                                           AND VE.DTENTRVENDA BETWEEN P_DTINICIAL AND P_DTFINAL
                                           AND VE.IDSITUVENDA = 'O'
                                           AND VE.NRORDEMVND  IS NOT NULL
                                           AND NVL(P_GERAFORSALE,'N') = 'S'
                                           AND VE.CDFILIAL    = PV.CDFILIAL(+)
                                         GROUP BY VE.DTENTRVENDA, VE.NRSERIEVND,VE.NRSUBSERIEVND, VE.NRORDEMVND, VE.NRSEQVENDA,
                                               VE.CDFILIAL, VE.CDCAIXA, VE.NRINSCRCONS, PV.CDTPOPERCNTREC))) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('24'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC350.ARQ_C350, P_NRSEQARQMAG);
         V_CONTREGC := NVL(V_CONTREGC,0) + 1;

         /* PLANO DE CONTAS REFERENCIAL */
         SELECT MAX(CDCHAVEREG)
           INTO V_CONTCTBL
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_REGC350.COD_CTA
            AND CDREGISTRO = '0500';

         IF (V_CONTCTBL IS NULL) AND (C_REGC350.COD_CTA IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
               ('0500', V_SEQUPROD, C_REGC350.COD_CTA);
         END IF;
         V_CONTCTBL := NULL;

         V_NRSEQITEM := 0;
         FOR C_REGC370 IN(SELECT (P.CDARVPROD  || '|' ||
                                  IT.QTITEMPROD             || '|' ||
                                  P.SGUNIDADE               || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND((SUM(I.VRCONTITIMP)),2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND((SUM(IT.VRENCARGODESC)),2), '999999999990.00')), '.', ',')    || '|' ) AS ARQ_C370,
                                  P.CDPRODUTO, P.SGUNIDADE AS UNID, IT.CDPRODNCMTRANS AS CDCLASFISC
                            FROM ITEMPROIMPOS I, ITEMPRODUTO IT, PRODUTO P, IMPOSTO IM
                           WHERE IT.CDFILIAL      = C_REGC350.CDFILIAL
                             AND IT.NRLANCTONF    = C_REGC350.NRLANCTONF
                             AND I.CDIMPOSTO      = IM.CDIMPOSTO
                             AND I.CDFILIAL       = IT.CDFILIAL
                             AND I.NRLANCTONF     = IT.NRLANCTONF
                             AND I.NRSEQITPROD    = IT.NRSEQITPROD
                             AND IT.CDPRODUTO     = P.CDPRODUTO
                             AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                             AND NVL(P_GERAFORSALE,'N') = 'N'
                           GROUP BY SUBSTR(I.NRSEQITPROD,2,3), P.CDARVPROD, IT.QTITEMPROD, P.SGUNIDADE, P.CDPRODUTO, IT.CDPRODNCMTRANS
                           UNION
                          SELECT CDARVPROD    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(QTPRODVEND, 3), '99999999990.000')), '.', ',') ||'|'||
                                 SGUNIDADE    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_TOT_IT,  2), '999999999990.00')), '.', ',') ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VRDESITVEND,2), '999999999990.00')), '.', ',') ||'|' AS ARQ_C370,
                                 CDPRODUTO, SGUNIDADE AS UNID, CDCLASFISC
                           FROM (SELECT NRSEQUITVEND,
                                        P.CDARVPROD,
                                        QTPRODVEND,
                                        P.SGUNIDADE,
                                        (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)+NVL(IV.VRACRITVEND,0))  AS VR_TOT_IT,
                                        VRDESITVEND, P.CDPRODUTO, IV.CDCLASFISC
                                   FROM ITEMVENDA IV, PRODUTO P
                                  WHERE IV.CDFILIAL   = C_REGC350.CDFILIAL
                                    AND IV.CDCAIXA    = C_REGC350.CDCAIXA
                                    AND IV.NRSEQVENDA =  C_REGC350.NRLANCTONF
                                    AND NVL(P_GERAFORSALE,'N') = 'S'
                                    AND IV.CDPRODUTO  = P.CDPRODUTO)NF) LOOP

               V_NRSEQITEM := NVL(V_NRSEQITEM,0)+1;
               INSERT INTO ARQMAGNETICO
                 (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                 ('24'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C370|'||LPAD(V_NRSEQITEM,3,'0')||'|'||C_REGC370.ARQ_C370, P_NRSEQARQMAG);
               V_CONTREGC := NVL(V_CONTREGC,0) + 1;

               /* CODIGO DO PRODUTO */
               SELECT MAX(CDCHAVEREG)
                 INTO V_PRODUTO
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC370.CDPRODUTO
                  AND CDREGISTRO = '0200';

               IF (V_PRODUTO IS NULL) AND (C_REGC370.CDPRODUTO IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
                  VALUES
                    ('0200', V_SEQUPROD, C_REGC370.CDPRODUTO, C_REGC370.CDCLASFISC);
               END IF;
               V_PRODUTO := NULL;

               /* UNIDADE DE MEDIDA */
               SELECT MAX(CDCHAVEREG)
                 INTO V_UNID
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC370.UNID
                  AND CDREGISTRO = '0190';

               IF (V_UNID IS NULL) AND (C_REGC370.UNID IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                  VALUES
                    ('0190', V_SEQUPROD, C_REGC370.UNID);
               END IF;
               V_UNID := NULL;
         END LOOP;

         FOR C_REGC390 IN(SELECT ('|C390'         || '|' ||
                                  NF.CDSITUTRIBNF|| '|' ||
                                  NF.CDFISCOPERNF    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRALIQNF,2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF,2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRBASECALCNF + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(NF.VRBASECARGA,0))),2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRIMPOSTONF  + DECODE(V_IDTPCARGATRIB,'O',0,NVL(NF.VRIMPCARGA,0)),2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRREDBCALC,2), '999999999990.00')), '.', ',')    || '|' ||
                                  ''  || '|'  ) AS ARQ_C390, CDFISCOPERNF
                          FROM(SELECT NVL(I.CDSITUTRIBNF,'000') AS CDSITUTRIBNF,
                                      I.CDFISCOPERNF,
                                      I.VRALIQNF+NVL(I.VRADICALIQFECP,0) AS VRALIQNF,
                                      SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                      SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                                      SUM((SELECT SUM(IP.VRBASECALCNF)
                                             FROM IMPOSTONF IP
                                            WHERE IP.CDFILIAL     = I.CDFILIAL
                                              AND IP.NRLANCTONF   = I.NRLANCTONF
                                              AND IP.CDFISCOPERNF = I.CDFISCOPERNF
                                              AND IP.CDIMPOSTO    = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                      SUM(I.VRIMPOSTONF+NVL(I.VRADICFECP,0)) AS VRIMPOSTONF,
                                      SUM(I.VRIMPCARGATRIBI) AS VRIMPCARGA,
                                      SUM(DECODE(I.IDIMPOSTONF, '2', I.VRCONTABILNF, '0')) AS VRREDBCALC
                                 FROM IMPOSTONF I, IMPOSTO IM
                                WHERE I.CDFILIAL      = C_REGC350.CDFILIAL
                                  AND I.NRLANCTONF    = C_REGC350.NRLANCTONF
                                  AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND IDIMPOSTONF <> '3'
                                  AND NVL(P_GERAFORSALE,'N') = 'N'
                                GROUP BY NVL(CDSITUTRIBNF,'000'), CDFISCOPERNF, VRALIQNF) NF
                          UNION
                          /*GERA REGISTRO C390 PARA O FOS - C390 FOS*/
                          SELECT '|C390'      ||'|'||
                                 CDSITUTRIBIT ||'|'||
                                 CDFISCOPERIT ||'|'||
                                 VRALIQITEM   ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_OPER,2), '999999999990.00')), '.', ',')    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_BC_ICMS,2), '999999999990.00')), '.', ',') ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_ICMS,2), '999999999990.00')), '.', ',')    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_RED,2), '999999999990.00')), '.', ',')     ||'|'||
                                 COD_OB       ||'|' AS ARQ_C390, CDFISCOPERIT AS CDFISCOPERNF
                            FROM (SELECT (NVL(LPAD(IVI.CDCSTPRODI,3,'0'), CASE WHEN IP.IDTPIMPOSFIS = 'T' THEN '000'
                                                                               WHEN IP.IDTPIMPOSFIS = 'I' THEN '040'
                                                                               WHEN IP.IDTPIMPOSFIS = 'F' THEN '060'
                                                                               WHEN IP.IDTPIMPOSFIS = 'N' THEN '041' END)) AS CDSITUTRIBIT,
                                         NVL(IVI.CDCSTPRODPC,'5102')  AS CDFISCOPERIT,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(IVI.VRPEALPRODIT,2), '999999999990.00')), '.', ',') AS VRALIQITEM,
                                         (CASE WHEN IP.CDIMPOSTONFE = P_CDIMPOSTO
                                               THEN SUM(TRUNC(IV.QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0))
                                               ELSE 0 END) AS VR_OPER,
                                         (CASE WHEN IP.IDTPIMPOSFIS = 'T' AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                               THEN SUM(TRUNC(IV.QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0))
                                               ELSE 0 END) AS VR_BC_ICMS,
                                         (CASE WHEN IP.IDTPIMPOSFIS = 'T' AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                               THEN SUM(IVI.VRIMPOPRODIT)
                                               ELSE 0 END) AS VR_ICMS,
                                         0 AS VR_RED,'' AS COD_OB, IP.CDIMPOSTONFE
                                    FROM ITEMVENDA IV, ITVENDAIMPOS IVI, IMPOSTO IP
                                   WHERE IV.CDFILIAL     = IVI.CDFILIAL
                                     AND IV.CDCAIXA      = IVI.CDCAIXA
                                     AND IV.NRSEQUITVEND = IVI.NRSEQUITVEND
                                     AND IV.NRSEQVENDA   = IVI.NRSEQVENDA
                                     AND IV.CDFILIAL     = C_REGC350.CDFILIAL
                                     AND IV.CDCAIXA      =  C_REGC350.CDCAIXA
                                     AND IV.NRSEQVENDA   = C_REGC350.NRLANCTONF
                                     AND NVL(P_GERAFORSALE,'N') = 'S'
                                     AND IP.CDIMPOSTO    = IVI.CDIMPOSTO
                                   GROUP BY IVI.CDCSTPRODI, IVI.CDCSTPRODPC, IP.IDTPIMPOSFIS, IVI.VRPEALPRODIT, IP.CDIMPOSTONFE)NF
                           WHERE NF.CDIMPOSTONFE = P_CDIMPOSTO) LOOP
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('24'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC390.ARQ_C390, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         END LOOP;
      END LOOP;
   END IF;

   /* registro c400 */
   FOR C_REGC400 IN (SELECT '|C400'            || '|' ||
                            '2D'               || '|' ||
                            'M'                || '|' ||  --DSMODMARCAECF
                            NRSERIEREDZ1       || '|' ||
                            CDCAIXA            || '|'   AS C400,
                            CDCAIXA, NRSERIEREDZ
                       FROM (SELECT SUBSTR(NRSERIEREDZ,1,21) AS NRSERIEREDZ1,
                                    SUBSTR(REPLACE('','|','-'),1,20) AS DSMODMARCAECF, --DSMODMARCAECF
                                    CDCAIXA, RZ.NRSERIEREDZ
                               FROM REDUCAOZ RZ ,FILIAL FI
                              WHERE RZ.DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL
                                AND RZ.CDFILIAL    = FI.CDFILIAL
                                AND FI.CDEMPRESA   = P_CDEMPRESA
                                AND FI.CDINSCESTA  = P_CDINSCESTA
                                AND NRSERIEREDZ IS NOT NULL
                                AND RZ.IDSTATUS    = 'A'
                                AND ((V_CDSITUCRT IN ('2','3')) OR (V_CDSITUCRT = '1' AND V_SGESTADO <> 'CE'))
                              GROUP BY SUBSTR(NRSERIEREDZ,1,20), SUBSTR(REPLACE('','|','-'),1,20) , --DSMODMARCAECF
                                       CDCAIXA, RZ.NRSERIEREDZ) )LOOP
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC400.C400, P_NRSEQARQMAG);
      V_CONTREGC := NVL(V_CONTREGC,0) + 1;
      FOR C_REGC405 IN (SELECT ('|C405'                                                                           || '|' ||
                                TO_CHAR(RZ.DTREDUCAOZ,'ddmmyyyy')                                                 || '|' ||
                                LPAD(LTRIM(NVL(RZ.NRREINIREDZ,'0'),'0'), 3, '0')                                  || '|' ||
                                LPAD(LTRIM(NVL(RZ.NRREDREDZ,'0'),'0'), 6, '0')                                    || '|' ||
                                CASE WHEN RZ.DTREDUCAOZ < '01/01/2014' THEN LPAD(LTRIM(NVL(RZ.NRULTCFREDZ,'0'),'0'), 6, '0') ELSE LPAD(LTRIM(NVL(RZ.NRULTCFREDZ,'0'),'0'), 9, '0') END || '|' || --atualizacao do layout para 2014
                                REPLACE(LTRIM(TO_CHAR(TRUNC(RZ.VRGTREDZ,2), '999999999990.00')), '.', ',')        || '|' ||
                                REPLACE(LTRIM(TO_CHAR(TRUNC(DECODE(RZ.VRVENLIQREDZ,0,RZ.VRVENBRUREDZ,RZ.VRVENLIQREDZ),2), '999999999990.00')), '.', ',')    || '|' ) AS C405,
                                DTREDUCAOZ, RZ.NRECFREDZ, RZ.CDFILIAL
                          FROM REDUCAOZ RZ, FILIAL FI
                         WHERE RZ.CDFILIAL    = FI.CDFILIAL
                           AND RZ.DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL
                           AND FI.CDEMPRESA   = P_CDEMPRESA
                           AND FI.CDINSCESTA  = P_CDINSCESTA
                           AND RZ.CDCAIXA     = C_REGC400.CDCAIXA
                           AND RZ.NRSERIEREDZ = C_REGC400.NRSERIEREDZ
                           AND RZ.IDSTATUS    = 'A'
                           AND VRVENBRUREDZ   > 0
                         ORDER BY TO_CHAR(RZ.DTREDUCAOZ,'ddmmyyyy')) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC405.C405, P_NRSEQARQMAG);
         V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         FOR C_420 IN (SELECT ('|C420'          || '|' ||
                                 VRALIQIMPRZ    || '|' ||
                                 VRBCALCIMPRZ   || '|' ) AS PARTE1,
                                 VRALIQIMPRZ,
                                 ALIQ_NR_TOT,
                                 DTREDUCAOZ, CDFILIAL
                            FROM (SELECT IDTPIMPOSFIS||LPAD(REPLACE(REPLACE(LTRIM(TO_CHAR(ROUND(VRALIQIMPRZ,2), '99.00')), '.', ','),',',''), 4, '0') AS VRALIQIMPRZ,
                                         REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRBCALCIMPRZ),2), '999999999990.00')), '.', ',') AS VRBCALCIMPRZ,
                                         R.DTREDUCAOZ, VRALIQIMPRZ AS ALIQ_NR_TOT, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ
                                    FROM IMPOSTOREDZ R, IMPOSTO I, FILIAL FI, REDUCAOZ Z
                                   WHERE R.CDCAIXA      = C_REGC400.CDCAIXA
                                     AND R.DTREDUCAOZ   = C_REGC405.DTREDUCAOZ
                                     AND R.CDIMPOSTO    = I.CDIMPOSTO
                                     AND I.IDTPIMPOSFIS = 'T'
                                     AND FI.CDEMPRESA   = P_CDEMPRESA
                                     AND FI.CDINSCESTA  = P_CDINSCESTA
                                     AND FI.CDFILIAL    = R.CDFILIAL
                                     AND R.CDCAIXA      = Z.CDCAIXA
                                     AND R.NRECFREDZ    = Z.NRECFREDZ
                                     AND R.DTREDUCAOZ   = Z.DTREDUCAOZ
                                     AND R.CDFILIAL     = Z.CDFILIAL
                                     AND Z.NRECFREDZ    = C_REGC405.NRECFREDZ
                                     AND Z.NRSERIEREDZ  = C_REGC400.NRSERIEREDZ
                                    GROUP BY R.DTREDUCAOZ, IDTPIMPOSFIS||LPAD(REPLACE(REPLACE(LTRIM(TO_CHAR(ROUND(VRALIQIMPRZ,2), '99.00')), '.', ','),',',''), 4, '0'),
                                             VRALIQIMPRZ, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ
                                   UNION ALL
                                  SELECT 'F1' AS VRALIQIMPRZ,
                                         REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(VRSTRIBREDZ),2), '999999999990.00')), '.', ',') AS VRBCALCIMPRZ, /* VALOR DE SUBSTITUICAO TRIBUTARIA */
                                         RE.DTREDUCAOZ, 0 AS ALIQ_NR_TOT, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ
                                    FROM REDUCAOZ RE, FILIAL FI
                                   WHERE RE.CDCAIXA     = C_REGC400.CDCAIXA
                                     AND RE.DTREDUCAOZ  = C_REGC405.DTREDUCAOZ
                                     AND RE.VRSTRIBREDZ > 0
                                     AND FI.CDEMPRESA   = P_CDEMPRESA
                                     AND FI.CDINSCESTA  = P_CDINSCESTA
                                     AND FI.CDFILIAL    = RE.CDFILIAL
                                     AND RE.NRECFREDZ   = C_REGC405.NRECFREDZ
                                     AND RE.NRSERIEREDZ = C_REGC400.NRSERIEREDZ
                                   GROUP BY RE.DTREDUCAOZ, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ
                                   UNION ALL
                                  SELECT DECODE(VRVENBRUREDZ,VRTOTCANREDZ ,'CAN-O','N1') AS VRALIQIMPRZ,
                                         REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(VRNINCIDREDZ),2), '999999999990.00')), '.', ',') AS VRBCALCIMPRZ, /* VALOR DE NAO TRIBUTADAS */
                                         RE.DTREDUCAOZ, 0 AS ALIQ_NR_TOT, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ
                                    FROM REDUCAOZ RE, FILIAL FI
                                   WHERE RE.CDCAIXA      = C_REGC400.CDCAIXA
                                     AND RE.DTREDUCAOZ   = C_REGC405.DTREDUCAOZ
                                     AND RE.VRNINCIDREDZ > 0
                                     AND FI.CDEMPRESA    = P_CDEMPRESA
                                     AND FI.CDINSCESTA   = P_CDINSCESTA
                                     AND FI.CDFILIAL     = RE.CDFILIAL
                                     AND RE.NRECFREDZ    = C_REGC405.NRECFREDZ
                                     AND RE.NRSERIEREDZ  = C_REGC400.NRSERIEREDZ
                                   GROUP BY RE.DTREDUCAOZ, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ
                                   UNION ALL
                                  SELECT 'I1' AS VRALIQIMPRZ,
                                         REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(VRISENCREDZ),2), '999999999990.00')), '.', ',') AS VRBCALCIMPRZ, /* VALOR DE ISENTO */
                                         RE.DTREDUCAOZ, 0 AS ALIQ_NR_TOT, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ
                                    FROM REDUCAOZ RE, FILIAL FI
                                   WHERE RE.CDCAIXA     = C_REGC400.CDCAIXA
                                     AND RE.DTREDUCAOZ  = C_REGC405.DTREDUCAOZ
                                     AND RE.VRISENCREDZ > 0
                                     AND FI.CDEMPRESA   = P_CDEMPRESA
                                     AND FI.CDINSCESTA  = P_CDINSCESTA
                                     AND FI.CDFILIAL    = RE.CDFILIAL
                                     AND RE.NRECFREDZ   = C_REGC405.NRECFREDZ
                                     AND RE.NRSERIEREDZ = C_REGC400.NRSERIEREDZ
                                   GROUP BY RE.DTREDUCAOZ, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ)) LOOP
               FOR C_NR_TOT IN (SELECT VRALIQIMPRZ, LPAD(TO_CHAR(ROWNUM), 2, '0') AS SEQUENCIAL
                                  FROM (SELECT VRALIQIMPRZ
                                          FROM IMPOSTOREDZ
                                         WHERE DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL
                                         GROUP BY VRALIQIMPRZ) )LOOP
                  IF (C_NR_TOT.VRALIQIMPRZ = C_420.ALIQ_NR_TOT) AND (C_420.ALIQ_NR_TOT > 0) THEN
                     V_NR_TOT := C_NR_TOT.SEQUENCIAL;
                     V_DESCR_NR_TOT := 'ALIQUOTA ' || V_NR_TOT;
                  END IF;
               END LOOP;
               V_LINHA := C_420.PARTE1      ||
                          V_NR_TOT          || '|' ||
                          V_DESCR_NR_TOT    || '|';
                V_NR_TOT       := NULL;
                V_DESCR_NR_TOT := NULL;
               INSERT INTO ARQMAGNETICO
                 (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                 ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), V_LINHA, P_NRSEQARQMAG);
               V_CONTREGC := NVL(V_CONTREGC,0) + 1;
            IF P_PERFIL = 'B' THEN
               FOR C_425 IN (SELECT DISTINCT('|C425'|| '|' ||
                                    CDARVPROD       || '|' ||
                                    QTPRODVEND      || '|' ||
                                    SGUNIDADE       || '|' ||
                                    VRITEM          || '|' ||
                                    VRPIS           || '|' ||
                                    VRCOFINS        || '|'  ) AS C425,
                                    CDPRODUTO,
                                    SGUNIDADE AS UNID, CDCLASFISC
                               FROM (SELECT P.CDARVPROD,
                                            REPLACE(LTRIM(TO_CHAR(SUM(QTPRODVEND), '999999999990.000')), '.', ',')  AS QTPRODVEND,
                                            SGUNIDADE,
                                            REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VRTOTAL),2), '999999999990.00')), '.', ',')  AS VRITEM,
                                            '0,00' AS VRPIS,
                                            '0,00' AS VRCOFINS,
                                            P.CDPRODUTO, I.CDCLASFISC
                                       FROM PRODUTO P,
                                            (SELECT DISTINCT R.DTREDUCAOZ
                                              FROM REDUCAOZ R, IMPOSTOREDZ IR, IMPOSTO I
                                             WHERE R.DTREDUCAOZ  = C_420.DTREDUCAOZ
                                               AND R.CDCAIXA = C_REGC400.CDCAIXA
                                               AND R.CDFILIAL = IR.CDFILIAL
                                               AND R.CDCAIXA = IR.CDCAIXA
                                               AND R.NRECFREDZ = IR.NRECFREDZ
                                               AND R.DTREDUCAOZ = IR.DTREDUCAOZ
                                               AND R.CDFILIAL = C_420.CDFILIAL
                                               AND I.CDIMPOSTO = IR.CDIMPOSTO) R,
                                            (SELECT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, IT.CDPRODUTO, V.DTENTRVENDA,
                                                    NVL(IT.VRUNITVEND,0) AS VRUNITVEND,
                                                    NVL(IT.QTPRODVEND,0) AS QTPRODVEND,
                                                    (TRUNC(QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2) - VRDESITVEND + VRACRITVEND) AS VRTOTAL,
                                                    IT.CDCLASFISC
                                               FROM ITVENDAIMPOS I, IMPOSTO P, ITEMVENDA IT, VENDA V
                                              WHERE I.CDIMPOSTO = P.CDIMPOSTO
                                                AND I.CDFILIAL = IT.CDFILIAL
                                                AND I.CDCAIXA = IT.CDCAIXA
                                                AND I.NRSEQVENDA = IT.NRSEQVENDA
                                                AND I.NRSEQUITVEND = IT.NRSEQUITVEND
                                                AND I.CDFILIAL = V.CDFILIAL
                                                AND I.CDCAIXA = V.CDCAIXA
                                                AND V.CDCAIXA = C_REGC400.CDCAIXA
                                                AND I.NRSEQVENDA = V.NRSEQVENDA
                                                AND DTENTRVENDA = C_420.DTREDUCAOZ
                                                AND IDSITUVENDA = 'O'
                                                AND V.NRCUPOMFIS IS NOT NULL
                                                AND C_420.VRALIQIMPRZ = IDTPIMPOSFIS||LPAD(REPLACE(REPLACE(LTRIM(TO_CHAR(ROUND(VRPEALPRODIT,2), '99.00')), '.', ','),',',''), 4,'0')
                                                AND V.CDFILIAL = C_420.CDFILIAL
                                                AND IDTPIMPOSFIS = 'T'
                                              UNION ALL
                                              SELECT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, IT.CDPRODUTO, V.DTENTRVENDA,
                                                    NVL(IT.VRUNITVEND,0) AS VRUNITVEND,
                                                    NVL(IT.QTPRODVEND,0) AS QTPRODVEND,
                                                    (TRUNC(QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2) - VRDESITVEND + VRACRITVEND) AS VRTOTAL,
                                                    IT.CDCLASFISC
                                               FROM ITVENDAIMPOS I, IMPOSTO P, ITEMVENDA IT, VENDA V
                                              WHERE I.CDIMPOSTO = P.CDIMPOSTO
                                                AND I.CDFILIAL = IT.CDFILIAL
                                                AND I.CDCAIXA = IT.CDCAIXA
                                                AND I.NRSEQVENDA = IT.NRSEQVENDA
                                                AND I.NRSEQUITVEND = IT.NRSEQUITVEND
                                                AND I.CDFILIAL = V.CDFILIAL
                                                AND I.CDCAIXA = V.CDCAIXA
                                                AND V.CDCAIXA = C_REGC400.CDCAIXA
                                                AND I.NRSEQVENDA = V.NRSEQVENDA
                                                AND DTENTRVENDA = C_420.DTREDUCAOZ
                                                AND V.NRCUPOMFIS IS NOT NULL
                                                AND IDSITUVENDA = 'O'
                                                AND C_420.VRALIQIMPRZ = IDTPIMPOSFIS||'1'
                                                AND V.CDFILIAL = C_420.CDFILIAL
                                                AND IDTPIMPOSFIS <> 'T'   ) I
                                      WHERE R.DTREDUCAOZ(+) = I.DTENTRVENDA
                                        AND P.CDPRODUTO     = I.CDPRODUTO
                                     GROUP BY P.CDARVPROD, SGUNIDADE, P.CDPRODUTO, I.CDCLASFISC)) LOOP
                  INSERT INTO ARQMAGNETICO
                    (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                  VALUES
                    ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_425.C425, P_NRSEQARQMAG);
                  V_CONTREGC := NVL(V_CONTREGC,0) + 1;
                  /* UNIDADE DE MEDIDA */
                  SELECT MAX(CDCHAVEREG)
                    INTO V_UNID
                    FROM TMP_REGDADOSSPED
                   WHERE CDCHAVEREG = C_425.UNID
                     AND CDREGISTRO = '0190';
                  IF (V_UNID IS NULL) AND (C_425.UNID IS NOT NULL) THEN
                     V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                     INSERT INTO TMP_REGDADOSSPED
                       (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                     VALUES
                       ('0190', V_SEQUPROD, C_425.UNID);
                  END IF;
                  V_UNID := NULL;
                  /* CODIGO DO PRODUTO */
                  SELECT MAX(CDCHAVEREG)
                    INTO V_PRODUTO
                    FROM TMP_REGDADOSSPED
                   WHERE CDCHAVEREG = C_425.CDPRODUTO
                     AND CDREGISTRO = '0200';
                  IF (V_PRODUTO IS NULL) AND (C_425.CDPRODUTO IS NOT NULL) THEN
                     V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                     INSERT INTO TMP_REGDADOSSPED
                       (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
                     VALUES
                       ('0200', V_SEQUPROD, C_425.CDPRODUTO, C_425.CDCLASFISC);
                  END IF;
                  V_PRODUTO := NULL;
               END LOOP;
            END IF;
         END LOOP;

         FOR C_C460 IN (SELECT (REG      || '|' ||
                               COD_MOD   || '|' ||
                               COD_SIT   || '|' ||
                               NUM_DOC   || '|' ||
                               DT_DOC    || '|' ||
                               VL_DOC    || '|' ||
                               VL_PIS    || '|' ||
                               VL_COFINS || '|' ||
                               CPF_CNPJ  || '|' ||
                               NOM_ADQ   || '|' )AS REG_C460,
                               CDCAIXA, CDFILIAL, DTREDUCAOZ ,NRSERIEREDZ , NRCUPOMFIS
                          FROM (SELECT '|C460' AS REG,
                                       '2D' AS COD_MOD,
                                       '00' AS COD_SIT,
                                       CASE WHEN V.DTENTRVENDA < '01/01/2014' THEN LPAD(LTRIM(NVL(V.NRCUPOMFIS,'0'),'0'), 6, '0') ELSE LPAD(LTRIM(NVL(V.NRCUPOMFIS,'0'),'0'), 9, '0') END AS NUM_DOC, --atualizacao do layout para 2014
                                       TO_CHAR(V.DTENTRVENDA, 'DDMMYYYY') AS DT_DOC,
                                       REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(IV.QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0)),'999999999990.00')),'.',',') AS VL_DOC,
                                       0 AS VL_PIS,
                                       0 AS VL_COFINS,
                                       NVL(REPLACE(REPLACE(REPLACE(REPLACE(V.NRINSCRCONS,'.'),'-'),'/'),' '),'') AS CPF_CNPJ,
                                       '' AS NOM_ADQ, V.NRCUPOMFIS, IV.CDCAIXA, V.CDFILIAL, V.DTENTRVENDA AS DTREDUCAOZ, V.NRSERIEIMPVND AS NRSERIEREDZ
                                  FROM ITEMVENDA IV, ITVENDAIMPOS IVI, VENDA V, IMPOSTO IP
                                 WHERE IV.CDFILIAL = IVI.CDFILIAL
                                   AND IV.CDCAIXA  = IVI.CDCAIXA
                                   AND IV.NRSEQUITVEND = IVI.NRSEQUITVEND
                                   AND IV.NRSEQVENDA  = IVI.NRSEQVENDA
                                   AND IV.CDFILIAL    = V.CDFILIAL
                                   AND IV.CDCAIXA     = V.CDCAIXA
                                   AND IV.NRSEQVENDA  = V.NRSEQVENDA
                                   AND IV.CDFILIAL    = C_REGC405.CDFILIAL
                                   AND IV.CDCAIXA     = C_REGC400.CDCAIXA
                                   AND V.DTENTRVENDA  = C_REGC405.DTREDUCAOZ
                                   AND V.IDSITUVENDA  = 'O'
			                          AND P_PERFIL = 'A'
                                   AND V.NRCUPOMFIS IS NOT NULL
                                   --AND NVL(P_GERAFORSALE,'N') = 'S'
                                   AND IP.CDIMPOSTO = IVI.CDIMPOSTO
                                 GROUP BY V.NRCUPOMFIS, DTENTRVENDA, V.NRSERIEIMPVND, IV.CDCAIXA, V.CDFILIAL, V.NRINSCRCONS))LOOP
               INSERT INTO ARQMAGNETICO
                 (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                 ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_C460.REG_C460, P_NRSEQARQMAG);
               V_CONTREGC := NVL(V_CONTREGC,0) + 1;
            FOR C_470 IN (SELECT REG        || '|' ||
                                 COD_ITEM   || '|' ||
                                 QTD        || '|' ||
                                 QTD_CANC   || '|' ||
                                 UNID       || '|' ||
                                 VL_ITEM    || '|' ||
                                 CST_ICMS   || '|' ||
                                 CFOP       || '|' ||
                                 ALIQ_ICMS  || '|' ||
                                 VL_PIS     || '|' ||
                                 VL_COFINS  || '|' AS REG_C470,
                                 CDPRODUTO, UNID, CDCLASFISC
                            FROM (SELECT '|C470' AS REG,
                                         CDARVPROD AS COD_ITEM,
                                         REPLACE(LTRIM(TO_CHAR(QTPRODVEND, '999999999990.000')), '.', ',') AS QTD,
                                         '0' AS QTD_CANC,
                                         SGUNIDADE AS UNID,
                                         REPLACE(LTRIM(TO_CHAR(TRUNC(VRTOTAL,2), '999999999990.00')), '.', ',') AS VL_ITEM,
                                         NVL(LPAD(CDCSTPRODI,3,'0'),DECODE(IDTPIMPOSFIS,'F','060','I','040','N','041','T',CASE WHEN VRPERCREDUCAO > 0 THEN '020' ELSE '000' END)) AS CST_ICMS,
                                         NVL(CDCFOPPROD,DECODE(IDTPIMPOSFIS,'F','5405','5102')) AS CFOP,
                                         REPLACE(LTRIM(TO_CHAR(TRUNC(VRPEALPRODIT,2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                         '0' AS VL_PIS,
                                         '0' AS VL_COFINS,
                                         P.CDPRODUTO, I.CDCLASFISC AS CDCLASFISC
                                    FROM PRODUTO P,
                                        (SELECT DISTINCT R.DTREDUCAOZ
                                           FROM REDUCAOZ R, IMPOSTOREDZ IR, IMPOSTO I
                                          WHERE R.DTREDUCAOZ  = C_C460.DTREDUCAOZ
                                            AND R.CDCAIXA     = C_C460.CDCAIXA
                                            AND R.CDFILIAL    = IR.CDFILIAL
                                            AND R.CDCAIXA     = IR.CDCAIXA
                                            AND R.NRECFREDZ   = IR.NRECFREDZ
                                            AND R.DTREDUCAOZ  = IR.DTREDUCAOZ
                                            AND R.CDFILIAL    = C_C460.CDFILIAL
                                            AND R.NRSERIEREDZ = C_C460.NRSERIEREDZ
                                            AND R.NRECFREDZ   = C_REGC405.NRECFREDZ
                                            AND P_PERFIL      = 'A'
                                            AND R.NRECFREDZ   = C_REGC405.NRECFREDZ
                                            AND I.CDIMPOSTO   = IR.CDIMPOSTO) R,
                                         (SELECT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, IT.CDPRODUTO, V.DTENTRVENDA,
                                                 NVL(IT.VRUNITVEND,0) AS VRUNITVEND,
                                                 NVL(IT.QTPRODVEND,0) AS QTPRODVEND,
                                                 TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2) - IT.VRDESITVEND + IT.VRACRITVEND AS VRTOTAL,
                                                 I.VRPEALPRODIT, P.IDTPIMPOSFIS, NVL(A.VRPERCREDUCAO,0) AS VRPERCREDUCAO, IT.CDCLASFISC, I.CDCFOPPROD, I.CDCSTPRODI
                                            FROM ITVENDAIMPOS I, IMPOSTO P, ITEMVENDA IT, VENDA V, ALIQIMPFIS A
                                           WHERE I.CDIMPOSTO    = P.CDIMPOSTO
                                             AND I.CDFILIAL     = IT.CDFILIAL
                                             AND I.CDCAIXA      = IT.CDCAIXA
                                             AND I.NRSEQVENDA   = IT.NRSEQVENDA
                                             AND I.NRSEQUITVEND = IT.NRSEQUITVEND
                                             AND I.CDFILIAL     = V.CDFILIAL
                                             AND I.CDCAIXA      = V.CDCAIXA
                                             AND V.CDCAIXA      = C_C460.CDCAIXA
                                             AND V.NRCUPOMFIS   = C_C460.NRCUPOMFIS
                                             AND I.NRSEQVENDA   = V.NRSEQVENDA
                                             AND V.DTENTRVENDA  = C_C460.DTREDUCAOZ
                                             AND V.NRCUPOMFIS   IS NOT NULL
                                             AND V.IDSITUVENDA  = 'O'
                                             AND IT.CDFILIAL    = A.CDFILIAL(+)
                                             AND IT.CDPRODUTO   = A.CDPRODUTO(+)
                                             --AND V.NRORDEMVND IS NULL
                                             AND NVL(NRSERIEIMPVND,NRSERIEVND) = C_C460.NRSERIEREDZ/*REDUO PELA IMPRESSORA*/
                                             --AND C_420.VRALIQIMPRZ = IDTPIMPOSFIS||LPAD(REPLACE(REPLACE(LTRIM(TO_CHAR(ROUND(VRPEALPRODIT,2), '99.00')), '.', ','),',',''), 4, '0')
                                             AND V.CDFILIAL = C_C460.CDFILIAL
                                             AND P_PERFIL = 'A'
                                             /*AND IDTPIMPOSFIS = 'T'*/)I
                                           /*
                                           UNION ALL
                                           SELECT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, IT.CDPRODUTO, V.DTENTRVENDA,
                                                 NVL(IT.VRUNITVEND,0) AS VRUNITVEND,
                                                 NVL(IT.QTPRODVEND,0) AS QTPRODVEND,
                                                 (TRUNC(QTPRODVEND * (VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - VRDESITVEND + VRACRITVEND) AS VRTOTAL,
                                                 VRPEALPRODIT, IT.CDCLASFISC
                                            FROM ITVENDAIMPOS I, IMPOSTO P, ITEMVENDA IT, VENDA V
                                           WHERE I.CDIMPOSTO = P.CDIMPOSTO
                                             AND I.CDFILIAL = IT.CDFILIAL
                                             AND I.CDCAIXA = IT.CDCAIXA
                                             AND I.NRSEQVENDA = IT.NRSEQVENDA
                                             AND I.NRSEQUITVEND = IT.NRSEQUITVEND
                                             AND I.CDFILIAL = V.CDFILIAL
                                             AND I.CDCAIXA = V.CDCAIXA
                                             AND V.CDCAIXA = C_C460.CDCAIXA
                                             AND I.NRSEQVENDA = V.NRSEQVENDA
                                             AND DTENTRVENDA = C_C460.DTREDUCAOZ
                                             AND IDSITUVENDA = 'O'
                                             --AND C_420.VRALIQIMPRZ = IDTPIMPOSFIS||'1'
                                             AND V.CDFILIAL = C_C460.CDFILIAL
                                             AND P_PERFIL = 'A'
                                             AND IDTPIMPOSFIS <> 'T'
                                             */
                                   WHERE R.DTREDUCAOZ(+) = I.DTENTRVENDA
                                     AND P.CDPRODUTO     = I.CDPRODUTO
                                   --GROUP BY CDARVPROD, SGUNIDADE, REPLACE(LTRIM(TO_CHAR(TRUNC(VRPEALPRODIT,2), '999999999990.00')), '.', ','),
                                            --P.CDPRODUTO, IDTPIMPOSFIS, CDCLASFISC
                                   ))LOOP

               INSERT INTO ARQMAGNETICO
                 (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                 ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_470.REG_C470, P_NRSEQARQMAG);
               V_CONTREGC := NVL(V_CONTREGC,0) + 1;

               SELECT MAX(CDCHAVEREG)
                 INTO V_UNID
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_470.UNID
                  AND CDREGISTRO = '0190';

               IF (V_UNID IS NULL) AND (C_470.UNID IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                  VALUES
                    ('0190', V_SEQUPROD, C_470.UNID);
               END IF;

               V_UNID := NULL;
               SELECT MAX(CDCHAVEREG)
                 INTO V_PRODUTO
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_470.CDPRODUTO
                  AND CDREGISTRO = '0200';

               IF (V_PRODUTO IS NULL) AND (C_470.CDPRODUTO IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
                  VALUES
                    ('0200', V_SEQUPROD, C_470.CDPRODUTO, C_470.CDCLASFISC);
               END IF;
               V_PRODUTO := NULL;

            END LOOP;
         END LOOP;
    /*VERIFICA O TOTAL DA VENDA BRUTA E O TOTAL DE CANCELAMENTOS*/
      SELECT VRVENBRUREDZ, VRTOTCANREDZ
        INTO V_VENDABRUTA, V_VENDACANC
        FROM REDUCAOZ
       WHERE DTREDUCAOZ  = C_REGC405.DTREDUCAOZ
         AND CDCAIXA     = C_REGC400.CDCAIXA
         AND NRECFREDZ   = C_REGC405.NRECFREDZ
         AND CDFILIAL    = C_REGC405.CDFILIAL
         AND NRSERIEREDZ = C_REGC400.NRSERIEREDZ;

       IF V_VENDABRUTA <> V_VENDACANC  THEN /*VERIFICA SE TODAS AS VENDAS FORAM CANCELADAS PARA GERAR O REGISTRO C490*/

         FOR C_490 IN (SELECT '|C490'     || '|' ||
                                 CST_ICMS    || '|' ||
                                 CFOP        || '|' ||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(ALIQ_ICMS,2), '999999999990.00')), '.', ',')      || '|' ||
                                 REPLACE(LTRIM(TO_CHAR(TRUNC(VL_OPR,2), '999999999990.00')), '.', ',')|| '|' ||
                                 REPLACE(LTRIM(TO_CHAR(TRUNC(VL_BC_ICMS,2), '999999999990.00')), '.', ',')|| '|' ||
                                 REPLACE(LTRIM(TO_CHAR(TRUNC(VL_ICMS,2), '999999999990.00')), '.', ',')|| '|' ||
                                 COD_OBS     || '|' AS C490
                         FROM (SELECT '000' AS CST_ICMS,
                                      '5102' AS CFOP,
                                      VRALIQIMPRZ AS ALIQ_ICMS,
                                      SUM(VRBCALCIMPRZ) AS VL_OPR,
                                      SUM(VRBCALCIMPRZ) AS VL_BC_ICMS,
                                      SUM(VRIMPOSTORZ) AS VL_ICMS,
                                      '' COD_OBS
                                 FROM IMPOSTOREDZ R, FILIAL FI, REDUCAOZ Z, IMPOSTO IM
                                WHERE R.DTREDUCAOZ    = C_REGC405.DTREDUCAOZ
                                  AND R.CDCAIXA       = C_REGC400.CDCAIXA
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND R.CDIMPOSTO     = IM.CDIMPOSTO
                                  AND FI.CDEMPRESA    = P_CDEMPRESA
                                  AND FI.CDINSCESTA   = P_CDINSCESTA
                                  AND FI.CDFILIAL     = R.CDFILIAL
                                  AND R.CDFILIAL      = Z.CDFILIAL
                                  AND R.CDCAIXA       = Z.CDCAIXA
                                  AND R.NRECFREDZ     = Z.NRECFREDZ
                                  AND R.DTREDUCAOZ    = Z.DTREDUCAOZ
                                  AND Z.NRECFREDZ     = C_REGC405.NRECFREDZ
                                  AND Z.NRSERIEREDZ   = C_REGC400.NRSERIEREDZ
                                  AND Z.NRLANCTONF    IS NULL
                                GROUP BY R.VRALIQIMPRZ
                                UNION ALL
                               SELECT '0'||SUBSTR(NVL(LPAD(IP.CDSITUTRIBNF,3,'0'),DECODE(IP.VRPERREDBCNF,0,'000','020')),2,2) AS CST_ICMS,
                                      NVL(IP.CDFISCOPERNF,'5102') AS CFOP,
                                      R.VRALIQIMPRZ AS ALIQ_ICMS,
                                      SUM(IP.VRCONTABILNF) + NVL(SUM(DECODE(IP.VRPERREDBCNF,0,0,(SELECT SUM(VRCONTABILNF)
                                                                                                   FROM IMPOSTONF II
                                                                                                  WHERE II.CDFILIAL    = IP.CDFILIAL
                                                                                                    AND II.NRLANCTONF  = IP.NRLANCTONF
                                                                                                    AND II.IDIMPOSTONF = '2'))),0) AS VL_OPR,
                                      SUM(IP.VRBASECALCNF) AS VL_BC_ICMS,
                                      SUM(IP.VRIMPOSTONF)  AS VL_ICMS,
                                      '' COD_OBS
                                 FROM IMPOSTOREDZ R, IMPOSTONF IP, FILIAL FI, REDUCAOZ Z, IMPOSTO IM, IMPOSTO I
                                WHERE R.DTREDUCAOZ    = C_REGC405.DTREDUCAOZ
                                  AND R.CDCAIXA       = C_REGC400.CDCAIXA
                                  AND Z.CDFILIALNF    = IP.CDFILIAL
                                  AND Z.NRLANCTONF    = IP.NRLANCTONF
                                  AND R.VRALIQIMPRZ   = IP.VRALIQNF
                                  AND IP.CDIMPOSTO    = I.CDIMPOSTO
                                  AND I.CDIMPOSTONFE  IN ('00','03')
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND R.CDIMPOSTO     = IM.CDIMPOSTO
                                  AND FI.CDEMPRESA    = P_CDEMPRESA
                                  AND FI.CDINSCESTA   = P_CDINSCESTA
                                  AND FI.CDFILIAL     = R.CDFILIAL
                                  AND R.CDFILIAL      = Z.CDFILIAL
                                  AND R.CDCAIXA       = Z.CDCAIXA
                                  AND R.NRECFREDZ     = Z.NRECFREDZ
                                  AND R.DTREDUCAOZ    = Z.DTREDUCAOZ
                                  AND Z.NRECFREDZ     = C_REGC405.NRECFREDZ
                                  AND Z.NRSERIEREDZ   = C_REGC400.NRSERIEREDZ
                                  AND Z.NRLANCTONF    IS NOT NULL
                                GROUP BY R.VRALIQIMPRZ,  '0'||SUBSTR(NVL(LPAD(IP.CDSITUTRIBNF,3,'0'),DECODE(IP.VRPERREDBCNF,0,'000','020')),2,2), IP.CDFISCOPERNF
                                UNION ALL
                               SELECT '060'  AS CST_ICMS,
                                      '5405' AS CFOP,
                                      0      AS ALIQ_ICMS,
                                      SUM(VRSTRIBREDZ) AS VL_OPR, /* VALOR DE SUBSTITUICAO TRIBUTARIA */
                                      0 VL_BC_ICMS,
                                      0 VL_ICMS,
                                      '' COD_OBS
                                 FROM REDUCAOZ RE, FILIAL FI
                                WHERE RE.CDCAIXA     = C_REGC400.CDCAIXA
                                  AND RE.DTREDUCAOZ  = C_REGC405.DTREDUCAOZ
                                  AND VRSTRIBREDZ    > 0
                                  AND FI.CDEMPRESA   = P_CDEMPRESA
                                  AND FI.CDINSCESTA  = P_CDINSCESTA
                                  AND FI.CDFILIAL    = RE.CDFILIAL
                                  AND RE.NRECFREDZ   = C_REGC405.NRECFREDZ
                                  AND RE.NRSERIEREDZ = C_REGC400.NRSERIEREDZ
                                  AND RE.NRLANCTONF  IS NULL
                                GROUP BY '060', '5405'
                                UNION ALL
                               SELECT '040'  AS CST_ICMS,
                                      '5102' AS CFOP,
                                      0      AS ALIQ_ICMS,
                                      SUM(VRISENCREDZ) AS VL_OPR, /* VALOR DE ISENO */
                                      0 VL_BC_ICMS,
                                      0 VL_ICMS,
                                      '' COD_OBS
                                 FROM REDUCAOZ RE, FILIAL FI
                                WHERE RE.CDCAIXA     = C_REGC400.CDCAIXA
                                  AND RE.DTREDUCAOZ  = C_REGC405.DTREDUCAOZ
                                  AND VRISENCREDZ    > 0
                                  AND FI.CDEMPRESA   = P_CDEMPRESA
                                  AND FI.CDINSCESTA  = P_CDINSCESTA
                                  AND FI.CDFILIAL    = RE.CDFILIAL
                                  AND RE.NRECFREDZ   = C_REGC405.NRECFREDZ
                                  AND RE.NRSERIEREDZ = C_REGC400.NRSERIEREDZ
                                  AND RE.NRLANCTONF  IS NULL
                                GROUP BY '040', '5102'
                                UNION ALL
                               SELECT '041'  AS CST_ICMS,
                                      '5102' AS CFOP,
                                      0      AS ALIQ_ICMS,
                                      SUM(VRNINCIDREDZ) AS VL_OPR, /* VALOR DE NO INCIDENCIA */
                                      0 VL_BC_ICMS,
                                      0 VL_ICMS,
                                      '' COD_OBS
                                 FROM REDUCAOZ RE, FILIAL FI
                                WHERE RE.CDCAIXA     = C_REGC400.CDCAIXA
                                  AND RE.DTREDUCAOZ  = C_REGC405.DTREDUCAOZ
                                  AND VRNINCIDREDZ   > 0
                                  AND FI.CDEMPRESA   = P_CDEMPRESA
                                  AND FI.CDINSCESTA  = P_CDINSCESTA
                                  AND FI.CDFILIAL    = RE.CDFILIAL
                                  AND RE.NRECFREDZ   = C_REGC405.NRECFREDZ
                                  AND RE.NRSERIEREDZ = C_REGC400.NRSERIEREDZ
                                  AND RE.NRLANCTONF  IS NULL
                                GROUP BY '041', '5102'
								        UNION ALL
								       SELECT '0'||SUBSTR(NVL(LPAD(IP.CDSITUTRIBNF,3,'0'),DECODE(IP.VRPERREDBCNF,0,'000','020')),2,2) AS CST_ICMS,
                                      NVL(IP.CDFISCOPERNF,'5102') AS CFOP,
                                      0 AS ALIQ_ICMS,
                                      SUM(IP.VRCONTABILNF) AS VL_OPR,
                                      0 AS VL_BC_ICMS,
                                      0 AS VL_ICMS,
                                      '' COD_OBS
                                 FROM IMPOSTONF IP, FILIAL FI, REDUCAOZ Z, IMPOSTO IM
                                WHERE Z.DTREDUCAOZ    = C_REGC405.DTREDUCAOZ
                                  AND Z.CDCAIXA       = C_REGC400.CDCAIXA
                                  AND Z.CDFILIALNF    = IP.CDFILIAL
                                  AND Z.NRLANCTONF    = IP.NRLANCTONF
                                  AND IP.CDIMPOSTO    = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND FI.CDEMPRESA    = P_CDEMPRESA
                                  AND FI.CDINSCESTA   = P_CDINSCESTA
                                  AND FI.CDFILIAL     = Z.CDFILIAL
                                  AND Z.NRECFREDZ     = C_REGC405.NRECFREDZ
                                  AND Z.NRSERIEREDZ   = C_REGC400.NRSERIEREDZ
                                  AND IP.CDFISCALNF   <> '1'
                                  AND IP.IDIMPOSTONF  <> '2'
                                  AND Z.NRLANCTONF    IS NOT NULL
                                  AND NVL(IP.VRIMPCARGATRIBI,0) = 0
                                GROUP BY '0'||SUBSTR(NVL(LPAD(IP.CDSITUTRIBNF,3,'0'),DECODE(IP.VRPERREDBCNF,0,'000','020')),2,2), IP.CDFISCOPERNF)) LOOP
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_490.C490, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         END LOOP;
       END IF;
      END LOOP;
   END LOOP;
   V_DADOS_2 := '';
   V_COD_PAR := '';

   IF V_CDSITUCRT IN ('2','3') THEN
      FOR C_500 IN (SELECT REG                 || '|' ||
                            IND_OPER            || '|' ||
                            IND_EMIT            || '|' ||
                            REPLACE(REPLACE(REPLACE(REPLACE(COD_PAR,'.'),'-'),'/'),' ') || '|' ||
                            COD_MOD             || '|' AS PART_1,
                            SER                 || '|' ||
                            SUB                 || '|' ||
                            COD_CONS            || '|' ||
                            NUM_DOC             || '|' ||
                            DT_DOC              || '|' ||
                            DT_E_S              || '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_DOC,2), '999999999990.00')), '.', ',')    || '|' ||
                            VL_DESC             || '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_FORN,2), '999999999990.00')), '.', ',')   || '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_SERV_NT,2), '999999999990.00')), '.', ',')|| '|' ||
                            VL_TERC             || '|' ||
                            VL_DA               || '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_BC_ICMS + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VRBASECARGA,0))),2), '999999999990.00')), '.', ',')|| '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_ICMS    + DECODE(V_IDTPCARGATRIB,'O',0,NVL(DECODE(IDENTRSAIDOP,'S',VRIMPCARGA,DECODE(V_SGESTADO,'SP',0,VRIMPCARGA)),0)),2), '999999999990.00')), '.', ',')   || '|' ||
                            VL_BC_ICMS_ST       || '|' ||
                            VL_ICMS_ST          || '|' ||
                            COD_INF             || '|' ||
                            VL_PIS              || '|' ||
                            VL_COFINS           || '|' ||
                            TP_LIGACAO          || '|' ||
                            COD_GRUPO_TENSAO    || '|' AS PART_2,
                            IDSTATUS,IDREGESPECIAL, DTEMISSAO, CDFILIAL, NRLANCTONF, COD_PAR,
                            IDENTRSAIDOP, IDORIGDESTNF, CDTIPOOPER, FILIAL
                       FROM (SELECT '|C500' AS REG,
                                    DECODE(N.IDENTRSAIDOP, 'E', '0','1')  AS IND_OPER,
                                    '1' AS IND_EMIT,
                                    N.IDORIGDESTNF||N.CDFORNECED AS COD_PAR,
                                    N.CDMODDOCFISC AS COD_MOD,
									NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS SER,
                                    '' AS SUB,
                                    '01' AS COD_CONS,
                                    LTRIM(N.NRNOTAFISC, '0') AS NUM_DOC,
                                    TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy') AS DT_E_S,
                                    SUM(I.VRCONTABILNF) AS VL_DOC,
                                    '0,00' AS VL_DESC,
                                    SUM(I.VRCONTABILNF) AS VL_FORN,
                                    SUM(DECODE(CDFISCALNF, '2', VRCONTABILNF, 0)) AS VL_SERV_NT,
                                    '0,00' AS VL_TERC,
                                    '0,00' AS VL_DA,
                                    SUM(DECODE(CDFISCALNF, '1', VRBASECALCNF, 0)) AS VL_BC_ICMS,
                                    SUM((SELECT SUM(VRBASECALCNF)
                                           FROM IMPOSTONF IP
                                          WHERE IP.CDFILIAL   = I.CDFILIAL
                                            AND IP.NRLANCTONF = I.NRLANCTONF
                                            AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALNF, '1', VRIMPOSTONF+NVL(VRADICFECP,0),0)) AS VL_ICMS,
                                    SUM(VRIMPCARGATRIBI) AS VRIMPCARGA,
                                    '0,00' AS VL_BC_ICMS_ST,
                                    '0,00' AS VL_ICMS_ST,
                                    '' AS COD_INF,
                                    '0,00' AS VL_PIS,
                                    '0,00' AS VL_COFINS,
                                    '1' AS TP_LIGACAO,
                                    '01' AS COD_GRUPO_TENSAO,
                                    N.IDSTATUS,T.IDREGESPECIAL, N.DTENTRSAID AS DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE AS FILIAL
                               FROM NOTAFISCAL N, IMPOSTONF I, FORNECEDOR F, IMPOSTO IM, SERIEENTR SE, TIPOOPERAC T 
                              WHERE I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU
                                AND IM.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND I.CDIMPOSTO       = IM.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND N.IDENTRSAIDOP    = 'E' 
                                AND NVL(I.IDIMPOSTONF, '1') <> '3' 
                                AND N.CDFILIAL        = I.CDFILIAL 
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) 
                                AND N.CDMODDOCFISC IN ('06', '29','28') 
                                AND N.CDFORNECED   = F.CDFORNECED 
                                AND N.IDORIGDESTNF = 'F' 
								AND T.IDENTRSAIDOP    = N.IDENTRSAIDOP
								AND T.CDTIPOOPER      = N.CDTIPOOPER
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.IDORIGDESTNF||N.CDFORNECED, N.CDMODDOCFISC,
                                    NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), LTRIM(N.NRNOTAFISC, '0'), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy'), N.IDSTATUS,T.IDREGESPECIAL, N.DTENTRSAID, N.CDFILIAL, N.NRLANCTONF,
                                    N.IDENTRSAIDOP, N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE
                             UNION ALL 
                             SELECT '|C500' AS REG, 
                                    DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS IND_OPER, 
                                    '1' AS IND_EMIT,
                                    N.IDORIGDESTNF||N.CDCLIENTE AS COD_PAR,
                                    N.CDMODDOCFISC AS COD_MOD, 
									NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS SER, 
                                    '' AS SUB, 
                                    '01' AS COD_CONS, 
                                    LTRIM(N.NRNOTAFISC, '0') AS NUM_DOC,
                                    TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy') AS DT_E_S,
                                    SUM(I.VRCONTABILNF) AS VL_DOC, 
                                    '0,00' AS VL_DESC, 
                                    SUM(I.VRCONTABILNF) AS VL_FORN, 
                                    SUM(DECODE(CDFISCALNF, '2', VRCONTABILNF, 0)) AS VL_SERV_NT,
                                    '0,00' AS VL_TERC, 
                                    '0,00' AS VL_DA, 
                                    SUM(DECODE(CDFISCALNF, '1', VRBASECALCNF, 0)) AS VL_BC_ICMS, 
                                    SUM((SELECT SUM(VRBASECALCNF) 
                                           FROM IMPOSTONF IP 
                                          WHERE IP.CDFILIAL   = I.CDFILIAL
                                            AND IP.NRLANCTONF = I.NRLANCTONF 
                                            AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALNF,'1',VRIMPOSTONF+NVL(VRADICFECP,0), 0)) AS VL_ICMS,
                                    SUM(VRIMPCARGATRIBI) AS VRIMPCARGA, 
                                    '0,00' AS VL_BC_ICMS_ST, 
                                    '0,00' AS VL_ICMS_ST,
                                    '' AS COD_INF, 
                                    '0,00' AS VL_PIS, 
                                    '0,00' AS VL_COFINS, 
                                    '1' AS TP_LIGACAO, 
                                    '01' AS COD_GRUPO_TENSAO, 
                                    N.IDSTATUS,T.IDREGESPECIAL, N.DTENTRSAID AS DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE AS FILIAL
                               FROM NOTAFISCAL N, IMPOSTONF I, CLIENTE C, IMPOSTO IM, SERIEENTR SE, TIPOOPERAC T 
                              WHERE I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU 
                                AND IM.CDIMPOSTONFE   = P_CDIMPOSTO 
                                AND I.CDIMPOSTO       = IM.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS') 
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND N.IDENTRSAIDOP    = 'E' 
                                AND NVL(I.IDIMPOSTONF, '1') <> '3' 
                                AND N.CDFILIAL        = I.CDFILIAL 
                                AND N.NRLANCTONF      = I.NRLANCTONF 
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) 
                                AND N.CDMODDOCFISC IN ('06', '29','28')
                                AND N.CDCLIENTE = C.CDCLIENTE
                                AND N.IDORIGDESTNF = 'C' 
								AND T.IDENTRSAIDOP    = N.IDENTRSAIDOP
								AND T.CDTIPOOPER      = N.CDTIPOOPER
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.IDORIGDESTNF||N.CDCLIENTE, N.CDMODDOCFISC,
                                    NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), LTRIM(N.NRNOTAFISC, '0'), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy'), N.IDSTATUS,T.IDREGESPECIAL, N.DTENTRSAID, N.CDFILIAL, N.NRLANCTONF,
                                    N.IDENTRSAIDOP, N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE
                             UNION ALL 
                             SELECT '|C500' AS REG, 
                                    DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS IND_OPER, 
                                    '1' AS IND_EMIT, 
                                    N.IDORIGDESTNF||N.CDFILIEMIT AS COD_PAR,
                                    N.CDMODDOCFISC AS COD_MOD,
									NVL(SE.CDSERIE,N.CDSERIE) AS SER,
                                    '' AS SUB, 
                                    '01' AS COD_CONS, 
                                    LTRIM(N.NRNOTAFISC, '0') AS NUM_DOC, 
                                    TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy') AS DT_E_S,
                                    SUM(I.VRCONTABILNF) AS VL_DOC, 
                                    '0,00' AS VL_DESC, 
                                    SUM(I.VRCONTABILNF) AS VL_FORN, 
                                    SUM(DECODE(CDFISCALNF, '2', VRCONTABILNF, 0)) AS VL_SERV_NT, 
                                    '0,00' AS VL_TERC, 
                                    '0,00' AS VL_DA,
                                    SUM(DECODE(CDFISCALNF, '1', VRBASECALCNF, 0)) AS VL_BC_ICMS, 
                                    SUM((SELECT SUM(VRBASECALCNF) 
                                           FROM IMPOSTONF IP 
                                          WHERE IP.CDFILIAL   = I.CDFILIAL 
                                            AND IP.NRLANCTONF = I.NRLANCTONF 
                                            AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALNF, '1', VRIMPOSTONF+NVL(VRADICFECP,0), 0)) AS VL_ICMS, 
                                    SUM(VRIMPCARGATRIBI) AS VRIMPCARGA, 
                                    '0,00' AS VL_BC_ICMS_ST, 
                                    '0,00' AS VL_ICMS_ST, 
                                    '' AS COD_INF, 
                                    '0,00' AS VL_PIS,
                                    '0,00' AS VL_COFINS, 
                                    '1' AS TP_LIGACAO, 
                                    '01' AS COD_GRUPO_TENSAO, 
                                    N.IDSTATUS,T.IDREGESPECIAL, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIEMIT AS FILIAL
                               FROM NOTAFISCAL N, IMPOSTONF I, FILIAL F, IMPOSTO IM, SERIENF SE, TIPOOPERAC T
                              WHERE I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU 
                                AND IM.CDIMPOSTO      = P_CDIMPOSTO
                                AND IM.CDIMPOSTO      = IM.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SE.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SE.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SE.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP    = 'S'
                                AND NVL(I.IDIMPOSTONF, '1') <> '3' 
                                AND N.CDFILIAL        = I.CDFILIAL 
                                AND N.NRLANCTONF      = I.NRLANCTONF 
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('06', '29','28') 
                                AND N.CDFILIEMIT = F.CDFILIAL 
                                AND IDORIGDESTNF = 'L' 
								AND T.IDENTRSAIDOP    = N.IDENTRSAIDOP
								AND T.CDTIPOOPER      = N.CDTIPOOPER
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.IDORIGDESTNF||N.CDFILIEMIT, N.CDMODDOCFISC,
                                    NVL(SE.CDSERIE,N.CDSERIE), LTRIM(N.NRNOTAFISC, '0'), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy'), N.IDSTATUS,T.IDREGESPECIAL, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF,
                                    N.IDENTRSAIDOP, N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIEMIT)) LOOP
          /* CODIDO DO PARTICIPANTE */
          SELECT MAX(CDCHAVEREG)
            INTO V_COD_PAR
            FROM TMP_REGDADOSSPED
           WHERE CDCHAVEREG = C_500.COD_PAR
             AND CDREGISTRO = '0150';
 
          IF (V_COD_PAR IS NULL) AND (C_500.COD_PAR IS NOT NULL) THEN
             V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
             INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
             VALUES 
               ('0150', V_SEQUPROD, C_500.COD_PAR);
          END IF;

          V_COD_PAR := '';
          IF C_500.IDSTATUS = 'C' THEN
             /* documentos cancelados */
             V_DADOS_2 := '02|';
			   ELSIF C_500.IDREGESPECIAL = 'S' THEN
			       V_DADOS_2 := '08|';
			   ELSE
             IF NOT C_500.DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL THEN 
                /* documentos fora do periodo */
                V_DADOS_2 := '01|';
             ELSE
                V_DADOS_2 := '00|';
             END IF;
          END IF; 
          INSERT INTO ARQMAGNETICO 
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
          VALUES 
            ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_500.PART_1||V_DADOS_2||C_500.PART_2, P_NRSEQARQMAG); 
          V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
          V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0'); 
          FOR C_510 IN (SELECT COD_ITEM         || '|' || 
                               COD_CLASS        || '|' || 
                               QTD              || '|' || 
                               UNID             || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(VL_ITEM,2), '999999999990.00')), '.', ',')    || '|' || 
                               VL_DESC          || '|' || 
                               CST_ICMS         || '|' || 
                               CFOP             || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(VL_BC_ICMS + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VRBASECARGA,0))),2), '999999999990.00')), '.', ',') || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(ALIQ_ICMS,2), '999999999990.00')), '.', ',')  || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(VL_ICMS    + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(C_500.IDENTRSAIDOP,'E',DECODE(V_SGESTADO,'SP',0,NVL(VRIMPCARGA,0)),NVL(VRIMPCARGA,0))),2), '999999999990.00')), '.', ',')    || '|' ||
                               VL_BC_ICMS_ST    || '|' ||
                               ALIQ_ST          || '|' ||
                               VL_ICMS_ST       || '|' ||
                               IND_REC          || '|' ||
                               COD_PART         || '|' ||
                               VL_PIS           || '|' ||
                               VL_COFINS        || '|' ||
                               COD_CTA          || '|' AS REGC510,
                               CDPRODUTO, UNID, CDCLASFISC, COD_CTA
                         FROM (SELECT CDARVPROD AS COD_ITEM,
                                      '0601' AS COD_CLASS,
                                      QTITEMPROD AS QTD,
                                      SGUNIDADE AS UNID,
                                      VRUNITITEM AS VL_ITEM,
                                      '0,00' AS VL_DESC,
                                      CDSITUTRIBIT AS CST_ICMS,
                                      CDFISCOPERIT AS CFOP,
                                      DECODE(CDFISCALIT, '1', VRBASECALCIT, 0) AS VL_BC_ICMS,
                                      (SELECT SUM(IT.VRBASECALCIT)
                                         FROM ITEMPROIMPOS IP
                                        WHERE IP.CDFILIAL   = IT.CDFILIAL
                                          AND IP.NRLANCTONF = IT.NRLANCTONF
                                          AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB) AS VRBASECARGA,
                                      DECODE(CDFISCALIT, '1', VRALIQITEM+NVL(VRADICALIQFECP,0), 0) AS ALIQ_ICMS,
                                      DECODE(CDFISCALIT, '1', VRIMPOSTOIT+NVL(VRADICFECP,0), 0) AS VL_ICMS,
                                      (SELECT SUM(IT.VRIMPOSTOIT+NVL(VRADICFECP,0))
                                         FROM ITEMPROIMPOS IP
                                        WHERE IP.CDFILIAL   = IT.CDFILIAL
                                          AND IP.NRLANCTONF = IT.NRLANCTONF
                                          AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB) AS VRIMPCARGA,
                                      '0,00' AS VL_BC_ICMS_ST,
                                      '0,00' AS ALIQ_ST,
                                      '0,00' AS VL_ICMS_ST,
                                      '1' AS IND_REC,
                                      '' AS COD_PART,
                                      '0,00' AS VL_PIS,
                                      '0,00' AS VL_COFINS,
                                      CONTCTBL_SPED(C_500.IDENTRSAIDOP, I.CDPRODUTO, C_500.CDTIPOOPER, C_500.FILIAL) AS COD_CTA,
                                      P.CDPRODUTO,
                                      I.CDPRODNCMTRANS AS CDCLASFISC
                                 FROM ITEMPRODUTO I, ITEMPROIMPOS IT, PRODUTO P, IMPOSTO IM
                                WHERE I.CDFILIAL = C_500.CDFILIAL 
                                  AND I.NRLANCTONF = C_500.NRLANCTONF 
                                  AND I.CDFILIAL = IT.CDFILIAL 
                                  AND I.NRLANCTONF = IT.NRLANCTONF 
                                  AND I.NRSEQITPROD = IT.NRSEQITPROD 
                                  AND SUBSTR(IT.CDFISCOPERIT,1,1) IN ('5','6','7') 
                                  AND P.CDPRODUTO = I.CDPRODUTO 
                                  AND IM.CDIMPOSTO = IT.CDIMPOSTO) ) LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C510|'||V_SEQUENCIAL||'|'||C_510.REGC510, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER(RTRIM(V_SEQUENCIAL))+1)), 3,'0');

            /* CODIGO DO PRODUTO */
            SELECT MAX(CDCHAVEREG)
              INTO V_PRODUTO
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_510.CDPRODUTO
               AND CDREGISTRO = '0200';
            IF V_PRODUTO IS NULL AND (C_510.CDPRODUTO IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
               VALUES
                  ('0200', V_SEQUPROD, C_510.CDPRODUTO, C_510.CDCLASFISC);
            END IF;
            V_PRODUTO := '';

            /* UNIDADE DE MEDIDA */
            SELECT MAX(CDCHAVEREG)
              INTO V_UNID
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_510.UNID
               AND CDREGISTRO = '0190';
            IF (V_UNID IS NULL) AND (C_510.UNID IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                  ('0190', V_SEQUPROD, C_510.UNID);
            END IF;
            V_UNID := '';

            /* PLANO DE CONTAS REFERENCIAL */
            SELECT MAX(CDCHAVEREG)
              INTO V_CONTCTBL
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_510.COD_CTA
               AND CDREGISTRO = '0500';

            IF (V_CONTCTBL IS NULL) AND (C_510.COD_CTA IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                  ('0500', V_SEQUPROD, C_510.COD_CTA);
            END IF;
            V_CONTCTBL := '';
          END LOOP;

          FOR C_590 IN(SELECT ('|C590'      || '|' || 
                               T.CST_ICMS   || '|' || 
                               T.CFOP       || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(T.ALIQ_ICMS,2), '999999999990.00')), '.', ',')      || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_OPR,2), '999999999990.00')), '.', ',')      || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_BC_ICMS + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VRBASECARGA,0))),2), '999999999990.00')), '.', ',')      || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_ICMS    + DECODE(V_IDTPCARGATRIB,'O',0,NVL(DECODE(C_500.IDENTRSAIDOP,'E',DECODE(V_SGESTADO,'SP',0,VRIMPCARGA),VRIMPCARGA),0)),2), '999999999990.00')), '.', ',')      || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(0,2), '999999999990.00')), '.', ',')      || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(0,2), '999999999990.00')), '.', ',')      || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_RED_BC,2), '999999999990.00')), '.', ',')      || '|' || 
                               '' || '|') ARQ_C590 
                       FROM (SELECT CDSITUTRIBIT AS CST_ICMS, 
                                    CDFISCOPERIT AS CFOP, 
                                    DECODE(CDFISCALIT, '1', VRALIQITEM+NVL(VRADICALIQFECP,0), 0) AS ALIQ_ICMS,
                                    SUM(VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                    SUM(DECODE(CDFISCALIT, '1', VRBASECALCIT, 0)) AS VL_BC_ICMS, 
                                    SUM((SELECT SUM(IP.VRBASECALCIT) 
                                           FROM ITEMPROIMPOS IP
                                          WHERE IP.CDFILIAL     = I.CDFILIAL
                                            AND IP.NRLANCTONF   = I.NRLANCTONF
                                            AND IP.CDSITUTRIBIT = I.CDSITUTRIBIT 
                                            AND IP.CDFISCOPERIT = I.CDFISCOPERIT 
                                            AND IP.CDIMPOSTO    = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALIT, '1', VRIMPOSTOIT+NVL(VRADICFECP,0), 0)) AS VL_ICMS,
                                    SUM((SELECT SUM(IP.VRIMPOSTOIT+NVL(VRADICFECP,0))
                                           FROM ITEMPROIMPOS IP 
                                          WHERE IP.CDFILIAL     = I.CDFILIAL
                                            AND IP.NRLANCTONF   = I.NRLANCTONF
                                            AND IP.CDSITUTRIBIT = I.CDSITUTRIBIT 
                                            AND IP.CDFISCOPERIT = I.CDFISCOPERIT 
                                            AND IP.CDIMPOSTO    = IM.CDIMPCARGATRIB)) AS VRIMPCARGA, 
                                    0 AS VL_BC_ICMS_ST, 
                                    0 AS VL_ICMS_ST, 
                                    NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL) ),0) AS VL_RED_BC, 
                                    0 AS VL_IPI, 
                                    '' AS COD_OBS 
                               FROM ITEMPROIMPOS I, IMPOSTO IM
                              WHERE I.CDFILIAL      = C_500.CDFILIAL 
                                AND I.NRLANCTONF    = C_500.NRLANCTONF 
                                AND I.NRITPROIMPOS    = '1' 
                                AND IM.CDIMPOSTO    = I.CDIMPOSTO 
                                AND IM.CDIMPOSTONFE = P_CDIMPOSTO 
                              GROUP BY CDSITUTRIBIT, I.CDFISCOPERIT, DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(VRADICALIQFECP,0), 0) ) T ) LOOP
             INSERT INTO ARQMAGNETICO 
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
             VALUES 
               ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_590.ARQ_C590, P_NRSEQARQMAG); 
             V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
          END LOOP; 
       END LOOP; 
   END IF; 
    
 
   IF V_CDSITUCRT = '1' THEN   /*SIMPLES NACIONAL*/
       FOR C_500 IN (SELECT REG                 || '|' ||
                            IND_OPER            || '|' ||
                            IND_EMIT            || '|' ||
                            REPLACE(REPLACE(REPLACE(REPLACE(COD_PAR,'.'),'-'),'/'),' ') || '|' ||
                            COD_MOD             || '|' AS PART_1,
							SER                 || '|' ||
                            SUB                 || '|' ||
                            COD_CONS            || '|' ||
                            NUM_DOC             || '|' ||
                            DT_DOC              || '|' ||
                            DT_E_S              || '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_DOC,2), '999999999990.00')), '.', ',')    || '|' ||
                            VL_DESC             || '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_FORN,2), '999999999990.00')), '.', ',')   || '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_SERV_NT,2), '999999999990.00')), '.', ',')|| '|' ||
                            VL_TERC             || '|' ||
                            VL_DA               || '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_BC_ICMS + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VRBASECARGA,0))),2), '999999999990.00')), '.', ',')|| '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_ICMS    + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(IDENTRSAIDOP,'S',NVL(VRIMPCARGA,0),DECODE(V_SGESTADO,'SP',0,NVL(VRIMPCARGA,0)))),2), '999999999990.00')), '.', ',')   || '|' ||
                            VL_BC_ICMS_ST       || '|' ||
                            VL_ICMS_ST          || '|' ||
                            COD_INF             || '|' ||
                            VL_PIS              || '|' ||
                            VL_COFINS           || '|' ||
                            TP_LIGACAO          || '|' ||
                            COD_GRUPO_TENSAO    || '|' AS PART_2,
                            IDSTATUS,IDREGESPECIAL, DTEMISSAO, CDFILIAL, NRLANCTONF, COD_PAR, IDENTRSAIDOP,
                            IDORIGDESTNF, CDTIPOOPER, FILIAL
                       FROM (SELECT '|C500' AS REG,
                                    DECODE(N.IDENTRSAIDOP, 'E', '0','1')  AS IND_OPER,
                                    '1' AS IND_EMIT,
                                    N.IDORIGDESTNF||N.CDFORNECED AS COD_PAR,
                                    N.CDMODDOCFISC AS COD_MOD,
									NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS SER,
                                    '' AS SUB,
                                    '01' AS COD_CONS,
                                    LTRIM(N.NRNOTAFISC, '0') AS NUM_DOC,
                                    TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy') AS DT_E_S,
                                    SUM(I.VRCONTABILNF) AS VL_DOC,
                                    '0,00' AS VL_DESC,
                                    SUM(I.VRCONTABILNF) AS VL_FORN,
                                    SUM(DECODE(CDFISCALNF, '2', VRCONTABILNF, 0)) AS VL_SERV_NT,
                                    '0,00' AS VL_TERC,
                                    '0,00' AS VL_DA,
                                    SUM(DECODE(CDFISCALNF, '1', VRBASECALCNF, 0)) AS VL_BC_ICMS,
                                    SUM((SELECT SUM(VRBASECALCNF)
                                           FROM IMPOSTONF IP
                                          WHERE IP.CDFILIAL   = I.CDFILIAL
                                            AND IP.NRLANCTONF = I.NRLANCTONF
                                            AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALNF, '1', VRIMPOSTONF, 0)) AS VL_ICMS,
                                    SUM(VRIMPCARGATRIBI) AS VRIMPCARGA,
                                    '0,00' AS VL_BC_ICMS_ST,
                                    '0,00' AS VL_ICMS_ST,
                                    '' AS COD_INF,
                                    '0,00' AS VL_PIS,
                                    '0,00' AS VL_COFINS,
                                    '1' AS TP_LIGACAO,
                                    '01' AS COD_GRUPO_TENSAO,
                                    N.IDSTATUS,T.IDREGESPECIAL, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE AS FILIAL
                               FROM NOTAFISCAL N, IMPOSTONF I, FORNECEDOR F, IMPOSTO IM, SERIEENTR SE, TIPOOPERAC T
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                AND N.CDINSCESTA      = P_CDINSCESTA
                                AND IM.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND I.CDIMPOSTO       = IM.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDSERIEENTR(+)    = N.CDSERIEENTR
                                AND N.IDENTRSAIDOP    = 'E'
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('06', '29','28')
                                AND N.CDFORNECED   = F.CDFORNECED
                                AND N.IDORIGDESTNF = 'F'
								AND T.IDENTRSAIDOP    = N.IDENTRSAIDOP
								AND T.CDTIPOOPER      = N.CDTIPOOPER
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.IDORIGDESTNF||N.CDFORNECED, N.CDMODDOCFISC,
                                    NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), LTRIM(N.NRNOTAFISC, '0'), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy'), N.IDSTATUS,T.IDREGESPECIAL, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF,
                                    N.IDENTRSAIDOP, N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE
                              UNION ALL
                              SELECT '|C500' AS REG,
                                    DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS IND_OPER,
                                    '1' AS IND_EMIT,
                                    N.IDORIGDESTNF||N.CDCLIENTE AS COD_PAR,
                                    N.CDMODDOCFISC AS COD_MOD,
                                    NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS SER,
                                    '' AS SUB,
                                    '01' AS COD_CONS,
                                    LTRIM(N.NRNOTAFISC, '0') AS NUM_DOC,
                                    TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy') AS DT_E_S,
                                    SUM(I.VRCONTABILNF) AS VL_DOC,
                                    '0,00' AS VL_DESC,
                                    SUM(I.VRCONTABILNF) AS VL_FORN,
                                    SUM(DECODE(CDFISCALNF, '2', VRCONTABILNF, 0)) AS VL_SERV_NT,
                                    '0,00' AS VL_TERC,
                                    '0,00' AS VL_DA,
                                    SUM(DECODE(CDFISCALNF, '1', VRBASECALCNF, 0)) AS VL_BC_ICMS,
                                    SUM((SELECT SUM(VRBASECALCNF)
                                           FROM IMPOSTONF IP
                                          WHERE IP.CDFILIAL   = I.CDFILIAL
                                            AND IP.NRLANCTONF = I.NRLANCTONF
                                            AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALNF, '1', VRIMPOSTONF, 0)) AS VL_ICMS,
                                    SUM(VRIMPCARGATRIBI) AS VRIMPCARGA,
                                    '0,00' AS VL_BC_ICMS_ST,
                                    '0,00' AS VL_ICMS_ST,
                                    '' AS COD_INF,
                                    '0,00' AS VL_PIS,
                                    '0,00' AS VL_COFINS,
                                    '1' AS TP_LIGACAO,
                                    '01' AS COD_GRUPO_TENSAO,
                                    N.IDSTATUS,T.IDREGESPECIAL, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE AS FILIAL
                               FROM NOTAFISCAL N, IMPOSTONF I, CLIENTE C, IMPOSTO IM, SERIEENTR SE, TIPOOPERAC T
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                AND N.CDINSCESTA      = P_CDINSCESTA
                                AND IM.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND I.CDIMPOSTO       = IM.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDSERIEENTR(+)    = N.CDSERIEENTR
                                AND N.IDENTRSAIDOP    = 'E'
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('06', '29','28')
                                AND N.CDCLIENTE = C.CDCLIENTE
                                AND N.IDORIGDESTNF = 'C'
								AND T.IDENTRSAIDOP    = N.IDENTRSAIDOP
								AND T.CDTIPOOPER      = N.CDTIPOOPER
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.IDORIGDESTNF||N.CDCLIENTE, N.CDMODDOCFISC,
                                    NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), LTRIM(N.NRNOTAFISC, '0'), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy'), N.IDSTATUS,T.IDREGESPECIAL, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF,
                                    N.IDENTRSAIDOP, N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE
                              UNION ALL
                             SELECT '|C500' AS REG,
                                    DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS IND_OPER,
                                    '1' AS IND_EMIT,
                                    N.IDORIGDESTNF||N.CDFILIEMIT AS COD_PAR,
                                    N.CDMODDOCFISC AS COD_MOD,
									NVL(SE.CDSERIE,N.CDSERIE) AS SER,
                                    '' AS SUB,
                                    '01' AS COD_CONS,
                                    LTRIM(N.NRNOTAFISC, '0') AS NUM_DOC,
                                    TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy') AS DT_E_S,
                                    SUM(I.VRCONTABILNF) AS VL_DOC,
                                    '0,00' AS VL_DESC,
                                    SUM(I.VRCONTABILNF) AS VL_FORN,
                                    SUM(DECODE(CDFISCALNF, '2', VRCONTABILNF, 0)) AS VL_SERV_NT,
                                    '0,00' AS VL_TERC,
                                    '0,00' AS VL_DA,
                                    SUM(DECODE(CDFISCALNF, '1', VRBASECALCNF, 0)) AS VL_BC_ICMS,
                                    SUM((SELECT SUM(VRBASECALCNF)
                                           FROM IMPOSTONF IP
                                          WHERE IP.CDFILIAL   = I.CDFILIAL
                                            AND IP.NRLANCTONF = I.NRLANCTONF
                                            AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALNF, '1', VRIMPOSTONF, 0)) AS VL_ICMS,
                                    SUM(VRIMPCARGATRIBI) AS VRIMPCARGA,
                                    '0,00' AS VL_BC_ICMS_ST,
                                    '0,00' AS VL_ICMS_ST,
                                    '' AS COD_INF,
                                    '0,00' AS VL_PIS,
                                    '0,00' AS VL_COFINS,
                                    '1' AS TP_LIGACAO,
                                    '01' AS COD_GRUPO_TENSAO,
                                    N.IDSTATUS,T.IDREGESPECIAL, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIEMIT AS FILIAL
                               FROM NOTAFISCAL N, IMPOSTONF I, FILIAL F, IMPOSTO IM, SERIENF SE, TIPOOPERAC T
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                AND N.CDINSCESTA      = P_CDINSCESTA
                                AND IM.CDIMPOSTO      = P_CDIMPOSTO
                                AND IM.CDIMPOSTO      = IM.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SE.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SE.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SE.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP    = 'S'
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('06', '29','28')
                                AND N.CDFILIEMIT = F.CDFILIAL
                                AND IDORIGDESTNF = 'L'
								AND T.IDENTRSAIDOP    = N.IDENTRSAIDOP
								AND T.CDTIPOOPER      = N.CDTIPOOPER
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.IDORIGDESTNF||N.CDFILIEMIT, N.CDMODDOCFISC, NVL(SE.CDSERIE,N.CDSERIE),
                                    LTRIM(N.NRNOTAFISC, '0'), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'), TO_CHAR(N.DTENTRSAID,'ddmmyyyy'),
                                    N.IDSTATUS, T.IDREGESPECIAL,N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIEMIT)) LOOP

         /* CODIGO DO PARTICIPANTE */
         SELECT MAX(CDCHAVEREG)
           INTO V_COD_PAR
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_500.COD_PAR
            AND CDREGISTRO = '0150';

         IF (V_COD_PAR IS NULL) AND (C_500.COD_PAR IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
              (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
              ('0150', V_SEQUPROD, C_500.COD_PAR);
         END IF;

         V_COD_PAR := '';
         IF C_500.IDSTATUS = 'C' THEN
            /* documentos cancelados */
            V_DADOS_2 := '02|';
         ELSIF C_500.IDREGESPECIAL = 'S' THEN
			    V_DADOS_2 := '08|';
			   ELSE
            IF NOT C_500.DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL THEN
               /* documentos fora do periodo */
               V_DADOS_2 := '01|';
            ELSE
               V_DADOS_2 := '00|';
            END IF;
         END IF;

         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_500.PART_1||V_DADOS_2||C_500.PART_2, P_NRSEQARQMAG);
         V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

         FOR C_510 IN (SELECT COD_ITEM         || '|' ||
                              COD_CLASS        || '|' ||
                              QTD              || '|' ||
                              UNID             || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(VL_ITEM,2), '999999999990.00')), '.', ',')    || '|' ||
                              VL_DESC          || '|' ||
                              CST_ICMS         || '|' ||
                              CFOP             || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(VL_BC_ICMS + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VRBASECARGA,0))),2), '999999999990.00')), '.', ',') || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(ALIQ_ICMS,2), '999999999990.00')), '.', ',')  || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(VL_ICMS    + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(C_500.IDENTRSAIDOP,'S',NVL(VRIMPCARGA,0),DECODE(V_SGESTADO,'SP',0,NVL(VRIMPCARGA,0)))),2), '999999999990.00')), '.', ',')    || '|' ||
                              VL_BC_ICMS_ST    || '|' ||
                              ALIQ_ST          || '|' ||
                              VL_ICMS_ST       || '|' ||
                              IND_REC          || '|' ||
                              COD_PART         || '|' ||
                              VL_PIS           || '|' ||
                              VL_COFINS        || '|' ||
                              COD_CTA          || '|' AS REGC510,
                              CDPRODUTO, UNID, CDCLASFISC, COD_CTA
                         FROM (SELECT CDARVPROD AS COD_ITEM,
                                      '0601' AS COD_CLASS,
                                      QTITEMPROD AS QTD,
                                      SGUNIDADE AS UNID,
                                      VRUNITITEM AS VL_ITEM,
                                      '0,00' AS VL_DESC,
                                      CDSITUTRIBIT AS CST_ICMS,
                                      CDFISCOPERIT AS CFOP,
                                      DECODE(CDFISCALIT, '1', VRBASECALCIT, 0) AS VL_BC_ICMS,
                                      (SELECT SUM(IT.VRBASECALCIT)
                                         FROM ITEMPROIMPOS IP
                                        WHERE IP.CDFILIAL   = IT.CDFILIAL
                                          AND IP.NRLANCTONF = IT.NRLANCTONF
                                          AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB) AS VRBASECARGA,
                                      DECODE(CDFISCALIT, '1', VRALIQITEM+NVL(VRADICALIQFECP,0), 0) AS ALIQ_ICMS,
                                      DECODE(CDFISCALIT, '1', VRIMPOSTOIT+NVL(VRADICFECP,0), 0) AS VL_ICMS,
                                      (SELECT SUM(IT.VRIMPOSTOIT)
                                         FROM ITEMPROIMPOS IP
                                        WHERE IP.CDFILIAL   = IT.CDFILIAL
                                          AND IP.NRLANCTONF = IT.NRLANCTONF
                                          AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB) AS VRIMPCARGA,
                                      '0,00' AS VL_BC_ICMS_ST,
                                      '0,00' AS ALIQ_ST,
                                      '0,00' AS VL_ICMS_ST,
                                      '1' AS IND_REC,
                                      '' AS COD_PART,
                                      '0,00' AS VL_PIS,
                                      '0,00' AS VL_COFINS,
                                      CONTCTBL_SPED(C_500.IDENTRSAIDOP, I.CDPRODUTO, C_500.CDTIPOOPER, C_500.FILIAL) AS COD_CTA,
                                      P.CDPRODUTO,
                                      I.CDPRODNCMTRANS AS CDCLASFISC
                                 FROM ITEMPRODUTO I, ITEMPROIMPOS IT, PRODUTO P, IMPOSTO IM
                                WHERE I.CDFILIAL = C_500.CDFILIAL
                                  AND I.NRLANCTONF = C_500.NRLANCTONF
                                  AND I.CDFILIAL = IT.CDFILIAL
                                  AND I.NRLANCTONF = IT.NRLANCTONF
                                  AND I.NRSEQITPROD = IT.NRSEQITPROD
                                  AND SUBSTR(IT.CDFISCOPERIT,1,1) IN ('5','6','7')
                                  AND P.CDPRODUTO = I.CDPRODUTO
                                  AND IM.CDIMPOSTO = IT.CDIMPOSTO)) LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C510|'||V_SEQUENCIAL||'|'||C_510.REGC510, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER(RTRIM(V_SEQUENCIAL))+1)), 3,'0');

            /* CODIGO DO PRODUTO */
            SELECT MAX(CDCHAVEREG)
              INTO V_PRODUTO
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_510.CDPRODUTO
               AND CDREGISTRO = '0200';

            IF V_PRODUTO IS NULL AND (C_510.CDPRODUTO IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
               VALUES
                 ('0200', V_SEQUPROD, C_510.CDPRODUTO, C_510.CDCLASFISC);
            END IF;
            V_PRODUTO := '';

            /* UNIDADE DE MEDIDA */
            SELECT MAX(CDCHAVEREG)
              INTO V_UNID
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_510.UNID
               AND CDREGISTRO = '0190';
            IF (V_UNID IS NULL) AND (C_510.UNID IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                 ('0190', V_SEQUPROD, C_510.UNID);
            END IF;
            V_UNID := '';

            SELECT MAX(CDCHAVEREG)
              INTO V_CONTCTBL
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_510.COD_CTA
               AND CDREGISTRO = '0500';

            IF (V_CONTCTBL IS NULL) AND (C_510.COD_CTA IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                  ('0500', V_SEQUPROD, C_510.COD_CTA);
            END IF;
            V_CONTCTBL := '';
         END LOOP;
         FOR C_590 IN (SELECT ('|C590'     || '|' ||
                              T.CST_ICMS   || '|' ||
                              T.CFOP       || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(T.ALIQ_ICMS,2), '999999999990.00')), '.', ',')      || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_OPR,2), '999999999990.00')), '.', ',')      || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_BC_ICMS + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VRBASECARGA,0))),2), '999999999990.00')), '.', ',')      || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_ICMS    + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(C_500.IDENTRSAIDOP,'E',DECODE(V_SGESTADO,'SP',0,NVL(VRIMPCARGA,0)),NVL(VRIMPCARGA,0))),2), '999999999990.00')), '.', ',')      || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(0,2), '999999999990.00')), '.', ',')      || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(0,2), '999999999990.00')), '.', ',')      || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_RED_BC,2), '999999999990.00')), '.', ',')      || '|' ||
                              '' || '|') ARQ_C590
                         FROM (SELECT CDSITUTRIBIT AS CST_ICMS,
                                      CDFISCOPERIT AS CFOP,
                                      DECODE(CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0) AS ALIQ_ICMS,
                                      SUM(VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                      SUM(DECODE(CDFISCALIT, '1', VRBASECALCIT, 0)) AS VL_BC_ICMS,
                                      SUM((SELECT SUM(IP.VRBASECALCIT)
                                             FROM ITEMPROIMPOS IP
                                            WHERE IP.CDFILIAL     = I.CDFILIAL
                                              AND IP.NRLANCTONF   = I.NRLANCTONF
                                              AND IP.CDSITUTRIBIT = I.CDSITUTRIBIT
                                              AND IP.CDFISCOPERIT = I.CDFISCOPERIT
                                              AND IP.CDIMPOSTO    = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                      SUM(DECODE(CDFISCALIT, '1', VRIMPOSTOIT+NVL(VRADICFECP,0), 0)) AS VL_ICMS,
                                      SUM((SELECT SUM(IP.VRIMPOSTOIT)
                                             FROM ITEMPROIMPOS IP
                                            WHERE IP.CDFILIAL     = I.CDFILIAL
                                              AND IP.NRLANCTONF   = I.NRLANCTONF
                                              AND IP.CDSITUTRIBIT = I.CDSITUTRIBIT
                                              AND IP.CDFISCOPERIT = I.CDFISCOPERIT
                                              AND IP.CDIMPOSTO    = IM.CDIMPCARGATRIB)) AS VRIMPCARGA,
                                      0 AS VL_BC_ICMS_ST,
                                      0 AS VL_ICMS_ST,
                                      NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL) ),0) AS VL_RED_BC,
                                      0 AS VL_IPI,
                                      '' AS COD_OBS
                                 FROM ITEMPROIMPOS I, IMPOSTO IM
                                WHERE I.CDFILIAL      = C_500.CDFILIAL
                                  AND I.NRLANCTONF    = C_500.NRLANCTONF
                                  AND I.NRITPROIMPOS    = '1'
                                  AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                GROUP BY CDSITUTRIBIT, I.CDFISCOPERIT, DECODE(I.CDFISCALIT, '1', I.VRALIQITEM+NVL(I.VRADICALIQFECP,0), 0) ) T ) LOOP

            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_590.ARQ_C590, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;

         END LOOP;
      END LOOP;
   END IF;

   /* REGISTRO REFERENTE AO CF-E SAT */
   FOR C_800 IN (SELECT (REG         || '|' ||
                         COD_MOD     || '|' ||
                         COD_SIT     || '|' ||
                         NUM_CFE     || '|' ||
                         DT_DOC      || '|' ||
                         VL_CFE      || '|' ||
                         VL_PIS      || '|' ||
                         VL_COFINS   || '|' ||
                         CNPJ_CPF    || '|' ||
                         NR_SAT      || '|' ||
                         CHV_CFE     || '|' ||
                         VL_DESC     || '|' ||
                         VL_MERC     || '|' ||
                         VL_OUT_DA   || '|' ||
                         VL_ICMS     || '|' ||
                         VL_PIS_ST   || '|' ||
                         VL_COFINS_ST|| '|') AS ARQ_C800, DTEMISSAO, CDFILIAL, CDCAIXA, NRSEQVENDA
                   FROM (SELECT '|C800' AS REG, '59' AS COD_MOD, DECODE(VE.IDSTATUSNFCE,'C','02','A','00') AS COD_SIT,
                                LPAD(NVL(VE.NRNOTAFISCALCE,0),6,'0') AS NUM_CFE,
                                DECODE(VE.IDSTATUSNFCE,'C','',TO_CHAR(VE.DTEMISSAONFCE,'DDMMYYYY')) AS DT_DOC,
                                DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0),2)),'999999999990.00')),'.',',')) AS VL_CFE,
                                '' AS VL_PIS, '' AS VL_COFINS,/*Contribuinte que apresenta EFD Contribuies no precisa informar valores de PIS e COFINS*/
                                DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(REPLACE(REPLACE(REPLACE(VE.NRINSCRCONS,'.'),'-'),'/'),' ')) AS CNPJ_CPF,
                                VE.CDSERIESAT AS NR_SAT, SUBSTR(VE.NRACESSONFCE,4,44) AS CHV_CFE,
                                DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(NVL(IT.VRDESITVEND,0),2)),'999999999990.00')),'.',',')) AS VL_DESC,
                                DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2)),'999999999990.00')),'.',',')) AS VL_MERC,
                                DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(NVL(IT.VRACRITVEND,0),2)),'999999999990.00')),'.',',')) AS VL_OUT_DA,
                                DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(LTRIM(TO_CHAR(SUM(ROUND(II.VRIMPOPRODIT, 2)),'999999999990.00')),'.',',')) AS VL_ICMS, 
                                DECODE(VE.IDSTATUSNFCE,'C','',0) AS VL_PIS_ST, DECODE(VE.IDSTATUSNFCE,'C','',0) AS VL_COFINS_ST, TRUNC(VE.DTEMISSAONFCE) AS DTEMISSAO, VE.CDFILIAL, VE.CDCAIXA, VE.NRSEQVENDA 
                           FROM VENDA VE, FILIAL FI, ITEMVENDA IT, ITVENDAIMPOS II 
                          WHERE TRUNC(VE.DTEMISSAONFCE) BETWEEN P_DTINICIAL AND P_DTFINAL 
                            AND VE.IDTPEMISVEND    = 'S' 
                            AND VE.CDFILIAL        = FI.CDFILIAL 
                            AND FI.CDEMPRESA       = P_CDEMPRESA 
                            AND FI.CDINSCESTA      = P_CDINSCESTA 
                            AND VE.IDSITUVENDA     IN ('O','C') 
                            AND ((VE.IDAPROVACAONFCE = 'A' AND VE.IDSTATUSNFCE = 'A') OR (VE.IDSTATUSNFCE = 'C')) 
                            AND VE.IDTPAMBNFCE     = '1' 
                            AND P_PERFIL           = 'A' 
                            AND VE.CDFILIAL        = IT.CDFILIAL 
                            AND VE.CDCAIXA         = IT.CDCAIXA 
                            AND VE.NRSEQVENDA      = IT.NRSEQVENDA 
                            AND IT.CDFILIAL        = II.CDFILIAL 
                            AND IT.CDCAIXA         = II.CDCAIXA 
                            AND IT.NRSEQVENDA      = II.NRSEQVENDA 
                            AND IT.NRSEQUITVEND    = II.NRSEQUITVEND
                            AND ((V_CDSITUCRT IN ('2','3')) OR (V_CDSITUCRT = '1' AND V_SGESTADO <> 'CE'))
                         GROUP BY VE.IDSTATUSNFCE, LPAD(NVL(VE.NRNOTAFISCALCE,0),6,'0'),
                                  DECODE(VE.IDSTATUSNFCE,'C','',TO_CHAR(VE.DTEMISSAONFCE,'DDMMYYYY')), 
                                  DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(REPLACE(REPLACE(REPLACE(VE.NRINSCRCONS,'.'),'-'),'/'),' ')), 
                                  VE.CDSERIESAT, SUBSTR(VE.NRACESSONFCE,4,44), 
                                  TRUNC(VE.DTEMISSAONFCE), VE.CDFILIAL, VE.CDCAIXA, VE.NRSEQVENDA 
                         ORDER BY NUM_CFE)) LOOP 
 
      INSERT INTO ARQMAGNETICO 
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
      VALUES 
         ('28'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_800.ARQ_C800, P_NRSEQARQMAG); 
      V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
 
      FOR C_850 IN (SELECT (REG          || '|' || 
                            CST_ICMS     || '|' || 
                            CFOP         || '|' || 
                            ALIQ_ICMS    || '|' || 
                            VL_OPR       || '|' || 
                            VL_BC_ICMS   || '|' ||
                            VL_ICMS      || '|' || 
                            COD_OBS      || '|' ) ARQ_C850 
                      FROM (SELECT '|C850' AS REG, LPAD(II.CDCSTPRODI,3,'0') AS CST_ICMS, II.CDCFOPPROD AS CFOP, 
                                   REPLACE(LTRIM(TO_CHAR(II.VRPEALPRODIT,'999990.00')),'.',',') AS ALIQ_ICMS,
                                   REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0),2)),'999999999990.00')),'.',',') AS VL_OPR, 
                                   REPLACE(LTRIM(TO_CHAR(SUM(DECODE(II.VRPEALPRODIT,0,0,TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0),2))),   '999999999990.00')),'.',',') AS VL_BC_ICMS, 
                                   REPLACE(LTRIM(TO_CHAR(SUM(ROUND(II.VRIMPOPRODIT, 2)),'999999999990.00')),'.',',') AS VL_ICMS, 
                                   '' AS COD_OBS 
                              FROM VENDA VE, ITEMVENDA IT, ITVENDAIMPOS II 
                             WHERE VE.IDAPROVACAONFCE      = 'A' 
                               AND TRUNC(VE.DTEMISSAONFCE) = C_800.DTEMISSAO 
                               AND VE.CDCAIXA              = C_800.CDCAIXA 
                               AND VE.CDFILIAL             = C_800.CDFILIAL 
                               AND VE.NRSEQVENDA           = C_800.NRSEQVENDA 
                               AND VE.IDTPEMISVEND         = 'S' 
                               AND VE.IDSITUVENDA          = 'O' 
                               AND VE.IDSTATUSNFCE         = 'A' 
                               AND VE.IDTPAMBNFCE          = '1' 
                               AND VE.CDFILIAL             = IT.CDFILIAL 
                               AND VE.CDCAIXA              = IT.CDCAIXA 
                               AND VE.NRSEQVENDA           = IT.NRSEQVENDA 
                               AND IT.CDFILIAL             = II.CDFILIAL 
                               AND IT.CDCAIXA              = II.CDCAIXA 
                               AND IT.NRSEQVENDA           = II.NRSEQVENDA 
                               AND IT.NRSEQUITVEND         = II.NRSEQUITVEND 
                            GROUP BY LPAD(II.CDCSTPRODI,3,'0'), II.CDCFOPPROD, II.VRPEALPRODIT)) LOOP 
 
         INSERT INTO ARQMAGNETICO 
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
         VALUES 
            ('28'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_850.ARQ_C850, P_NRSEQARQMAG); 
         V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
      END LOOP; 
   END LOOP; 
 
   FOR C_860 IN (SELECT (REG     || '|' || 
                         COD_MOD || '|' || 
                         NR_SAT  || '|' || 
                         DT_DOC  || '|' || 
                         DOC_INI || '|' || 
                         DOC_FIM || '|' ) ARQ_C860, NR_SAT, DTEMISSAO 
                   FROM (SELECT '|C860' AS REG, '59' AS COD_MOD, VE.CDSERIESAT AS NR_SAT, TO_CHAR(TRUNC(VE.DTEMISSAONFCE),'DDMMYYYY') AS DT_DOC, 
                                MIN(LPAD(NVL(VE.NRNOTAFISCALCE,0),6,'0')) DOC_INI, MAX(LPAD(NVL(VE.NRNOTAFISCALCE,0),6,'0')) DOC_FIM, 
                                TRUNC(VE.DTEMISSAONFCE) AS DTEMISSAO 
                           FROM VENDA VE, FILIAL FI 
                          WHERE TRUNC(VE.DTEMISSAONFCE) BETWEEN P_DTINICIAL AND P_DTFINAL 
                            AND VE.IDTPEMISVEND    = 'S' 
                            AND VE.CDFILIAL        = FI.CDFILIAL 
                            AND FI.CDEMPRESA       = P_CDEMPRESA 
                            AND FI.CDINSCESTA      = P_CDINSCESTA 
                            AND P_PERFIL           = 'B' 
                            AND VE.IDSITUVENDA     IN ('O','C') 
                            AND ((VE.IDAPROVACAONFCE = 'A' AND VE.IDSTATUSNFCE = 'A') OR (VE.IDSTATUSNFCE = 'C')) 
                            AND VE.IDTPAMBNFCE     = '1'
                            AND ((V_CDSITUCRT IN ('2','3')) OR (V_CDSITUCRT = '1' AND V_SGESTADO <> 'CE'))
                          GROUP BY VE.CDSERIESAT, TRUNC(VE.DTEMISSAONFCE))) LOOP
 
      INSERT INTO ARQMAGNETICO 
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
      VALUES 
         ('28'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_860.ARQ_C860, P_NRSEQARQMAG); 
      V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
 
      FOR C_890 IN (SELECT (REG          || '|' || 
                            CST_ICMS     || '|' || 
                            CFOP         || '|' || 
                            ALIQ_ICMS    || '|' || 
                            VL_OPR       || '|' ||
                            VL_BC_ICMS   || '|' ||
                            VL_ICMS      || '|' || 
                            COD_OBS      || '|' ) ARQ_C890 
                      FROM (SELECT '|C890' AS REG, LPAD(II.CDCSTPRODI,3,'0') AS CST_ICMS, II.CDCFOPPROD AS CFOP, 
                                   REPLACE(LTRIM(TO_CHAR(II.VRPEALPRODIT,'999990.00')),'.',',') AS ALIQ_ICMS,
                                   REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0),2)),'999999999990.00')),'.',',') AS VL_OPR, 
                                   REPLACE(LTRIM(TO_CHAR(SUM(DECODE(II.VRPEALPRODIT,0,0,TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0),2))),   '999999999990.00')),'.',',') AS VL_BC_ICMS, 
                                   REPLACE(LTRIM(TO_CHAR(SUM(ROUND(II.VRIMPOPRODIT,2)),'999999999990.00')),'.',',') AS VL_ICMS,
                                   '' AS COD_OBS 
                              FROM VENDA VE, FILIAL FI, ITEMVENDA IT, ITVENDAIMPOS II 
                             WHERE VE.IDAPROVACAONFCE      = 'A' 
                               AND VE.CDFILIAL             = FI.CDFILIAL 
                               AND FI.CDEMPRESA            = P_CDEMPRESA 
                               AND FI.CDINSCESTA           = P_CDINSCESTA 
                               AND TRUNC(VE.DTEMISSAONFCE) = C_860.DTEMISSAO 
                               AND VE.CDSERIESAT           = C_860.NR_SAT 
                               AND VE.IDTPEMISVEND         = 'S' 
                               AND VE.IDSITUVENDA          = 'O' 
                               AND VE.IDSTATUSNFCE         = 'A' 
                               AND VE.IDTPAMBNFCE          = '1' 
                               AND VE.CDFILIAL             = IT.CDFILIAL 
                               AND VE.CDCAIXA              = IT.CDCAIXA 
                               AND VE.NRSEQVENDA           = IT.NRSEQVENDA 
                               AND IT.CDFILIAL             = II.CDFILIAL 
                               AND IT.CDCAIXA              = II.CDCAIXA 
                               AND IT.NRSEQVENDA           = II.NRSEQVENDA 
                               AND IT.NRSEQUITVEND         = II.NRSEQUITVEND 
                            GROUP BY II.CDCSTPRODI, II.CDCFOPPROD, II.VRPEALPRODIT)) LOOP 
 
         INSERT INTO ARQMAGNETICO 
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
         VALUES 
            ('28'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_890.ARQ_C890, P_NRSEQARQMAG); 
         V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
 
      END LOOP; 
   END LOOP; 
 
   IF V_CONTREGC <> 0 THEN 
      V_MOVIMENT := 0; 
   ELSE 
      V_MOVIMENT := 1; 
   END IF; 
   /* ABERTURA DO REGISTRO C */
   V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
   INSERT INTO ARQMAGNETICO 
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
   VALUES 
     ('18'||LPAD('0', 8, '0'), '|C001'|| '|' ||V_MOVIMENT|| '|', P_NRSEQARQMAG);
   /* ENCERRAMENTO DO BLOCO C */
   V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
   INSERT INTO ARQMAGNETICO 
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
   VALUES 
     ('40'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C990'|| '|' ||V_CONTREGC|| '|', P_NRSEQARQMAG); 
   RETURN(LPAD(TO_CHAR(NVL(V_CONTREGC,0)),10, '0')||LPAD(TO_CHAR(NVL(V_TOTFORPER_S,0)),10,'0')||LPAD(TO_CHAR(NVL(V_VRFORAPER_E,0)),10,'0')||LPAD(TO_CHAR(NVL(V_SEQUPROD,0)), 10, '0')||LPAD(TO_CHAR(NVL(V_VRDEBESP,0)), 10, '0'));
END;